#include<iostream>
#include<vector>
using namespace std;
const long long int mod = 1e9+7;
const long long int base = 2e5;
const int MAXN = 2005;
const int MAXQ = 1e5+7;
int n,m;
int br;
vector<int> a[MAXN];
vector<int> a_rev[MAXN];
vector<int> out_order;
int comp[MAXN];
long long pr[MAXQ];
long long ans;
bool used[MAXN];
void dfs(int x){
    used[x]=1;
    for(auto to:a[x]){
        if(!used[to]) dfs(to);
    }
    out_order.push_back(x);
}
void dfs2(int x){
    used[x]=1;
    comp[x]=br;
    for(auto to:a_rev[x]){
        if(!used[to]) dfs2(to);
    }
}
void reset(){
    for(int i=0;i<n;i++) used[i]=0;
    long long curr=1;
    for(int i=0;i<MAXQ;i++){
        pr[i]=curr;
        curr*=base;
        curr%=mod;
    }
}
int main(){
    cin>>n>>m;
    int from,to;
    for(int i=0;i<m;i++){
        cin>>from>>to;
        from--; to--;
        a[from].push_back(to);
        a_rev[to].push_back(from);
    }
    dfs(0);
    reset();
    for(int i=n-1;i>=0;i--){
        int curr=out_order[i];
        if(!used[curr]){
            dfs2(curr);
            br++;
        }
    }
    int q;
    cin>>q;
    int a,b;
    if(q!=0){
        while(q--){
            cin>>a>>b;
            a--; b--;
            if(comp[a]==comp[b]) ans+=(m+1)*pr[q];
            ans%=mod;
        }
    }else{
        q=n*(n+1)/2;
        for(int i=0;i<n;i++){
            for(int j=0;j<n;j++){
                if(comp[i]==comp[j]) ans+=(m+1)*pr[q];
                q--;
                ans%=mod;
            }
        }
    }
    cout<<ans<<"\n";
    return 0;
}
