#include<iostream>
#include<vector>
#include<stack>
using namespace std;
const long long int mod = 1e9+7;
const long long int base = 2e5;
const long long MAXN = 2005;
const long long MAXQ = 1e5+7;
long long n,m;
long long br;
vector<int> a[MAXN];
vector<int> a_rev[MAXN];
vector<int> out_order;
stack<pair<int,int>> queries;
long long comp[MAXN];
long long ans;
bool used[MAXN];
void dfs(long long x){
    used[x]=1;
    for(auto to:a[x]){
        if(!used[to]) dfs(to);
    }
    out_order.push_back(x);
}
void dfs2(long long x){
    used[x]=1;
    comp[x]=br;
    for(auto to:a_rev[x]){
        if(!used[to]) dfs2(to);
    }
}
void reset(){
    for(long long i=0;i<n;i++) used[i]=0;
}
int main(){
    cin>>n>>m;
    long long from,to;
    for(long long i=0;i<m;i++){
        cin>>from>>to;
        from--; to--;
        a[from].push_back(to);
        a_rev[to].push_back(from);
    }
    dfs(0);
    reset();
    for(long long i=n-1;i>=0;i--){
        long long curr=out_order[i];
        if(!used[curr]){
            dfs2(curr);
            br++;
        }
    }
    long long q;
    cin>>q;
    long long a,b;
    for(long long i=0;i<q;i++){
        cin>>a>>b;
        a--; b--;
        queries.push({a,b});
    }
    long long pr=1;
    while(!queries.empty()){
        auto [a,b]=queries.top();
        queries.pop();
        if(comp[a]==comp[b]) ans+=pr*(m+1);
        pr*=base;
        pr%=mod;
        ans%=mod;
    }
    if(q==0){
        for(long long i=n-1;i>=0;i--){
            for(long long j=n-1;j>=i;j--){
                if(comp[i]==comp[j]) ans+=pr*(m+1);
                pr*=base;
                pr%=mod;
                ans%=mod;
            }
        }
    }
    cout<<ans<<"\n";
    return 0;
}
