#include <bits/stdc++.h>
#define endl '\n'


using namespace std;

const int MAXN = 2005;
const int MAXM = 5e5 + 50;

int used[MAXN];
pair <int, int> edges[MAXN];
vector <int> Graph[MAXN];

void dfs(int curr, int dest, int trial, bool &res, int eraseX, int eraseY, bool erased)
{

    used[curr] = trial+1;
    if (curr == dest)
    {
        res = true;
        return;
    }

    for (int i:Graph[curr])
    {
        if (res == true)
            return;
        if (used[i] <= trial)
        {
            if (!erased && eraseX == curr && eraseY == i)
                erased = true;
            else
                dfs(i, dest, trial, res, eraseX, eraseY, erased);
        }
    }






}

const int64_t B = 200000, MOD = int64_t(1e9) + int64_t(7);
void UpdateAnswer(int64_t &ans, int64_t s)
{
    ans = ans*B + s;
    ans %= MOD;
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, m;
    cin >> n >> m;

    for (int i = 1; i <= m; i++)
    {
        int u, v;
        cin >> u >> v;
        Graph[u].push_back(v);
        edges[i] = make_pair(u, v);
    }

    int64_t ans = 0;
    int q, trial = 0;
    cin >> q;

    /*if (q == 0)
    {
        for (int i = 1; i <= n; i++)
        {
            for (int j = i; j <= n; j++)
            {
                bool res1 = false;
                bool res2 = false;

                dfs(i, j, trial, res1);
                trial++;
                dfs(j, i, trial, res2);
                trial++;

                if (res1 && res2)
                    UpdateAnswer(ans, int64_t(m+1));
                else
                    UpdateAnswer(ans, int64_t(0));
            }
        }
        cout << ans << endl;
        return 0;
    }*/

    for (int i = 0; i < q; i++)
    {
        int u, v;
        cin >> u >> v;

        bool res1 = false;
        bool res2 = false;

        dfs(u, v, trial, res1, 0, 0, false);
        trial++;
        dfs(v, u, trial, res2, 0, 0, false);
        trial++;
        if (res1 == false || res2 == false)
        {
            UpdateAnswer(ans, int64_t(0));
        }

        bool flag = false;
        res1 = false;
        res2 = false;

        for (int j = 1; j <= m; j++)
        {
            res1 = res2 = false;
            dfs(u, v, trial, res1, edges[j].first, edges[j].second, false);
            trial++;
            dfs(v, u, trial, res2, edges[j].first, edges[j].second, false);
            trial++;

            if (res1 == false || res2 == false)
            {
                flag = true;
                UpdateAnswer(ans, int64_t(j));

                break;
            }
        }

        if (!flag)
        {
            UpdateAnswer(ans, int64_t(m+1));
        }

    }
    cout << ans << endl;

    return 0;
}
