#include <bits/stdc++.h>
#define endl '\n'
using namespace std;
const long long MAXN = 2e4+10, MAXM = 1e3+10;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
long long n, m;
struct bus
{
    long long y, c;
    bus() {};
    bus(long long _y, long long _c)
    {
        y = _y;
        c = _c;
    }
};
struct person
{
    long long x, v;
    person() {};
    person(long long _x, long long _v)
    {
        x = _x;
        v = _v;
    }
};
bus b[MAXN];
person p[MAXN];

void read()
{
    cin >> n;

    for (long long i = 1; i <= n; ++ i)
    {
        cin >> b[i].y >> b[i].c;
    }
    cin >> m;
    for (long long i = 1; i <= m; ++ i)
    {
        cin >> p[i].x >> p[i].v;
    }
}

long long dp[MAXM][MAXN], inf = 1e18 * 2;
long long walk, ans;
void solve()
{
    for (int i = 0; i <= m; ++ i)
    {
        for (int j = 0; j <= n; ++ j)
            dp[i][j] = 2e18;
    }
    dp[1][0] = 2e18;
    for (int j = 1; j <= n; ++ j)
    {
        if(b[j].y <= p[1].x)
        {
            dp[1][j] = b[j].c + (p[1].x - b[j].y) * p[1].v;
        }
        else dp[1][j] = 2*1e18;
    }
    for (int i = 2; i <= m; ++ i)
    {
        for (int j = 1; j <= n; ++ j)
        {
            if(b[j].y <= p[i].x)
            {
                walk = (p[i].x - b[j].y) * p[i].v;
                dp[i][j] = dp[i-1][j] + walk;
                for (int k = 1; k < j; ++ k)
                    dp[i][j] = min(dp[i][j], dp[i-1][k] + b[j].c + walk);
            }
            else dp[i][j] = 2*1e18;
        }
    }
    /*for (int i = 1; i <= m; ++ i)
    {
        for (int j = 1; j <= n; ++ j)
            cout << dp[i][j] << " ";
        cout << endl;
    }*/
    for (int i = 1; i <= m; ++ i)
    {
        ans = 2e18;
        for (int j = 1; j <= n; ++ j)
            ans = min(ans, dp[i][j]);
        cout << ans << " ";
    }
    cout << endl;
}
int main()
{
    speed();

    read();
    solve();

    return 0;
}
