#include<iostream>
#include<vector>
using namespace std;
const int MAXN = 207;
const long long mod = 1e9+7;
vector<pair<int,int>> susedi[MAXN];
int koren;
int zabraneno = 0;
int connected[MAXN][MAXN];
bool visited[MAXN];
void dfs(int vr){
    visited[vr]=true;
    for(auto p:susedi[vr]){
        if(p.second!=zabraneno and !visited[p.first]){
            dfs(p.first);
        }
    }
}
long long b = 2*1e5;
long long povdigane[MAXN*MAXN];
long long stepen(long long a){
    //cout<<"stepen "<<a<<"\n";
    if(a==0) return 1;
    if(a==1) return b;
    if(povdigane[a]>0) return povdigane[a];
    long long x;
    if(a%2==1){
        x=b;
    }else{
        x=1;
    }
    return povdigane[a]= (((stepen(a/2)*stepen(a/2))%mod)*x)%mod;
}
int main (){
    int n,m;
    cin>>n>>m;
    int a,b;
    for(int i=1;i<=m;i++){
        cin>>a>>b;
        susedi[a].push_back({b,i});
    }
    for(int i=1;i<=n;i++){
        for(int j=1;j<=n;j++){
            connected[i][j]=-1;
        }
    }
    for(int i=1;i<=n;i++){
        koren = i;
        dfs(i);
        //cout<<"zele "<<i;
        for(int j=1;j<=n;j++){
            if(!visited[j]){
                connected[i][j]=0;
            }
            visited[j]=false;
        }
    }
    for(int i=1;i<=m;i++){
        zabraneno=i;
        for(int j=1;j<=n;j++){
            dfs(j);
            for(int o=1;o<=n;o++){
                if(!visited[o]){
                    if(connected[j][o]==-1){
                        connected[j][o]=i;
                    }
                }
                visited[o]=false;
            }
        }
    }
    int q;
    cin>>q;
    long long ans = 0;
    long long k = (n);
    k= q;
    for(int i=1;i<=q;i++){
        cin>>a>>b;
            if(connected[a][b]==-1){
                connected[a][b]=m+1;
            }
            k--;
            //cout<<"zele\n";
            ans+=connected[a][b]*stepen(k);
            ans%=mod;
    }
    cout<<ans%mod<<"\n";
    return 0;
}
