#include <bits/stdc++.h>

using namespace std;

struct Point
{
    int x,y;
    Point(){};
    Point(int xi, int yi)
    {
        x = xi;
        y = yi;
    }
};

const long long mod = 1e9+7;
const int maxn = 256;
int n,m,q,ch1,ch2,k;
Point reb[1024];
int mat[maxn][maxn];
int used[maxn];
long long ans,b,step[512];
bool f1,f2;

void pre()
{
    b = 2*1e5;
    step[0] = 1;
    for(int i=1;i<=500;i++)
    {
        step[i] = step[i-1]*b;
        step[i] %= mod;
    }
}

void dfs1(int beg)
{
    used[beg] = 1;
    if(beg==ch2) f1 = true;
    for(int i=1;i<=n;i++)
    {
        if(f1) return;
        if(!used[i]&&mat[beg][i]) dfs1(i);
    }
}

void dfs2(int beg)
{
    used[beg] = 1;
    if(beg==ch1) f2 = true;
    for(int i=1;i<=n;i++)
    {
        if(f2) return;
        if(!used[i]&&mat[beg][i]) dfs2(i);
    }
}

void solve()
{
    int idx = -1;
    int br = 0;
    f1 = f2 = false;
    memset(used,0,sizeof(used));
    dfs1(ch1);
    if(used[ch2]) f1 = true;
    memset(used,0,sizeof(used));
    dfs2(ch2);
    if(used[ch1]) f2 = true;
    if(f1&&f2) br++;
    for(int i=1;i<=m;i++)
    {
        mat[reb[i].x][reb[i].y]--;
        f1 = f2 = false;
        memset(used,0,sizeof(used));
        dfs1(ch1);
        memset(used,0,sizeof(used));
        dfs2(ch2);
        if(used[ch1]) f2 = true;
        if(f1&&f2) br++;
        else
        {
            if(idx==-1) idx = i;
        }
        mat[reb[i].x][reb[i].y]++;
    }
    long long s;
    s = br;
    if(s!=0&&s!=m+1) s = idx;
    k--;
    s *= step[k];
    s %= mod;
    ans += s;
    ans %= mod;
}

void read()
{
    pre();
    ans = 0;
    cin >> n >> m;
    for(int i=1;i<=m;i++)
    {
        cin >> reb[i].x >> reb[i].y;
        mat[reb[i].x][reb[i].y]++;
    }
    cin >> q;
    k = q;
    for(int i=1;i<=q;i++)
    {
        cin >> ch1 >> ch2;
        solve();
    }
    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    return 0;
}
