#include <bits/stdc++.h>

using namespace std;

const long long mod = 1e9+7;
const int maxn = 256;
int n,m,q,ch1,ch2;
int x[1024],y[1024];
int mat[maxn][maxn],used[maxn];
long long ans,b;
bool f1,f2;

void dfs1(int beg)
{
    used[beg] = 1;
    if(beg==ch2) f1 = true;
    for(int i=1;i<=n;i++)
    {
        if(f1) return;
        if(!used[i]&&mat[beg][i]) dfs1(i);
    }
}

void dfs2(int beg)
{
    used[beg] = 1;
    if(beg==ch1) f2 = true;
    for(int i=1;i<=n;i++)
    {
        if(f2) return;
        if(!used[i]&&mat[beg][i]) dfs2(i);
    }
}

void solve()
{
    long long s;
    int idx = -1;
    int br = 0;
    f1 = f2 = false;
    memset(used,0,sizeof(used));
    dfs1(ch1);
    memset(used,0,sizeof(used));
    dfs2(ch2);
    if(f1&&f2) br++;
    if(br==0)
    {
        ans *= b;
        ans %= mod;
        return;
    }
    for(int i=1;i<=m;i++)
    {
        if(mat[x[i]][y[i]]>1)
        {
            br++;
            continue;
        }
        mat[x[i]][y[i]] = 0;
        f1 = f2 = false;
        memset(used,0,sizeof(used));
        dfs1(ch1);
        memset(used,0,sizeof(used));
        dfs2(ch2);
        mat[x[i]][y[i]] = 1;
        if(f1&&f2) br++;
        else
        {
            if(idx==-1) idx = i;
            break;
        }
    }
    s = br;
    if(s!=m+1) s = idx;
    ans *= b;
    ans %= mod;
    ans += s;
    ans %= mod;
}

void read()
{
    b = 2*1e5;
    cin >> n >> m;
    for(int i=1;i<=m;i++)
    {
        cin >> x[i] >> y[i];
        mat[x[i]][y[i]]++;
    }
    cin >> q;
    for(int i=1;i<=q;i++)
    {
        cin >> ch1 >> ch2;
        solve();
    }
    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    return 0;
}
