#include <bits/stdc++.h>

using namespace std;

const long long mod = 1e9+7;
const int maxn = 2001;
const int maxm = 1e5+1;
int n,m,q,ch1,ch2;
int x[maxm],y[maxm];
int mat[maxn][maxn];
bool used[maxn];
long long ans,b;
bool f1,f2;
vector<int>v[maxn];

void dfs1(int beg)
{
    used[beg] = 1;
    if(beg==ch2) f1 = true;
    int nb,sz = v[beg].size();
    for(int i=0;i<sz;i++)
    {
        if(f1) return;
        nb = v[beg][i];
        if(!used[nb]&&mat[beg][nb]) dfs1(nb);
    }
}

void dfs2(int beg)
{
    used[beg] = 1;
    if(beg==ch1) f2 = true;
    int nb,sz = v[beg].size();
    for(int i=0;i<sz;i++)
    {
        if(f2) return;
        nb = v[beg][i];
        if(!used[nb]&&mat[beg][nb]) dfs2(nb);
    }
}

void solve()
{
    int idx = -1;
    int br = 0;
    f1 = f2 = false;
    memset(used,0,sizeof(used));
    dfs1(ch1);
    memset(used,0,sizeof(used));
    dfs2(ch2);
    if(f1&&f2) br++;
    if(br==0)
    {
        ans *= b;
        ans %= mod;
        return;
    }
    for(int i=1;i<=m;i++)
    {
        if(mat[x[i]][y[i]]>1)
        {
            br++;
            continue;
        }
        mat[x[i]][y[i]] = 0;
        f1 = f2 = false;
        memset(used,0,sizeof(used));
        dfs1(ch1);
        memset(used,0,sizeof(used));
        dfs2(ch2);
        mat[x[i]][y[i]] = 1;
        if(f1&&f2) br++;
        else
        {
            if(idx==-1) idx = i;
            break;
        }
    }
    if(br==m+1) idx = m+1;
    ans *= b;
    ans %= mod;
    ans += idx;
    ans %= mod;
}

void read()
{
    b = 2*1e5;
    cin >> n >> m;
    for(int i=1;i<=m;i++)
    {
        cin >> x[i] >> y[i];
        mat[x[i]][y[i]]++;
        if(mat[x[i]][y[i]]==1) v[x[i]].push_back(y[i]);
    }
    cin >> q;
    if(q)
    {
        for(int i=1;i<=q;i++)
        {
            cin >> ch1 >> ch2;
            solve();
        }
    }
    else
    {
        for(int i=1;i<=n;i++)
        {
            for(int j=i;j<=n;j++)
            {
                ch1 = i;
                ch2 = j;
                solve();
            }
        }
    }
    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    return 0;
}
