#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <set>
#include <queue>
#include <map>
#include <iomanip>
using namespace std;

#define ll long long
#define vi vector<int>
#define vll vector<ll>
#define pii pair<int, int>
#define mpr make_pair
#define yes cout<<"YES\n"
#define no cout<<"NO\n"

const int N = 20005, M = 1005;
ll dp[N][M], mn[N];
const ll ool = 2000000000000000001;
int n, m;

void solve() {
	vll y, c, x, v, u;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		ll y0, c0;
		cin >> y0 >> c0;
		y.push_back(y0);
		c.push_back(c0);
	}
	cin >> m;
	for (int i = 0; i < m; ++i) {
		ll x0, v0;
		cin >> x0 >> v0;
		x.push_back(x0);
		v.push_back(v0);
	}
	for (int i = 0; i < n; ++i) {
		int ind = lower_bound(x.begin(), x.end(), y[i]) - x.begin();
		if (ind == x.size()) {
			u.push_back(ool);
		}
		else {
			u.push_back(ind);
		}
	}
	for (int i = 0; i < m; ++i) {
		mn[i] = ool;
		for (int j = n - 1; j >= 0; --j) {
			int ind = u[j];
			//cout << i << ' ' << j << ' ' << ind << "\n";
			if (ind > i) {
				dp[i][j] = ool;
				continue;
			}
			if (i == 0) {
				dp[i][j] = c[j] + v[i] * (x[i] - y[j]);
			}
			else {
				if (ind == i) {
					dp[i][j] = c[j] + v[i] * (x[i] - y[j]) + mn[i - 1];
				}
				else {
					//yes;
					dp[i][j] = (x[i] - y[j]) * v[i] + dp[i - 1][j];
				}
			}
			/*dp[i][j] = c[j];
			for (int k = ind; k <= i; ++k) {
				dp[i][j] += v[k] * (x[ind] - y[j]);
			}
			if (ind != 0) {
				dp[i][j] += mn[ind - 1];
			}*/
			//cout << dp[i][j] << "\n";
			mn[i] = min(mn[i], dp[i][j]);
		}
	}
	for (int i = 0; i < m; ++i) {
		cout << mn[i] << ' ';
	}
	cout << "\n";
}

void precalc() {

}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	precalc();
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}