#include "sorting.h"
#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <set>
#include <queue>
#include <map>
#include <iomanip>
using namespace std;

#define ll long long
#define vi vector<int>
#define vll vector<ll>
#define pii pair<int, int>
#define mpr make_pair
#define yes cout<<"YES\n"
#define no cout<<"NO\n"

vi solve(int n) {
	/*cout << 20000 << "\n";
	for (int i = 1; i <= 20000; ++i) {
		cout << i << ' ';
	}
	cout << "\n";*/
	bool f;
	vi ans(n);
	if (n <= 10000) {
		int x, y;
		for (int i = 1; i <= n; ++i) {
			for (int j = 1; j <= n; ++j) {
				if (i == j) {
					continue;
				}
				f = divisible(i, j, n - 1);
				if (f) {
					x = i, y = j;
					i = n + 5, j = n + 5;
				}
			}
		}
		f = compare(x, y);
		if (!f) {
			swap(x, y);
		}
		ans[x - 1] = 1;
		ans[y - 1] = n;
		for (int i = 1; i <= n; ++i) {
			if (i == x || i == y) continue;
			int num = 0;
			for (int j = 1; j <= n - 2; ++j) {
				f = divisible(x, i, j);
				if (f) {
					num = j;
				}
			}
			ans[i - 1] = num + 1;
		}
		return ans;
	}
	else {
		vll primes;
		vector<bool> used(n + 5);
		int mn = 0;
		for (int i = 2; i <= n; ++i) {
			if (!used[i]) {
				primes.push_back(i);
				for (int j = i * i; j <= n; j += i) {
					used[j] = true;
				}
			}
		}
		for (int i = 1; i < n; ++i) {
			ll num = 1;
			for (auto j : primes) {
				ll cp = 1LL;
				while (cp * j <= n && divisible(i, i + 1, cp * j)) {
					cp *= j;
				}
				num *= cp;
			}
			f = compare(i, i + 1);
			if (f) {
				ans[i] = ans[i - 1] + num;
			}
			else {
				ans[i] = ans[i - 1] - num;
			}
			mn = min(mn, ans[i]);
		}
		mn = 1 - mn;
		for (int i = 0; i < n; ++i) {
			ans[i] += mn;
		}
		return ans;
	}
}