#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
const long long P = 1e9 + 7, B = 2e5;
int comp[2001];
bool used[2001];
vector <vector<int>> g, t;
vector <int> order;
long long binpow(long long a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) {
        long long b = binpow(a, n / 2);
        return (b * b) % P;
    }
    else return (a * binpow(a, n - 1)) % P;
}
void dfs(int v) {
    used[v] = true;
    for (auto it : g[v])
        if (!used[it]) dfs(it);
    order.push_back(v);
}
void dfs1(int v, int c) {
    used[v] = true;
    comp[v] = c;
    for (auto it : t[v])
        if (!used[it]) dfs1(it, c);
}

int main()
{
    int a, b, n, m;
    cin >> n >> m;
    g.resize(n + 1);
    t.resize(n + 1);
    for (int i = 1; i <= m; i++) {
        cin >> a >> b;
        g[a].push_back(b);
        t[b].push_back(a);
    }
    int c = 1;
    for (int i = 1; i <= n; i++) {
        if (!used[i]) dfs(i);
    }
    for (int i = 1; i <= n; i++)
        used[i] = false;
    reverse(order.begin(), order.end());
    for (auto it : order) {
        if (!used[it]) {
            dfs1(it, c);
            c++;
        }
    }
    int q;
    cin >> q;
    vector <long long> v;
    if (q == 0) {
        for (int i = 1; i <= n; i++)
        for (int j = 1; j <= n; j++)
        {
            if (comp[i] == comp[j]) v.push_back(m + 1);
            else v.push_back(0);
        }
    }
    else {
        while (q--) {
            int a, b;
            cin >> a >> b;
            if (comp[a] == comp[b]) v.push_back(m + 1);
            else v.push_back(0);
        }
    }
    long long k = (int)v.size() - 1, ans = 0;
    for (auto it : v) {
        ans = ans + ((it * binpow(B, k)) % P);
        ans %= P; k--;
    }
    cout << ans << "\n";
}