#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
const long long P = 1e9 + 7, B = 2e5;
bool used[201];
bool Used[201][201][1001];
int ans[201][201];
int comp[201];
vector <vector<int>> g, t;
vector <vector<pair<int, int>>> G;
vector <int> order;
long long binpow(long long a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) {
        long long b = binpow(a, n / 2);
        return (b * b) % P;
    }
    return (a * binpow(a, n - 1)) % P;
}
void dfs(int v) {
    used[v] = true;
    for (auto it : g[v])
        if (!used[it]) dfs(it);
    order.push_back(v);
}
void dfs1(int v, int c) {
    used[v] = true;
    comp[v] = c;
    for (auto it : t[v])
        if (!used[it]) dfs1(it, c);
}
void DFS(int a, int v, int k) {
    Used[a][v][k] = true;
    for (auto it : G[v]) {
        if (it.second != k && !Used[a][it.first][k]) DFS(a, it.first, k);
    }
}
int main()
{
    int a, b, n, m;
    std::cin >> n >> m;
    g.resize(n + 1);
    t.resize(n + 1);
    G.resize(n + 1);
    for (int i = 1; i <= m; i++) {
        std::cin >> a >> b;
        g[a].push_back(b);
        t[b].push_back(a);
        G[a].push_back({ b, i });
    }
    int c = 1;
    for (int i = 1; i <= n; i++) {
        if (!used[i]) dfs(i);
    }
    for (int i = 1; i <= n; i++)
        used[i] = false;
    reverse(order.begin(), order.end());
    for (auto it : order) {
        if (!used[it]) {
            dfs1(it, c);
            c++;
        }
    }
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
            DFS(i, i, j);
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= n; j++)
        {
            for (int k = 1; k <= m; k++)
                if ((Used[i][j][k] + Used[j][i][k]) < 2) {
                    ans[i][j] = k;
                    break;
                }
        }
    int q;
    std::cin >> q;
    vector <long long> v;
    if (q == 0) {
        for (int i = 1; i <= n; i++)
            for (int j = i; j <= n; j++)
            {
                if (comp[i] != comp[j]) v.push_back(0);
                else {
                    if (ans[i][j]) v.push_back(ans[i][j]);
                    else v.push_back(m + 1);
                }
            }
    }
    else {
        while (q--) {
            int a, b;
            std::cin >> a >> b;
            if (comp[a] != comp[b]) v.push_back(0);
            else {
                if (ans[a][b]) v.push_back(ans[a][b]);
                else v.push_back(m + 1);
            }
        }
    }
    int k = (int)v.size() - 1, ans = 0;
    for (auto it : v) {
        ans = ans + ((it * binpow(B, k)) % P);
        ans %= P; k--;
    }
    cout << ans << "\n";
}