#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
const int N = 1e3 + 10, M = 1e2 + 10;
const long long INF = 2e18 + 10;
long long y[N], c[N], x[N], v[N];
long long dp[N][M][M];
long long ans[M];
int main()
{
	int n, m;
	cin >> n;
	for (int i = 1; i <= n; i++) {
		scanf("%lld%lld", &y[i], &c[i]);
	}
	cin >> m;
	for (int i = 1; i <= m; i++) {
		scanf("%lld%lld", &x[i], &v[i]);
	}
	// dp[i][j][k], i -> last, j -> place, k -> numberofstudents
	ans[0] = 0;
	for (int i = 1; i <= m; i++) {
		ans[i] = INF;
		for (int k = 1; k <= i; k++) {
			for (int j = 1; j <= n; j++) {
				if (y[j] > x[i - k + 1]) break;
				if (k == 1) dp[i][j][k] = (x[i] - y[j]) * v[i] + c[j];
				else dp[i][j][k] = dp[i][j][k - 1] + (x[i - k + 1] - y[j]) * v[i - k + 1];
				ans[i] = min(ans[i], ans[i - k] + dp[i][j][k]);
			}
		}
		printf("%lld ", ans[i]);
	}
}