#include <iostream>
#include <vector>
#include <set>
using namespace std;

vector<int>g[2005];
bool color[2005];
bool c[2005][2005];

void rec(int k, set<int>s)
{
	int i, j;
	color[k] = true;
	for (set<int>::iterator it = s.begin(); it != s.end(); it++)
	{
		c[*it][k] = true;
	}
	s.insert(k);
	for (i = 0; i < g[k].size(); i++)
	{
		c[k][g[k][i]] = 1;
		if (!color[g[k][i]])
			rec(g[k][i], s);
	}
}

int main()
{
	int i, j, m, n;
	cin >> n >> m;
	for (i = 0; i < m; i++)
	{
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		g[a].push_back(b);
	}
	int q;
	cin >> q;
	set<int>st;
	for (i = 0; i < n; i++)
	{
		if (!color[i])
		{
			rec(i, st);
		}
	}
	while (q--)
	{
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		if (c[a][b] && c[b][a])
		{
			cout << m - 1 << endl;
		}
		else cout << 0 << endl;
	}

	return 0;
}