#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <random>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;

#define pb push_back
#define ff first
#define ss second
#define mpr make_pair

//-------------------------------------------------//

bool p[500005];

vector<int> v;

void primes()
{
	int i, j;

	for (i = 2; i * i <= 500000; i++) {
		if (p[i]) continue;

		for (j = i * i; j <= 50000; j += i) {
			p[i] = true;
		}
	}

	for (i = 2; i <= 500000; i++) {
		if (!p[i]) v.pb(i);
	}

	return;
}

vector<int> a;

int calc(int x, int y, int n)
{
	int i, j;

	int ans = 1;

	for (i = 0; i < v.size(); i++) {
		while (divisible(x, y, v[i] * ans)) {
			ans *= v[i];
		}

		if (ans * v[i + 1] > n - 1) break;
	}

	return ans;
}

vector<int> solve(int n)
{
	int i, j;

	int in = 1;

	for (i = 2; i <= n; i++) {
		if (compare(in, i)) {
			in = i;
		}
	}

	a[in] = n;

	for (i = 1; i <= n; i++) {
		if (i == in) a.pb(n);

		a.pb(n - calc(i, in, n));
	}

	return a;
}