#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <random>
#include "sorting.h"
using namespace std;

typedef long long ll;
typedef unsigned long long ull;

#define pb push_back
#define ff first
#define ss second
#define mpr make_pair

//-------------------------------------------------//

bool p[500005];

vector<int> v;

void primes()
{
	int i, j;

	for (i = 2; i * i <= 500000; i++) {
		if (p[i]) continue;

		for (j = i * i; j <= 500000; j += i) {
			p[j] = true;
		}
	}

	for (i = 2; i <= 500000; i++) {
		if (!p[i]) v.pb(i);
	}

	return;
}

vector<int> a;

int calc(int x, int y, int n)
{
	int i, j;

	int ans = 1;

	for (i = 0; i < v.size(); i++) {
		while (ans * v[i] <= n && divisible(x, y, v[i] * ans)) {
			ans *= v[i];
		}
	}

	return ans;
}

vector<int> solve(int N)
{
	int i, j;

	primes();

	int in = 1;

	for (i = 2; i <= N; i++) {
		if (!compare(in, i)) {
			in = i;
		}
	}

	for (i = 1; i <= N; i++) {
		if (i == in) {
			a.pb(1);
			continue;
		}

		a.pb(1 + calc(i, in, N));
	}

	return a;
}