﻿#include "sorting.h"
#include <vector>
#include <set>
#include <iostream>
using namespace std;

template<typename T>
using V = vector<T>;

struct Compare {
	bool operator()(int x, int y) const {
		return compare(x, y);
	}
};

V<int> solve(int N)
{
	int i;
	multiset<int, Compare> Perm;
	V<int> ans(N);
	Perm.insert(1);
	for (i = 2; i <= N; ++i)
		Perm.insert(i);
	i = 1;
	for (set<int>::iterator it = Perm.begin(); it != Perm.end(); ++it, ++i)
		ans[*it - 1] = i;
	return ans;
}