#include <bits/stdc++.h>

using namespace std;

#define int long long

vector<vector<int>> graph(205); 
vector<int> color(205 , 0);
vector<vector<int>> cnt(205 , vector<int> (205 , 0));

const int mod = 1e9 + 7;

int binpow(int a , int b){
	if(b == 0){
		return 1;
	}
	int res = binpow(a , b/2);
	res %= mod;
	if(b & 1){
		return res * res * a;
	}
	return res * res;
}

void init(){
	for(int i=1 ; i<=200 ; i++){
		color[i] = 0;
	}
}

bool DFS(int from , int to , int u , int v){
	color[from] = 1;
	for(int i=0 ; i<graph[from].size() ; i++){
		int node = graph[from][i];
		if(((u != from || v != node) || cnt[from][node] > 1) && color[node] == 0){
			DFS(node , to , u , v);
		}
	} 
	if(color[to] == 1){
		return true;
	}
	return false;
}

void solve(){
	int n , m;
	cin >> n >> m;
	vector<pair<int , int>> e;
	for(int i=0 ; i<m ; i++){
		int u , v;
		cin >> u >> v;
		cnt[u][v]++;
		e.push_back({u , v});
		graph[u].push_back(v);
	}
	int q;
	cin >> q;
	vector<int> ans(q+5);
	for(int i=0 ; i<q ; i++){
		int u , v;
		cin >> u >> v;
		bool ch = DFS(u , v , 0 , 0);
		init();
		bool ch1 = DFS(v , u , 0 , 0);
		if(ch == false || ch1 == false){
			ans[i+1] = 0; 
		}
		init();
		int index = -1;
		for(int j=0 ; j<e.size() ; j++){
			init();
			bool ch = DFS(u , v , e[j].first , e[j].second);
			init();
			bool ch1 = DFS(v , u , e[j].first , e[j].second);
			if(ch == false || ch1 == false){
				index = j+1;
				break;
			}
		}
		if(index == -1){
			ans[i+1] = m + 1;
		}
		else{
			ans[i+1] = index;
		}
	}
	int answer = 0 , k = q - 1;
	for(int i=1 ; i<=q ; i++){
		answer += (ans[i] * binpow(200000 , k));
		k--;
	}
	cout << answer % mod;
}

signed main(){
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	solve();

	return 0;
}