#include<bits/stdc++.h>
using namespace std;
using ll = long long;
#include<bits/stdc++.h>
using namespace std;
using ll = long long;
struct convex_hull {
    struct line {
        long long a, b;
        long double x;
        line( long long _a, long long _b) {
            a=_a,b=_b;
        }
        long double intersect(line s) {
            return ((long double)b-s.b)/((long double)s.a-a);
        }
        long long val(long long _x) {
            return a*_x+b;
        }
    };
    vector<line> hull;
    void insert(line l) {
        while(hull.size()) {
            line c = hull.back();
            if((c.a-l.a)*c.x>(l.b-c.b)) {
                hull.pop_back();
                continue;
            }
            if(c.a!=l.a) {
                l.x = l.intersect(c);
                hull.push_back(l);
            }
            return;
        }
        l.x=-10;
        hull.push_back(l);
    }
    static bool cmp(long long x, line l) {
        return x<=l.x;
    }
    pair<ll,ll> query(long long x) {
        int idx = (--upper_bound(hull.begin(), hull.end(),x,cmp))-hull.begin();
        return {hull[idx].a, hull[idx].b};
    }
};

int main () {
    convex_hull cc;
    int n;
    cin >> n;
    vector<pair<ll,ll>> v(n+1);
	v[0]={0,0};
    for(int i = 1;i<=n;i++){
        cin >> v[i].first >> v[i].second;
    }
    int m;
    cin >> m;
    vector<pair<ll,ll>> p(m);
    for(int i = 0;i<m;i++)cin>>p[i].first>>p[i].second;
    long long ans=0;
    int at=0;
    for(int i = 0;i<m;i++) {
        for(;at<=n and v[at].first<=p[i].first;at++) {
            cc.insert(convex_hull::line(-v[at].first, v[at].second));
        }
        long long res=(p[i].first+cc.query(p[i].second).first)*p[i].second+cc.query(p[i].second).second;
        ans+=res;
        cout << ans;
		if(i!=m-1)cout << " ";
    }
	cout << "\n";
}

