#include <bits/stdc++.h>
typedef long long ll;
typedef unsigned long long ull;

const ll INFL = 0x3f3f3f3f3f3f3f3f;
const ull INFUL = INFL;
const ll MOD = 1e9 + 7;
const ll B = 2e5;
#define IOF ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define sz(x) x.size()
#define all(x) x.begin(), x.end()
#define FOR(typ, i, a, b, c) for(typ i = a; i<b; i+=c)
#define FORR(typ, i, a, b, c) for(typ i = a; i>b; i-=c)
#define FORA(a,x) for(auto x: a)
#define WH while
#define WHI(t) WH(t--)
#define pii pair<int,int>
#define pll pair<ll,ll>
#define V vector
#define RET return 
#define TYP 0
using namespace std;

ll n, m, q, u, v, ans, c;
map<pair<ll,ll>, ll> ed;
V<ll> topo, color,res;
V<V<ll>> g, g1, con;
V<V<pll>> gc;
V<pll>	qs;
V<bool> used;
ll mult(ll a, ll b, ll m)
{
	a %= m;
	ll res = 0;
	WH(b > 0)
	{
		if (b & 1)res = (res + a) % m;
		a = (2 * a) % m;
		b >>= 1;
	}
	return res;
}
ll pom(ll a, ll b, ll m)
{
	a %= m;
	ll res = 1;
	WH(b > 0)
	{
		if (b & 1)res = mult(res, a, m);
		a = mult(a, a, m);
		b >>= 1;
	}
	return res;
}

void dfs1(ll u)
{
	used[u] = 1;

	FORA(g[u], v)if (!used[v])dfs1(v);
	topo.emplace_back(u);
}

void dfs2(ll u, ll c)
{
	color[u] = c;
	FORA(g1[u], v)if (color[v] == -1)dfs2(v, c);
}

bool dfs3(ll u, ll e)
{
	if (u == e)return 1;
	used[u] = 1;
	FORA(g[u], v)
		if (!used[v] && color[v] == color[u] && dfs3(v, e)) return 1;
	return 0;
}


ll getAns(ll u, ll v)
{
	ll res = INFL, v1=-1;
	FOR(ll,u1,1,n+1,1)
		FOR(ll, j, 0, g[u1].size(), 1)
	{
		used.assign(n + 1, 0);
		v1 = g[u1][j];
		g[u1][j] = u1;
		if (!dfs3(u, v))
			res = min(res, ed[{u1, v1}]);
		used.assign(n + 1, 0);
		if(!dfs3(v,u))
			res = min(res, ed[{u1, v1}]);
		g[u1][j] = v1;

	}
	
	if (res == INFL)res = m + 1;
	return res;
}

void solve()
{
	cin >> n >> m;
	g.resize(n + 1); g1.resize(n + 1); color.assign(n + 1, -1); used.resize(n + 1);
	FOR(ll, i, 1, m + 1, 1)
	{
		cin >> u >> v;
		if (!ed[{u, v}])ed[{u, v}] = i;
		g[u].push_back(v), g1[v].push_back(u);

	}
	dfs1(1);
	reverse(all(topo));
	FORA(topo, u)
		if (color[u] == -1)
		{
			c++;
			dfs2(u, c);
		}
	cin >> q;
	if (!q)
	{
		FOR(ll, i, 1, n + 1, 1)
			FOR(ll, j, i, n + 1, 1)
		{
			if (color[i] != color[j])res.emplace_back(0);
			else res.emplace_back(getAns(i, j));
		}
	}
	
	WHI(q)
	{
		cin >> u >> v;
		if (color[u] != color[v])res.emplace_back(0);
		else res.emplace_back(getAns(u, v));
	}
	ans = 0;
	FOR(ll, i, 0, res.size(), 1)ans = (ans + mult(res[i], pom(B, res.size() - i - 1, MOD), MOD)) % MOD;
	cout << ans << endl;
}

void handle()
{
	ll t = 1;
	if (TYP) cin >> t;
	WHI(t)solve();
}

void init()
{
	
}

int main()
{
	init();
	handle();
	RET 0;
}