#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
#define endl '\n'
const int mod = 1e9+7;
const int B = 2e5;
ll power(ll a,ll b){
    if(b == 0) return 1;
    if(b == 1) return a%mod;
    ll r = power(a,b/2)%mod;
    if(b&1){
        return (((r*r)%mod)*a)%mod;
    }
    return (r*r)%mod;
}
void solve(){
    int n,m;
    cin>>n>>m;
    vector<vector<int>> adj(n+1);
    for(int i=0;i<m;i++){
        int a,b;
        cin>>a>>b;
        adj[a].push_back(b);
    }
    vector<vector<bool>> can(n+1,vector<bool>(n+1));
    for(int i=1;i<=n;i++){
        vector<bool> vis(n+1);
        queue<int> q;
        vis[i] = 1;
        q.push(i);
        while(q.size()){
            int cur = q.front();        q.pop();
            for(auto ch : adj[cur]){
                if(vis[ch]) continue;
                vis[ch] = 1;
                q.push(ch);
            }
        }
        for(int j=1;j<=n;j++){
            can[i][j] = vis[j];
        }
    }
    int q;
    cin>>q;
    vector<pair<int,int>> Q(q);
    for(int i=0;i<q;i++){
        cin>>Q[i].first>>Q[i].second;
    }
    if(q == 0){
        for(int i=1;i<=n;i++){
            for(int j=i;j<=n;j++){
                Q.push_back({i,j});
            }
        }
    }
    ll ans = 0;
    ll k = Q.size();
    k --;
    for(auto i : Q){
        ll a = 0;
        if(can[i.first][i.second] && can[i.second][i.first]) a = m+1;
        ans += (a*power(B,k))%mod;
        k --;
    }
    cout<<ans<<endl;
}
int main()
{
    int t=1;
    //cin>>t;
    while(t--){
        solve();
    }
    return 0;
}
