#include <bits/stdc++.h>

using namespace std;

#define int long long
#define IOS ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

const int N = 1e5 + 5, LOO = 0x3f3f3f3f3f3f3f3f;

int Log[N];

void LogPr()
{
	for (int i = 2; i < N; i++)
		Log[i] = Log[i / 2] + 1;
}

vector<vector<int>> buildTable(vector<int>& a)
{
	int n = a.size();
	int j = Log[n];
	vector<vector<int>> table(n, vector<int>(j + 2));
	for (int i = 0; i < n; i++)
		table[i][0] = a[i];
	for (int j = 1; (1 << j) <= n; j++)
		for (int i = 0; (i + (1 << j) - 1) < n; i++)
			table[i][j] = min(table[i][j - 1], table[i + (1 << (j - 1))][j - 1]);
	return table;
}
int get(vector<vector<int>>& tab, int l, int r)
{
	int len = r - l + 1;
	int j = Log[len];
	return min(tab[l][j], tab[r - (1 << j) + 1][j]);
}

int32_t main()
{
	IOS;
	LogPr();
	int n;
	cin >> n;
	vector<pair<int, int>> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i].first >> a[i].second;
	sort(a.begin(), a.end());
	int ls = a.back().first;
	vector<int> b(n);
	int m, st, x;
	cin >> m >> st >> x;
	for (int i = 0; i < n; i++)
	{
		int co = (ls - a[i].first) * x + a[i].second;
		b[i] = co;
	}
	vector<vector<int>> table = buildTable(b);
	int cur = 0;
	if (st <= ls)
		cur = (get(table, 0, st - 1) - (abs(ls - st) * x));
	else
		cur = (get(table, 0, ls - 1) + (abs(ls - st) * x));
	int ll = 0;
	ll += cur;
	cout << ll << " ";
	for (int i = 0; i < m - 1; i++)
	{
		cin >> st >> x;
		if (st <= ls)
			cur = (get(table, 0, st - 1) - (abs(ls - st) * x));
		else
			cur = (get(table, 0, ls - 1) + (abs(ls - st) * x));
		ll += cur;
		cout << ll << " ";
	}
}