#include <bits/stdc++.h>

using namespace std;

#define lg long long

const lg N = 2e3+5, MOD = 1e9+7;

vector<multiset<lg>> adj(N);
lg vis[N], tmp;

void dfs(lg src)
{
	vis[src] = tmp;
	for(auto it : adj[src])
	{
		if(vis[it] == tmp)	continue;
		dfs(it);
	}
	return;
}

lg fast_power(lg n, lg k)
{	
	lg ans = 1;
	while(k)
	{
		if((k&1))	ans = (ans*n)%MOD;
		n = (n*n)%MOD;
		k >>= 1;
	}
	return ans;
}

int main()
{
	ios_base::sync_with_stdio(0);cin.tie(NULL);cout.tie(NULL);
	lg n, m;
	cin >> n >> m;
	vector<pair<lg, lg>> edges;
	for(int i = 0; i < m; i++)
	{
		lg u, v;
		cin >> u >> v;
		edges.push_back({u, v});
		adj[u].insert(v);
	}
	lg q;
	cin >> q;
	lg ans = 0, cur = fast_power(2e5, q-1);
	lg inv = fast_power(2e5, MOD-2);
	while(q--)
	{
		lg a, b;
		cin >> a >> b;
		tmp++;
		dfs(a);
		lg curAns = 0;
		if(vis[b]  == tmp)	
		{
			tmp++;
			dfs(b);
			if(vis[a] == tmp)
			{
				curAns = m+1;
				lg g = 1;
				for(auto [u, v] : edges)	
				{
					adj[u].erase(adj[u].find(v));	
					tmp++;
					dfs(a);
					if(vis[b] != tmp)	
					{	
						curAns = g;
						adj[u].insert(v);
						break;
					}
					tmp++;
					dfs(b);
					if(vis[a] != tmp)	
					{	
						curAns = g;
						adj[u].insert(v);
						break;
					}
					g++;
					adj[u].insert(v);
				}
			}
		}
		ans = (ans+(curAns*cur)%MOD)%MOD;
		//cout << curAns << '\n';
		cur = (cur*inv)%MOD;
	}
	cout << ans << '\n';
	return 0;
}