#include <vector>
#include <bits/stdc++.h>
#include "sorting.h"

#define lg long long

using namespace std;

#ifdef CYBER
#include "Lgrader.cpp"
#endif

vector<int> d_c(int l, int r, int &n)
{
	if(r == l)	return {0};
	int mid = (r-l)/2;
	vector<int> a = d_c(l, mid+l, n);
	vector<int> b = d_c(l+mid+1, r, n);
	vector<int> ans(r-l+1);
	int mxm = 1;
	for(int i = n; i >= 2; i--)
	{
		if(divisible(l+1, l+mid+2, i))	
		{
			mxm = i;break;
		}
	}
	if(compare(l+1, l+mid+2))	
	{
		for(int i = 0; i < a.size(); i++)	ans[i] = a[i];
		for(int i = 0; i < b.size(); i++)	ans[i+a.size()] = b[i]+mxm;
	}
	else	
	{
		for(int i = 0; i < a.size(); i++)	ans[i] = a[i];
		for(int i = 0; i < b.size(); i++)	ans[i+a.size()] = b[i]-mxm;
	}
	return ans;
}

std::vector < int > solve(int n)
{
	int l = 0, r = n-1;
	vector<int> ans = d_c(l, r, n);
	int lRange = 1, rRange = n;
	for(int j = 1; j < n; j++)
	{
		lRange = max(lRange , 1-ans[j]);
		rRange  = min(rRange , n-ans[j]);
	}		
	int best = -1;
	for(int i = lRange ; i <= rRange  && best == -1; i++)	best = i;
	for(auto &it : ans)	it += best;
	return ans;
}