#include <bits/stdc++.h>
#define ll long long
#define fi first
#define se second
//#define endl '\n'
using namespace std;
ll M = 1e9 + 7;
vector <vector <ll > > g, gr;
vector <pair <ll, ll > > edges, rev_edges;
vector <ll > ts, used;
ll n, m;
void ts_dfs(ll v, ll u1, ll v1) {
    used[v] = 1;
    for (auto e : g[v]) {
        if (u1 == v && e == v1) continue;
        if (!used[e]) {
            ts_dfs(e, u1, v1);
        }
    }
    ts.push_back(v);
}
void rev_dfs(ll v, ll u1, ll v1, ll clr) {
    used[v] = clr;
    for (auto e : gr[v]) {
        if (u1 == v && e == v1) continue;
        if (!used[e]) {
            rev_dfs(e, u1, v1, clr);
        }
    }
}
map <pair <ll, ll >, ll > mp_edges;
void fnc(ll ind) {
    ts.clear();
    used.assign(n, 0);
    ll u1, v1;
    if (ind == -1) {
        u1 = -1, v1 = -1;
    } else {
        u1 = edges[ind].fi;
        v1 = edges[ind].se;
    }
    for (ll i = 0; i < n; i++) {
        if (!used[i]) {
            ts_dfs(i, u1, v1);
        }
    }
    reverse(ts.begin(), ts.end());
    used.assign(n, 0);
    ll clr = 1;
    for (auto e : ts) {
        if (!used[e]) {
            rev_dfs(e, v1, u1, clr++);
        }
    }
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < n; j++) {
            if (used[i] == used[j]) {
                mp_edges[{i, j}] = m + 1;
                mp_edges[{j, i}] = m + 1;
            } else {
                mp_edges[{i, j}] = 0;
                mp_edges[{j, i}] = 0;
            }
        }
    }
}
void kupaga() {
    cin >> n >> m;
    edges.resize(m);
    rev_edges.resize(m);
    g.resize(n);
    gr.resize(n);

    for (ll i = 0; i < m; i++) {
        ll u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
        gr[v].push_back(u);

        edges[i] = {u, v};
        rev_edges[i] = {v, u};
    }
    fnc(-1);
    ll q;
    cin >> q;
    ll ans = 0;
    if (q == 0) {
        for (ll u = 0; u < n; u++) {
            for (ll v = u; v < n; v++) {
                ans *= (ll)2e5;
                ans %= M;
                ans += mp_edges[{u, v}];
            }
        }
    } else {
        for (ll i = 0; i < q; i++) {
            ll u, v;
            cin >> u >> v;
            u--, v--;
            ans *= (ll)2e5;
            ans %= M;
            ans += mp_edges[{u, v}];
        }
    }
    cout << ans << endl;

}
int main() {
    cin.tie(0); ios_base::sync_with_stdio(0); cout.tie(0);
    //freopen("bacon.in", "r", stdin); freopen("bacon.out", "w", stdout);
    //cout << fixed << setprecision(10);
    //ll zxc;  cin >> zxc; while (zxc--)
    kupaga();
    return 0;
}
