﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <random>
#include "sorting.h"
using namespace std;
typedef int ll;
typedef long double ld;
typedef unsigned long long ull;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define forr(i, n) for (ll i = 0;i<n;i++)

//const ll INF = 4e18;
ll n;
vector<vector<ll>> bp;
vector<char> isp;
void precalc() {
    isp.resize(n, 1);
    for (ll i = 2; i < n; i++) {
        if (isp[i]) {
            bp.push_back({i});
            while ((long long)bp.back().back() * i < n) {
                bp.back().push_back(bp.back().back() * i);
            }
            for (ll j = i * 2; j < n; j += i) {
                isp[j] = 0;
            }
        }
    }
}
vector<int> solve(ll nn) {
    n = nn;
    precalc();
    ll mn = 0;
    for (ll i = 0; i < n; i++) {
        if (compare(i, mn)) mn = i;
    }
    vector<ll> ans(n);
    for (ll i = 0; i < n; i++) {
        if (i != mn) {
            ans[i] = 1;
            forr(j, bp.size()) {
                forr(k, bp[j].size()) {
                    if (divisible(i, mn, bp[j][k])) ans[i] *= bp[j][0];
                    else break;
                }
            }
        }
    }
    return ans;
}

/*int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    return 0;
}*/