#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

random_device rd;
mt19937 rnd(time(0));

const ll INF = 2000000000000000000;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

void solve() {
	ll n;
	cin >> n;
	deque<pair<ll, ll>> bus(n);
	for (ll i = 0; i < n; i++) {
		cin >> bus[i].first >> bus[i].second;
	}
	sort(bus.begin(), bus.end());
	ll m;
	cin >> m;
	vector<pair<ll, ll>> st(m);
	for (ll i = 0; i < m; i++) {
		cin >> st[i].first >> st[i].second;
	}
	ll v = st[0].second;
	ll u1 = 0;
	vector<ll> ans(m, INF);
	vector<pair<ll, ll>> cu;
	for (ll i = 0; i < m; i++) {
		while (!bus.empty() && bus.front().first <= st[i].first) {
			while (!cu.empty() && cu.back().second + abs(bus.front().first - cu.back().first) * v >= bus.front().second) {
				cu.pop_back();
				if (u1 == cu.size()) {
					u1--;
				}
			}
			cu.push_back(bus.front());
			bus.pop_front();
		}
		if (u1 == -1) {
			u1 = 0;
		}
		while (u1 < cu.size() - 1 && (abs(cu[u1].first - st[i].first) * st[i].second + cu[u1].second) > (abs(cu[u1 + 1].first - st[i].first) * st[i].second + cu[u1 + 1].second)) {
			u1++;
		}
		assign_min(ans[i], (abs(cu[u1].first - st[i].first) * st[i].second + cu[u1].second));
	}
	ll sum = 0;
	for (ll i = 0; i < m; i++) {
		sum += ans[i];
		cout << sum << ' ';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
