#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

random_device rd;
mt19937 rnd(time(0));

const ll INF = 2000000000000000000;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

void solve() {
	ll n;
	cin >> n;
	deque<pair<ll, ll>> bus(n);
	for (ll i = 0; i < n; i++) {
		cin >> bus[i].first >> bus[i].second;
	}
	sort(bus.begin(), bus.end());
	ll m;
	cin >> m;
	vector<pair<ll, ll>> st(m);
	for (ll i = 0; i < m; i++) {
		cin >> st[i].first >> st[i].second;
	}
	vector<vector<ll>> dp(m, vector<ll>(n, INF));
	for (ll i = 0; i < m; i++) {
		dp[i][0] = bus[0].second;
		for (ll j = 0; j <= i; j++) {
			dp[i][0] += abs(bus[0].first - st[i].first) * st[i].second;
		}
		for (ll j = 1; j < n; j++) {
			dp[i][j] = dp[i][j - 1];
			ll sum = bus[j].second;
			for (ll k = i; k >= 0; k--) {
				if (bus[j].first > st[k].first) {
					break;
				}
				sum += abs(st[k].first - bus[j].first) * st[k].second;
				assign_min(dp[i][j], sum + (k == 0 ? 0 : dp[k - 1][j - 1]));
			}
		}
		cout << dp[i].back() << ' ';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
