#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

random_device rd;
mt19937 rnd(time(0));

const ll INF = 2000000000000000000;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

void solve() {
	ll n;
	cin >> n;
	deque<pair<ll, ll>> bus(n);
	for (ll i = 0; i < n; i++) {
		cin >> bus[i].first >> bus[i].second;
	}
	sort(bus.begin(), bus.end());
	ll m;
	cin >> m;
	vector<pair<ll, ll>> st(m);
	for (ll i = 0; i < m; i++) {
		cin >> st[i].first >> st[i].second;
	}
	vector<ll> ans(m, INF);
	for (ll i = 0; i < m; i++) {
		ll last = i, na = 0, sumv = 0, lst = bus.back().first;
		for (ll j = n - 1; j >= 0; j--) {
			na += (lst - bus[j].first) * sumv;
			while (last != -1 && st[last].first >= bus[j].first) {
				sumv += st[last].second;
				na += (st[last].first - bus[j].first) * st[last].second;
				last--;
			}
			lst = bus[j].first;
			if (last < i) {
				assign_min(ans[i], na + bus[j].second + (last == -1 ? 0 : ans[last]));
			}
		}
		cout << ans[i] << ' ';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
