#include<bits/stdc++.h>
#include "sorting.h"

using namespace std;

typedef int ll;

random_device rd;
mt19937 rnd(rd());

const ll INF = 2000000000;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

vector<ll> solve(ll n) {
	map<ll, vector<ll>> all;
	for (ll i = 1; i <= n; i++) {
		all[0].push_back(i);
	}
	vector<ll> ans(n);
	for (ll i = 0; i < n; i++) {
		if (all[i].empty()) {
			continue;
		}
		ll mi = all[i][0];
		for (ll j = 1; j < all[i].size(); j++) {
			if (compare(all[i][j], mi)) {
				mi = all[i][j];
			}
		}
		ans[mi - 1] = i + 1;
		for (ll j = 0; j < all[i].size(); j++) {
			if (all[i][j] == mi) {
				continue;
			}
			for (ll k = 1;; k++) {
				if ((1 << k) >= n || !divisible(mi, all[i][j], (1 << k))) {
					all[i + (1 << (k - 1))].push_back(all[i][j]);
					break;
				}
			}
		}
	}
	return ans;
}
