#include<bits/stdc++.h>
#include "sorting.h"

using namespace std;

typedef int ll;

random_device rd;
mt19937 rnd(rd());

const ll INF = 2000000000;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

vector<ll> solve(ll n) {
	if (n <= 75000) {
	ll me = rnd() % n;
    	vector<vector<ll>> ots(n);
	ll mots = 0, nmots = 0;
    	for (ll i = 0; i < n; i++) {
        	if (i == me) {
            		continue;
        	}
        	ll now = 1;
        	for (ll j = 1; j < n; j += now) {
            		if (divisible(i + 1, me + 1, j)) {
                		now = j;
            		}
        	}
        	ots[now].push_back(i);
		if (assign_max(mots, now)) {
			nmots = i;
		}
    	}
	vector<ll> ans(n);
	if (n == 1) {
		ans[0] = 1;
		return ans;
	}
	ll cme = 0;
	if (compare(nmots + 1, me + 1)) {
		cme = mots + 1;
	} else {
		cme = n - mots;
	}
	ans[me] = cme;
	for (ll i = 0; i < n; i++) {
		if (ots[i].size() == 0) {
			continue;
		}
		if (ots[i].size() == 1) {
			if (cme - i < 1) {
				ans[ots[i][0]] = cme + i;
			} else {
				ans[ots[i][0]] = cme - i;
			}
		} else {
			if (compare(ots[i][1] + 1, ots[i][0] + 1)) {
				swap(ots[i][1], ots[i][0]);
			}
			ans[ots[i][0]] = cme - i;
			ans[ots[i][1]] = cme + i;
		}
	}
    	return ans;
	}
	vector<vector<ll>> all(n);
	for (ll i = 1; i <= n; i++) {
		all[0].push_back(i);
	}
	vector<ll> ans(n);
	for (ll i = 0; i < n; i++) {
		if (all[i].empty()) {
			continue;
		}
		ll mi = all[i][0];
		for (ll j = 1; j < all[i].size(); j++) {
			if (compare(all[i][j], mi)) {
				mi = all[i][j];
			}
		}
		ans[mi - 1] = i + 1;
		for (ll j = 0; j < all[i].size(); j++) {
			if (all[i][j] == mi) {
				continue;
			}
			for (ll k = 1;; k++) {
				if ((1 << k) >= n || !divisible(mi, all[i][j], (1 << k))) {
					all[i + (1 << (k - 1))].push_back(all[i][j]);
					break;
				}
			}
		}
	}
	return ans;
}
