#include "bits/stdc++.h"
using namespace std;

using ll = long long;
#define all(x) x.begin(), x.end()

int mod = 1e9 + 7;
int b = 2e5;

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
    }
    vector<int> top, used(n), comp(n);
    function<void(int)> dfs = [&](int u) {
        used[u] = 1;
        for (auto to : g[u]) if (!used[to]) dfs(to);
        top.push_back(u);
    };
    for (int i = 0; i < n; ++i) {
        if (!used[i]) dfs(i);
    }
    int c;
    function<void(int)> paint = [&](int u) {
        comp[u] = c;
        for (auto to : g[u]) if (!comp[to]) paint(to);
    };
    reverse(all(top));
    for (auto u : top) {
        if (!comp[u]) ++c, paint(u);
    }
    auto qq = [&](int u, int v) {
        if (comp[u] == comp[v]) return m;
        return 0;
    };
    int q;
    cin >> q;
    if (q == 0) {
        int ans = 0;
        for (int i = 0; i < n; ++i) {
            for (int j = i; j < n; ++j) {
                ans = (1LL * ans * b + qq(i, j)) % mod;
            }
        }
        cout << ans;
    } else {
        int ans = 0;
        while (q--) {
            int u, v;
            cin >> u >> v;
            ans = (1LL * ans * b + qq(u, v)) % mod;
        }
        cout << ans;
    }
}