#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define int ll

const int N = 2010;

vector<int> g[N];
bool can[N][N];

void dfs(int v, int st){
    can[st][v] = true;
    for(auto u : g[v]){
        if(can[st][u])
            continue;
        dfs(u, st);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    for(int i = 0; i < m; i++){
        int u, v;
        cin >> u >> v;
        g[u].emplace_back(v);
    }
    for(int i = 1; i <= N; i++){
        for(int j = 1; j <= N; j++){
            can[i][j] = false;
        }
    }
    for(int i = 1; i <= n; i++){
        dfs(i, i);
    }
    int q;
    cin >> q;
    vector<int> res;
    if(q == 0){
        for(int i = 1; i <= n; i++){
            for(int j = i; j <= n; j++){
                if(!can[i][j] || !can[j][i]){
                    res.emplace_back(0);
                    continue;
                }
                res.emplace_back(m + 1);
            }
        }
    }else{
        while(q--){
            int u, v;
            cin >> u >> v;
            if(!can[u][v] || !can[v][u])
                res.emplace_back(0);
            else
                res.emplace_back(m + 1);
        }
    }
    reverse(all(res));
    const int mod = int(1e9) + 7, b = int(2e5);
    int p = 1, answer = 0;
    for(int i = 0; i < int(res.size()); i++){
        answer += (res[i] * p) % mod;
        answer %= mod;
        p = p * b;
        p %= mod;
    }
    cout << answer;
    return 0;
}