#include "sorting.h"
#include <bits/stdc++.h>
#pragma GCC optimize("O3,unroll-loops")

using namespace std;

bool isp(int x)
{
    for(int i = 2; i * i <= x; i++)
        if(x % i == 0)
            return false;
    return true;
}

std::vector < int > solve(int n)
{
    set<int> nums;
    for(int i = 2; i <= 500000; i++)
        nums.insert(i);
    for(int i : primes)
    {
        for(int j = i * i; j <= 500000; j += i)
            if(nums.find(j) != nums.end())
                nums.erase(j);
    }
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0); cerr.tie(0);
    if(n == 1)
        return {1};
    else if(n == 2)
    {
        if(compare(1, 2))
            return {2, 1};
        return {1, 2};
    }
    else if(n == 3)
    {
        if(compare(1, 2))
        {
            if(divisible(1, 3, 2))
                return {3, 2, 1};
            if(divisible(2, 3, 2))
                return {2, 1, 3};
            return {3, 1, 2};
        }
        else
        {
            if(divisible(1, 3, 2))
                return {1, 2, 3};
            if(divisible(2, 3, 2))
                return {2, 3, 1};
            return {1, 3, 2};
        }
    }
    vector<int> res(n);
    vector<int> compares;
    int cnt = 0, f = compare(1, 2);
    cnt += f;
    for(int i = 3; i <= n; i++)
        cnt += compare(1, i);
    res[0] = n - cnt;
    vector<bool> used(n + 5, false);
    for(int i = 0; i < n - 1; i++)
    {
        int r;
        int mx = max(res[i] - 1, n - res[i]);
        int nw = 1;
        while(nw <= mx)
        {
            bool b = false;
            for(int j : nums)
            {
                if(j * nw > mx)
                    break;
                if(divisible(i + 1, i + 2, nw * j))
                {
                    nw *= j;
                    goto f1;
                }
            }
            b = true;
            f1: if(b)
                    break;
        }
        if(res[i] - nw >= 1 && (res[i] + nw > n || used[res[i] + nw]))
            r = res[i] - nw;
        else if(res[i] + nw <= n && (res[i] - nw < 1 || used[res[i] - nw]))
            r = res[i] + nw;
        else
        {
            if(i != 0)
            {
                if(compare(i + 1, i + 2))
                    r = res[i] + nw;
                else r = res[i] - nw;
            }
            else
            {
                if(f)
                    r = res[i] + nw;
                else r = res[i] - nw;
            }
        }
        res[i + 1] = r;
        used[r] = true;
    }
    return res;
}
