#pragma GCC optimize("O3,unroll-loops")
#include "sorting.h"
#include <bits/stdc++.h>

using namespace std;

bool compare(int x, int y);

bool divisible(int x, int y, int d);

vector<int> solve(int n)
{
    vector<int> res(n);
    if (n > 60000)
    {
        vector<int> perm(n);
        for (int i = 0; i < n; i++) perm[i] = i + 1;
        stable_sort(perm.begin(), perm.end(), compare);
        for (int i = 1; i <= n; i++) res[perm[i - 1] - 1] = i;
        return res;
    }
    int p = 0;
    for (int i = 1; i < n; i++)
    {
        if (compare(i + 1, p + 1)) p = i;
    }
    res[p] = 1;
    for (int i = 0; i < n; i++)
    {
        if (i == p) continue;
        int mx = 1, l = 1;
        for (int j = 2; j <= n; j += l)
        {
            if (divisible(i + 1, p + 1, j)) mx = j, l = lcm(l, j);
        }
        res[i] = mx + 1;
    }
    return res;
}
//
