#pragma GCC optimixe ("ofast")

#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
#define int ll
#define E '\n'
#define pb push_back

const ll MD = 1e9 + 7;
ll bp(ll a, int b) {
    ll st = 1;
    while(b > 0) {
        if(b & 1) {
            st *= a;
            st %= MD;
            b--;
        } else {
            a *= a;
            a %= MD;
            b >>= 1;
        }
    }
    return st;
}

const int N = 2e3 + 12;
vector <int> g[N];
int ms[N][N];
const int M = 5e6 + 12;
ll st[M];

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n, m;
    cin >> n >> m;
    for(int i = 1; i <= m; ++i) {
        int x, y;
        cin >> x >> y;
        g[x].pb(y);
    }
    for(int i = 1; i <= n; ++i) {
        vector <int> p(n + 1, 0);
        queue <int> q;
        q.push(i);
        p[i] = 1;
        while(q.size()) {
            int v = q.front();
            q.pop();
            for(auto to : g[v]) {
                if(p[to])
                    continue;
                p[to] = 1;
                q.push(to);
            }
        }
        for(int j = 1; j <= n; ++j) {
            ms[i][j] = p[j];
        }
    }
    st[0] = 1;
    for(int i = 1; i < M; ++i) {
        st[i] = (st[i - 1] * ll(2e5)) % MD;
    }
    ll ans = 0;
    int qq;
    cin >> qq;
    if(qq == 0) {
        qq = n * (n - 1) / 2;
        int id = qq - 1;
        for(int i = 1; i <= n; ++i) {
            for(int j = i; j <= n; ++j) {
                if(ms[i][j] == 0 || ms[j][i] == 0) {
                    id--;
                    continue;
                }
//                cout << i << ' ' << j << " : " << id << ' ' << st[id] << E;
                ans += (ll(m + 1LL) * st[id]) % MD;
                ans %= MD;
                id--;
            }
        }
        cout << ans;
        return 0;
    }
    while(qq--) {
        int id = qq;
        int i, j;
        cin >> i >> j;
//        cout << id << E;
        if(ms[i][j] == 0 || ms[j][i] == 0)
            continue;
        ans += (ll(m + 1LL) * st[id]) % MD;
        ans %= MD;
    }
    cout << ans;
    return 0;
}
