#include <bits/stdc++.h>

#define fi first
#define se second
#define pb push_back
#define pii pair <int, int>
#define ll long long
#define int int64_t

using namespace std;
const int N = 1e5 + 50, M = 2e5;
vector <pii> g[N];
const int mod = 1e9 + 7;

int bp (ll a, int st) {
    ll ans = 1;
    while (st > 0) {
        if(st & 1) {
            ans *= a;
            ans %= mod;
        }
        a *= a;
        a %= mod;
        st >>= 1;
    }
    return ans;
}

bool CAN (int a, int b) {
    unordered_set <int> st;
    st.insert(a);
    queue <int> q;
    q.push(a);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        if(v == b) {
            return 1;
        }
        for(auto to : g[v]) {
            if(!st.count(to.fi)) {
                st.insert(to.fi);
                if(to.fi == b) {
                    return 1;
                }
                q.push(to.fi);
            }
        }
    }
    return 0;
}

bool can (int a, int b, int ban) {
    unordered_set <int> st;
    st.insert(a);
    queue <int> q;
    q.push(a);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        if(v == b) {
            return 1;
        }
        for(auto to : g[v]) {
            if(to.se == ban) {
                continue;
            }
            if(!st.count(to.fi)) {
                st.insert(to.fi);
                if(to.fi == b) {
                    return 1;
                }
                q.push(to.fi);
            }
        }
    }
    return 0;
}

int32_t main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n, m;
    cin >> n >> m;
    for(int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        --x;
        --y;
        g[x].pb({y, i});
    }
    int q;
    cin >> q;
    if(n <= 10) {
        if(q == 0) {
            ll ans = 0, cnt = n * (n + 1) / 2 - 1;
            for(int i = 0; i < n; ++i) {
                for(int j = i; j < n; ++j) {
                    if(!CAN(i, j) || !CAN(j, i)) {
                        cnt--;
                        continue;
                    }
                    if(i == j) {
                        ans += 1LL * (m + 1) * bp(M, cnt);
                        cnt--;
                        ans %= mod;
                        continue;
                    }
                    bool fnd = 0;
                    for(int ban = 0; ban < m; ++ban) {
                        if(!can(i, j, ban) || !can(j, i, ban)) {
                            ans += (ban + 1) * bp(M, cnt);
                            ans %= mod;
                            cnt--;
                            fnd = 1;
                            break;
                        }
                    }
                    if(!fnd) {
                        ans += 1LL * (m + 1) * bp(M, cnt);
                        cnt--;
                        ans %= mod;
                    }
                }
            }
            cout << ans;
            return 0;
        }
        ll cnt = q - 1, ans = 0;
        while (q --) {
            int i, j;
            cin >> i >> j;
            i--;
            j--;
            if(!CAN(i, j) || !CAN(j, i)) {
                cnt--;
                continue;
            }
            int res = m + 1;
            for(int ban = 0; ban < m; ++ban) {
                if(!can(i, j, ban) || !can(j, i, ban)) {
                    res = ban + 1;
                    break;
                }
            }
            ans += 1LL * res * bp(M, cnt);
            ans %= mod;
            cnt--;
        }
        cout << ans;
        return 0;
    }
    if(n <= 200 && q != 0) {
        ll cnt = q - 1, ans = 0;
        while (q --) {
            int i, j;
            cin >> i >> j;
            i--;
            j--;
            if(!CAN(i, j) || !CAN(j, i)) {
                cnt--;
                continue;
            }
            int res = m + 1;
            for(int ban = 0; ban < m; ++ban) {
                if(!can(i, j, ban) || !can(j, i, ban)) {
                    res = ban + 1;
                    break;
                }
            }
            ans += 1LL * res * bp(M, cnt);
            ans %= mod;
            cnt--;
        }
        cout << ans;
        return 0;
    }
    set <int> st[n];
    for(int i = 0; i < n; ++i) {
        queue <int> q;
        q.push(i);
        vector <bool> used(n, 0);
        used[i] = 1;
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            st[i].insert(v);
            for(auto to : g[v]) {
                if(!used[to.fi]) {
                    q.push(to.fi);
                    used[to.fi] = 1;
                }
            }
        }
    }
    if(q == 0) {
        ll ans = 0, cnt = n * (n + 1) / 2 - 1;
        for(int i = 0; i < n; ++i) {
            for(int j = i; j < n; ++j) {
                if(!st[i].count(j) || !st[j].count(i)) {
                    cnt--;
                    continue;
                }
                ans += (m + 1) * bp(M, cnt);
                ans %= mod;
                cnt--;
            }
        }
        cout << ans;
        return 0;
    }
    ll ans = 0, cnt = q - 1;
    while (q --) {
        int i, j;
        cin >> i >> j;
        --i;
        --j;
        if(!st[i].count(j) || !st[j].count(i)) {
            cnt--;
            continue;
        }
        ans += 1LL * (m + 1) * bp(M, cnt);
        ans %= mod;
        cnt--;
    }
    cout << ans;
}
