#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
#define fi first
#define se second
#define pb push_back
#define pii pair <int, int>
#define ll long long
#define ull unsigned long long
#define int int64_t

using namespace std;
const int INF = 2e18;
const int N = 5e3 + 50;
pii a[N], b[N];
int sum[N][N], clc[N][N];
bool used[N];
int n, m;

int calc (int a, int b) {
    return 1LL * abs(a - b);
}

int32_t main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    cin >> n;
    for(int i = 1; i <= n; ++i) {
        cin >> a[i].fi >> a[i].se;
    }
    cin >> m;
    for(int i = 1; i <= m; ++i) {
        cin >> b[i].fi >> b[i].se;
    }
    sort(a + 1, a + 1 + n);
    for(int i = 1; i <= m; ++i) {
        for(int j = 1; j <= n; ++j) {
            clc[i][j] = calc(a[j].fi, b[i].fi);
            clc[i][j] *= b[i].se;
            if(i) {
                sum[i][j] += sum[i - 1][j];
            } else {
                sum[i][j] = 0;
            }
            sum[i][j] += clc[i][j];
        }
    }
    vector <pii> ot(m + 1, {INF, 0});
    ot[0] = {0, 0};
    for(int i = 1; i <= m; ++i) {
        int dop = i;
        while (dop >= 1) {
            int now = ot[dop - 1].se;
            int uk = now + 1;
            bool f = 0;
            while (uk <= n) {
                if(b[dop].fi < a[uk].fi) {
                    f = 1;
                    break;
                }
                int now_sum = 0;
                now_sum += sum[i][uk];
                now_sum -= sum[dop - 1][uk];
                now_sum += ot[dop - 1].fi;
                now_sum += a[uk].se;
                if(now_sum < ot[i].fi) {
                    ot[i].fi = now_sum;
                    ot[i].se = uk;
                } else {
//                    cerr << now_sum << endl;
                }
                ++uk;
            }
            --dop;
//            cerr << f << endl;
        }
    }
    int now_uk = 0;
    for(auto to : ot) {
        if(!now_uk) {
            now_uk++;
            continue;
        }
        cout << to.fi << " ";
    }
    return 0;
}
