#include <iostream>
#include <vector>
using namespace std;
//use dp to know cheapest way with t kilometers
//add the students

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0); cerr.tie(0);
	int N, M;
	cin >> N;//the number of places that have buses for rent.
	vector<int> bus_dist(N, 0);
	vector<int> bus_cost(N, 0);
	for (int i = 0; i < N; i++)
	{
		int y;
		int c;
		cin >> y; //the distance from Shumen to the corresponding place in which a bus can be rent;
		cin >> c; //the cost for renting a bus in that place.
		bus_cost[i] = c;
		bus_dist[i] = y;
	}
	cin >> M;
	int max = 0; //max distance
	vector<int> students(M, 0);
	int v; //the amount of money that student needs for walking one kilometer. //for me is a const
	for (int i = 0; i < M; i++)
	{
		int x; //the distance from Shumen to the place where the corresponding student was sent on ethnographic expedition
		cin >> v;
		cin >> x;
		students[i] = x;

		if (x > max) {
			max = x;
		}
	}
	vector<long long> dp(max+1, 0);
	vector<long long> bus(max, -1);
	for (int i = 0; i < N; i++)
	{
		bus[bus_dist[i]] = bus_cost[i];
	}
	for (int i = 1; i <= max; i++)
	{
		if (bus[i] != -1) {
			dp[i] = min(dp[i - 1] + v, bus[i]);
		}
		else {
			dp[i] = dp[i - 1] + v;
		}
	}

	int sum = 0;
	for (int i = 0; i < M; i++)
	{
		sum += dp[students[i]];
		cout << sum << endl;
	}
}