#include <vector>
#include "sorting.h"
using namespace std;
//first i will find all prime between 0 to N// will take o(nlog n) // working
//then i will find the diffrence between p1 to p_i// will take o(nlogn) i hope so // i did
//then check if its negative or positive using the px<py
//then just orgenize // will take o(n)
vector <int> primes(int N)
{
	vector <int> prime;
	vector <bool> is_prime(N+1, 0);
	int pointer = 2;
	while (pointer <= N) {
		if (is_prime[pointer] == 0) {
			prime.push_back(pointer);
		}
		for (int i = 2; i * pointer <= N; i++)
		{
			is_prime[i * pointer] = 1;
		}
		pointer++;
	}
	return prime;
}


//|p1-pi|
int difference(int N, int i, vector<int> prime) {
	int dif = 1; //starting point
	int count = 0; //prime count
	while (count < prime.size() && N / dif >= prime[count])
	{
		for (int j = prime[count]; divisible(1, i, j); j = j * j) {
			dif *= prime[count];
		}
		count++;
	}
	return dif;
}
vector < int > solve(int N)
{
	vector<int> answer(N);
	vector<int> prime = primes(N);
	int max = 0;
	for (int i = 2; i <= N; i++)
	{
		int dif = difference(N, i, prime);
		if (compare(1, i)) {
			dif = -dif; //p1 > pi, dif = p1 - pi
		}
		answer[i - 1] = dif;
		if (dif > max) {
			max = dif;
		}
	}
	answer[0] = max + 1;
	for (int i = 2; i <= N; i++)
	{
		answer[i - 1] = -answer[i - 1] + answer[0];
	}
	return answer;
}

