#include <iostream>
#include <vector>
using namespace std;
const int mod = 1000000007;
int n, m;

vector<vector<int>> v;
vector<vector<bool>> d;

void dfs(int i, int x) {
	d[x][i] = true;
	for (int j : v[i]) {
		if (d[x][j]) {
			dfs(j, x);
		}
	}
}


int main() {
	cin >> n >> m;
	v.resize(n); d.resize(n);
	for (auto& i : d) i.resize(n);
	for (int i = 0; i < m; ++i) {
		int a, b; cin >> a >> b; a--; b--;
		v[a].push_back(b);
	}
	for (int i = 0; i < n; ++i) {
		dfs(i, i);
		}
	int q; cin >> q;
	long long ans = 0;
	vector<int> B(n);
	B[0] = 1;
	for (int i = 1; i < n; ++i) B[i] = (B[i - 1] * 200000) % mod;
	for (int i = 0; i < q; ++i) {
		int a, b; cin >> a >> b; a--; b--;
		if (d[a][b] && d[b][a]) {
			ans += (m + 1) * B[n - i - 1];
		}
		ans %= mod;
	}
	cout << ans;
}