#include<iostream>
#include<vector>

int main() {
	std :: ios_base::sync_with_stdio(false); std::cin.tie(NULL);
	long long n, m; std::vector<long long> y, c, x, v;
	std::cin >> n;
	for (long long i = 0; i < n; i++)
	{
		long long a, b; std::cin >> a >> b;
		y.push_back(a); c.push_back(b);
	}
	std::cin >> m;
	for (long long i = 0; i < m; i++)
	{
		long long a, b; std::cin >> a >> b;
		x.push_back(a); v.push_back(b);
	}
	std::vector<std::vector<long long>> dp (m, std::vector<long long>(n + 1,2e18));
	for (long long j = 0; j < n; j++)
	{
		if (y[j] <= x[0])
			dp[0][j] = v[0] * (x[0] - y[j]) + c[j];
	}
	dp[0][n] = dp[0][0];
	for (long long i = 1; i < n; i++)
	{
		dp[0][n] = std::min(dp[0][n], dp[0][i]);
	}
	for (long long i = 1; i < m; i++)
	{
		for (long long j = 0; j < n; j++)
		{
			if(y[j] <= x[i])
				dp[i][j] = v[i] * (x[i] - y[j]) + std::min(dp[i - 1][j], dp[i - 1][n] + c[j]);
		}
		dp[i][n] = dp[i][0];
		for (long long j = 1; j < n; j++)
		{
			dp[i][n] = std::min(dp[i][n], dp[i][j]);
		}
	}

	for (long long i = 0; i < m; i++)
	{
		std::cout << dp[i][n] << " ";
	}
}