#include<iostream>
#include<vector>

using namespace std;

int main() {
	ios_base::sync_with_stdio(false); cin.tie(NULL);
	
	long long n, m; vector<long long> y, c, x, v;
	cin >> n;
	for (long long i = 0; i < n; i++)
	{
		long long a, b; cin >> a >> b;
		y.push_back(a); c.push_back(b);
	}
	cin >> m;
	for (long long i = 0; i < m; i++)
	{
		long long a, b; cin >> a >> b;
		x.push_back(a); v.push_back(b);
	}

	vector<vector<long long>> dp(2, vector<long long>(n + 1, 2e18));
	vector<long long> res(m);
	for (long long j = 0; j < n; j++)
	{
		if (y[j] <= x[0])
			dp[0][j] = v[0] * (x[0] - y[j]) + c[j];
	}
	dp[0][n] = dp[0][0];
	for (long long i = 1; i < n; i++)
	{
		dp[0][n] = min(dp[0][n], dp[0][i]);
	}
	res[0] = dp[0][n];
	for (long long i = 1; i < m; i++)
	{
		for (long long j = 0; j <= n; j++)
		{
			dp[i % 2][j] = 2e18;
		}
		for (long long j = 0; j < n; j++)
		{
			if (y[j] <= x[i])
				dp[i % 2][j] = v[i] * (x[i] - y[j]) + min(dp[(i + 1) % 2][j], dp[(i + 1) % 2][n] + c[j]);
		}
		dp[i % 2][n] = dp[i % 2][0];
		for (long long j = 1; j < n; j++)
		{
			dp[i % 2][n] = min(dp[i % 2][n], dp[i % 2][j]);
		}
		res[i] = dp[i % 2][n];
	}

	for (long long i = 0; i < m; i++)
	{
		cout << res[i] << " ";
	}
	
}