//
//  main.cpp
//  problem 3
//
//  Created by Afek on 26/11/2022.
//

#include <iostream>
#include "sorting.h"
#include <math.h>
#include <algorithm>
#include <vector>
#include <numeric>
using namespace std;

vector<int> solve(int n){
    vector<int> dis;
    vector<int> primes;
    primes.push_back(2);
    primes.push_back(3);
    for (int i=4; i<n; i++) {
        bool prime=true;
        for (int j=0; (j<primes.size() && prime) && primes[j]*primes[j]<n; j++) {
            if (i%primes[j]==0) {
                prime=false;
            }
        }
        if (prime) {
            primes.push_back(i);
        }
    }
    int num=0;
    vector<pair<int, int>> loc;
    loc.resize(n, {-1,-1});
    dis.resize(n-1,1);
    for (int i=0; i<n-1; i++) {
        for (int j=0; j<primes.size() && dis[i]*primes[j]<n; j++) {
            int f=primes[j];
            while (divisible(1,i+2,f)) {
                dis[i]=dis[i]*primes[j];
                f=f*primes[j];
                if (f>n-1) {
                    break;;
                }
            }
            
        }
        num=max(num, dis[i]);
        if (loc[dis[i]].first==-1) {
            loc[dis[i]].first=i+2;
        }
        else{
            loc[dis[i]].second=i+2;
        }
    }
    vector<int> re;
    int first;
    if (compare(1,loc[num].first)) {
        dis[loc[num].second-2]=-num;
        first=n-num;
        num--;
        while (loc[num].second==-1) {
            num--;
        }
        for (num=num; num>0; num--) {
            if (compare(1,loc[num].first)) {
                dis[loc[num].second-2]=-num;
            }
            else{
                dis[loc[num].first-2]=-num;
            }
        }
    }
    else{
        dis[loc[num].first-2]=-num;
        first=1+num;
        while (loc[num].second==-1 && num>0) {
            num--;
            dis[loc[num].first-2]=-dis[loc[num].first-2];
        }
        for (num=num; num>0; num--) {
            if (compare(1,loc[num].first)) {
                dis[loc[num].second-2]=-num;
            }
            else{
                dis[loc[num].first-2]=-num;
            }
        }
    }
    re.push_back(first);
    for (int i=0; i<n-1; i++) {
        re.push_back(first+dis[i]);
    }
    return re;
}
