#include <iostream>
#include <vector>
#include <unordered_set>
#include <queue>
using namespace std;
using ll = long long int;
const ll mod = (ll) (1e9) +7;

ll bin_exp(ll a, ll b, ll m){
    ll res = 1;
    while (b){
        if (b&1) res = (res*a)%m;
        a= a*a % m;
        b/=2;
    }
    return res;
}

int main(){
    int n,m,a,b;
    cin>>n>>m;

    vector<unordered_set<int>> edges(n);
    vector<unordered_set<int>> road(n);
    for (int i=0; i<m; i++){
        cin>>a>>b; a--; b--;
        edges[a].insert(b);
    }

    for (int i=0; i<n; i++){
        queue<int> bfs;
        cout<<'a';
        bfs.push(i);road[i].insert(i);
        while (!bfs.empty()){
            for (auto j: edges[bfs.front()]){
                if (!road[i].count(j)) {bfs.push(j); road[i].insert(j);}
            }
            bfs.pop();
        }
    }



    int q;
    cin>>q;
    int k = (q)?q: (n*(n+1)/2);
    long long int res=0;
    int s = 0;
    if (q==0){
        for (int i=0; i<n; i++){
            for (int j=0; j<n; j++){
                s++;
                if (road[i].count(j) && road[j].count(i)) res+=bin_exp((ll)2e5, k-s, mod);
            }
        }
    }
    res*=(m+1);
    cout<<res;
}
