#include <iostream>
#include <unordered_set>
#include <vector>
#include "sorting.h"

using namespace std;

bool compare(int x, int y);
bool divisible(int x, int y, int d);

vector<int> solve(int n){
    vector<int> res(n,0);
    int bound = (n%2)?(n-2):(n-1);
    int a, b, m;
    int k, l;
    unordered_set<int> unv;
    for (int i=1; i<=n; i++) unv.insert(i);
    for (int i = 1; i<=bound; i+=2){
        a = (i+1)/2; b = n - (i-1)/2;
        m = n - i;
        bool f = 1;
        unordered_set<int> al = unv;
        for (auto x: unv){
            for (auto y: al){
                if (x==y) continue;
                if (divisible(x,y,m)){
                    if (compare(x,y)) {
                        res[x-1] = a;
                        res[y-1] = b;
                    } else {
                        res[x-1] = b;
                        res[y-1] = a;
                    }
                    unv.erase(x); unv.erase(y);
                    f = 0; break;
                }

            }
            al.erase(x);
            if (!f) break;
        }
    }
    if (!unv.empty()) for (auto x: unv) res[x-1] = (n+1)/2;
    return res;


}
