#include <iostream>
#include <unordered_set>
#include <vector>
#include "sorting.h"

using namespace std;

bool compare(int x, int y);
bool divisible(int x, int y, int d) ;

vector<int> solve(int n){
    vector<int> res(n,0);
    int bound = (n%2)?(n-2):(n-1);
    int a, b, m;
    bool f= 1;unordered_set<int> sm, bg;
    for (int i=1; i<=n-1; i+=2){
        if (compare(i, i+1)){
            sm.insert(i); bg.insert(i+1);
        } else {
            sm.insert(i+1); bg.insert(i);
        }
    }
    if (n&1){
        sm.insert(n);
        bg.insert(n);
    }
    f=0;
    for (auto x: sm){
        for (auto y: bg){
            if (x==y) continue;
            if (divisible(x,y,n-1)){
                a = x;
                b = y;
                res[a-1] = 1;
                res[b-1] = n;
                f = 1;
                break;
            }
        }
        if (f) break;
    }
    unordered_set<int> unv;
    for (int i=1; i<=n; i++){
        if (i!=a && i!=b){
            unv.insert(i);
        }
    }
    m = n-2;
    while (m>1){
        for (auto x: unv){
            if (divisible(a, x, m)){
                res[x-1] = m+1;
                unv.erase(x);
                m--;
                break;
            }
        }
    }
    for (auto x: unv) res[x-1] = 2;
    return res;


}
