/*
#include <iostream>
#include <vector>
#include <algorithm>

#include "sorting.h"

using namespace std;

// const int N = 1e5+10;
// int arr[N];

// bool divisible(int i, int j, int d)
// {
// 	if ((arr[i]-arr[j])%d==0)
// 		return 1;
// 	return 0;
// }

// bool compare(int x,int y)
// {
// 	if (arr[x] < arr[y])
// 		return 1;
// 	return 0;
// }

vector<int> solve(int N)
{
	int n = N;
	vector<pair<int,int>> diff;
	int paired[n+1];
	int d = (n+1)/2;
	bool mark[N+1][N+1];
	bool vis[N+1][N+1];
	vector<int> ans(n);
	for (int i=1; i<=N; i++)
		for (int j=1; j<=N; j++)
		{
			paired[j] = 0;
			mark[i][j] = 0;
			vis[i][j] = 0;
		}
	for (int i=1; i<=n; i++)
	{
		for (int j=1; j<=n; j++)
		{
			if (mark[i][j] or i==j)
				continue;
			if (divisible(i,j,d))
			{
				diff.push_back({i,j});
				mark[i][j] = 1;
				mark[j][i] = 1;	
			}
		}
	}
	for (int i=0; i<diff.size(); i++)
	{
		bool x = compare(diff[i].first, diff[i].second);
		if (!x)
			diff[i] = {diff[i].second, diff[i].first};
		paired[diff[i].first] = diff[i].second;
		paired[diff[i].second] = diff[i].first;
	}
	int last=diff[diff.size()-1].first;
	for (int i=0; i<diff.size(); i++)
	{
		for (int j=0; j<diff.size(); j++)
		{
			if (i==j)
				continue;
			if (divisible(diff[i].first,diff[j].second,d+1))
				break;
			// cout << "HERE" << endl;
			if (j==(diff.size()-1))
			{
				last = diff[i].first;
			}
		}
	}
	// cout << last << endl;
	// for (auto i:diff)
	// 	cout << i.first << " " << i.second << endl;
	int consec[N+1];
	for (int i=0; i<=n; i++)
		consec[i] = -1;
	for (int i=0; i<diff.size(); i++)
	{
		for (int j=0; j<diff.size(); j++)
		{
			if (i==j)
				continue;
			if (divisible(diff[i].first,diff[j].second,d+1))
				consec[diff[j].first] = diff[i].first;
		}
	}
	// for (int i=1; i<=n; i++)
	// 	cout << consec[i] << " ";
	// cout << endl;
	ans[last-1] = d-(n%2);
	while (consec[last]!=-1)
	{
		ans[consec[last]-1] = ans[last-1]-1;
		last = consec[last];
	}
	for (int i=0; i<n; i++)
	{
		if (ans[i]==0)
			ans[i] = ans[paired[i+1]-1]+d;
	}
	for (int i=0; i<n; i++)
		if (ans[i] == 0)
			ans[i] = d;
	// for (int i=0; i<n; i++)
	// 	cout << ans[i] << " ";
	// cout << endl;
	return ans;
}

// int main()
// {
// 	int n;
// 	cin >> n;
// 	for (int i=1; i<=n; i++)
// 		cin >> arr[i];
// 	solve(n);
// }
*/
#include <cstdio>
// #include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

#define ll long long

int main()
{
	ll n;
	scanf("%lld",&n);
	ll busd[n+1];
	ll busc[n+1];
	for (ll i=1; i<=n; i++)
	{
		scanf("%lld %lld",&busd[i],& busc[i]);
	}
	ll m;
	scanf("%lld",&m);
	ll boyd[m+1];
	ll boyc[m+1];
	busc[0] = busd[0] = boyd[0] = boyc[0] = 0;
	for (ll i=1; i<=m; i++)
	{
		scanf("%lld %lld", &boyd[i], &boyc[i]);
	}
	ll pref[m+1], ans[m+1];
	pref[0] = 0;
	ans[0] = 0;
	ll last = 0;
	for (ll i=1; i<=m; i++)
	{
		ans[i] = ans[i-1]+(boyd[i]-last)*boyc[i];
		ll s = upper_bound(busd,busd+n+1,last)-busd;
		ll e = upper_bound(busd,busd+n+1,boyd[i])-busd;
		// cout << boyd[i] << " : ";
		for (ll j=s; j<e; j++)
		{
			// cout << busd[j] << " ";
			if (busd[j]>boyd[i])
				break;
			ans[i] = min(ans[i], (boyd[i]-busd[j])*boyc[i]+busc[j]);
		}
		// cout << endl;
		last = boyd[i];
		// cout << s << " " << e << endl;
		pref[i] = pref[i-1]+ans[i];
		printf("%lld ", pref[i]);
	}
	printf("\n");

}