#include <iostream>
#include <vector>
using namespace std;

#define ll long long
ll const N=2e3+10;
ll const mul=2e5;
vector<ll> g[N];
bool vis[N][N];
ll mod=1e9+7;

ll power(ll n,ll e,ll mod)
{
	if(e==0)
		return 1;
	else if(e==1)
		return n%mod;
	else
	{
		if(e%2==0)
		{
			ll x=power(n,e/2,mod);
			return (x*x)%mod;
		}
		else
		{
			ll x=power(n,e/2,mod);
			return (((x*x)%mod)*n)%mod;
		}
	}
}

void dfs(ll v,ll u)
{
	vis[u][v]=true;
	for(ll i:g[v])
		if(!vis[u][i])
			dfs(i,u);
}

void solve()
{
	ll n,m;
	cin >> n >> m;
	for (ll i = 0; i < m; ++i)
	{
		ll u,v;
		cin >> u >> v;
		g[u].push_back(v);
	}
	for (ll i = 1; i <= n; ++i)
		dfs(i,i);
	ll q;
	cin >> q;
	if(q==0)
	{
		ll ans=0;
		ll K=(n*(n+1))/2;
		for (ll i = 1; i <= n; ++i)
			for (ll j = i; j <= n; ++j)
			{
				K--;
				if(!vis[i][j] or !vis[j][i])
					continue;
				else
				{
					// cout << ((m+1)%mod)*power(mul,K,mod)%mod << endl;
					ans+=((m+1)%mod)*power(mul,K,mod)%mod;
					ans%=mod;
				}
			}
		cout << ans%mod << endl;
		return;
	}
	ll K=q;
	ll ans=0;
	for (ll i = 0; i < q; ++i)
	{
		K--;
		ll a,b;
		cin >> a >> b;
		if(!vis[a][b] or !vis[b][a])
			continue;
		else
		{
			ans+=((m+1)%mod)*power(mul,K,mod)%mod;
			ans%=mod;
		}
	}
	cout << ans << endl;
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(NULL), cout.tie(NULL);
	// int t;
	// cin >> t;
	// while(t--)
		solve();
	return 0;
}