#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

const int N = 2005, mod = 1e9+7 , B = 2e5;
vector<int> G[N];
vector<int> v;
int n, m;
bool a[N][N] , vis[N];

int query(int x, int y)
{
  if(a[x][y]==true)
    return m+1;
  return 0;
}
vector<int> path;
void dfs(int s)
{
  vis[s] = true;
  for(int i:path)
    a[i][s] = a[s][i] = true;
  path.push_back(s);
  for(int i:G[s])
    if(!vis[i])
      dfs(i);
}

int main()
{
  cin>>n>>m;
  for(int i=0;i<m;i++)
    {
      int a, b;
      cin>>a>>b;
      G[a].push_back(b);
    }
  for(int i=1;i<=n;i++)
    if(!vis[i])
      dfs(i);
  int q;
  cin>>q;
  if(q==0)
    {
      for(int i=1;i<=n;i++)
	for(int j=i;j<=n;j++)
	  v.push_back(query(i,j));
    }
  else
    {
      while(q--)
	{
	  int a, b;
	  cin>>a>>b;
	  v.push_back(query(a,b));
	}
    }
  long long ans = 0, p = 1;
  reverse(v.begin() , v.end());
  for(int i:v)
    {
      ans += (i*p)%mod;
      ans%=mod;
      p*=B;
      p%=mod;
    }
  cout << ans << endl;
  return 0;
}
