#include<iostream>
#include<vector>
#include "sorting.h"
#include<set>

using namespace std;

vector<int> solve(int n)
{
  vector<int> ans(n , 0);
  set<int> ind;
  for(int i=1;i<=n;i++)
    ind.insert(i+1);

  int left = 1 , right = n;
  int d = n-1;
  while(right > left)
    {
      int one, two;
      for(int i:ind)
	for(int j:ind)
	  if(i!=j)
	    {
	      if(divisible(i, j , d))
		{
		  one = i;
		  two = j;
		  break;
		}
	    }
      if(compare(one , two))
	{
	  ans[one-1] = left;
	  ans[two-1] = right;
	}
      else
	{
	  ans[one-1] = right;
	  ans[two-1] = left;
	}
      right--;
      left--;
      ind.erase(one);
      ind.erase(two);
      d = right-left;
    }
  if(left==right)
    ans[(*ind.begin())-1] = left;
  return ans;
}
