#include<iostream>
#include<vector>
#include "sorting.h"
#include<set>

using namespace std;

/*const int N = 1e5+5;
int a[N];

bool compare(int x, int y)
{
  return a[x]<a[y];
}
bool divisible(int x, int y, int d)
{
  return (((a[x]-a[y])%d)==0);
  }*/

vector<int> solve(int n)
{
  vector<int> ans(n , 0);
  set<int> ind;
  for(int i=1;i<=n;i++)
    ind.insert(i);

  int left = 1 , right = n;
  int d = n-1;
  while(right > left)
    {
      int one, two;
      for(int i:ind)
	for(int j:ind)
	  if(i!=j)
	    {
	      if(divisible(i, j , d))
		{
		  one = i;
		  two = j;
		  break;
		}
	    }
      if(compare(one , two))
	{
	  ans[one-1] = left;
	  ans[two-1] = right;
	}
      else
	{
	  ans[one-1] = right;
	  ans[two-1] = left;
	}
      right--;
      left++;
      ind.erase(one);
      ind.erase(two);
      d = right-left;
    }
  if(ind.size())
    {
      int x = *ind.begin();
      x--;
      ans[x] = left;
    }
  return ans;
}
/*int main()
{
  int n;
  cin>>n;
  for(int i=1;i<=n;i++)
    cin>>a[i];
  vector<int> v = solve(n);
  for(int i:v)
    cout<<i<<" ";
  cout<<endl;
  return 0;
  }*/
