#include<bits/stdc++.h>
#define fastio ios_base::sync_with_stdio(0); cin.tie(0);
#define sz(x) ll(x.size())
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> ii;
typedef pair<ll,ii> tri;
const ll mod=1e9+7;
vector<ii> gfo[210];
vector<ii> aristas;
map<ll,bool> valid;
bool vst[210];
ll n, m;
void bfs(ll ini){
    queue<ll> q;
    q.push(ini);
    vst[ini]=true;
    while(sz(q)){
        ll u=q.front();
        q.pop();
        for(ii y:gfo[u]){
                ll v=y.first;
                ll w=y.second;
            if(!vst[v] and valid[w]){
                q.push(v);
                vst[v]=true;
            }
        }
    }
}
void clean(){
    for(ll i=1; i<=n; i++){
        vst[i]=false;
    }
}
ll ans1=1e18;
ll consulta(ll u, ll v){
    ans1=1e18;
    ll cont=0;
    bfs(u);
    if(vst[v]==false) return 0;
    clean();
    bfs(v);
    if(vst[u]==false) return 0;
    clean();
    for(ll i=0; i<sz(aristas); i++){
        valid[i+1]=false;
        bfs(u);
        if(vst[v]==false){
            if(i+1<ans1){
                ans1=i+1;
            }
        }
        else cont++;
        clean();
        bfs(v);
        if(vst[u]==false){
            if(i+1<ans1){
                ans1=i+1;
            }
        }
        else cont++;
        clean();
        valid[i+1]=true;
    }
    if(cont==sz(aristas)*2){
        return m+1;
    }
    else{
        return ans1;
    }
}
ll binpow(ll base, ll expo){
    if(expo==0) return 1;
    ll aux=binpow(base, expo/2);
    if(expo%2){
        return (((aux*aux)%mod)*base)%mod;
    }
    else{
        return ((aux*aux)%mod);
    }
}
int main(){
    fastio;
    cin>>n>>m;
    for(ll i=0; i<m; i++){
        ll a, b;
        cin>>a>>b;
        gfo[a].push_back({b,i+1});
        aristas.push_back({a,b});
        valid[i+1]=true;
    }
    ll q;
    cin>>q;
    ll B=2*100000;
    ll k=q;
    ll noc=1;
    ll ans=0;
    for(ll i=0; i<q; i++){
        ll u, v;
        cin>>u>>v;
        ll w=consulta(u,v);
        ll aux=binpow(B,k-noc);
        noc++;
        ans+=(w*aux)%mod;
        ans%=mod;
    }
    cout<<ans<<"\n";
}
