#include <iostream>
using namespace std;
const int nmax = 10;
const int mmax = 6;
const long long oo = 2000000000000000000LL;
long long dp[nmax + 1];
long long dp_min[nmax + 1];

struct autocar {
    int poz; long long cost;
} a[nmax + 1];

struct copil {
    int poz; int cost;
} c[mmax + 1];

static inline long long minim ( const long long &a, const long long &b ) {
    return a < b ? a : b;
}

int main() {
    int n, m;
    cin >> n;
    for ( int i = 1; i <= n; i++ )
        cin >> a[i].poz >> a[i].cost;
    cin >> m;
    for ( int i = 1; i <= m; i++ )
        cin >> c[i].poz >> c[i].cost;

    for ( int i = 0; i <= n; i++ )
        dp_min[i] = 0, dp[i] = oo;

    dp[0] = 0;
    for ( int i = 1; i <= m; i++ ) {
        int X = c[i].poz;
        int V = c[i].cost, pozz = 0;
        dp[0] = dp[0] + ( long long ) X * V;
        for ( int j = 1; j <= n && a[j].poz <= X; pozz = j, j++ ) {
            dp[j] = minim ( dp_min[j - 1] + a[j].cost + ( long long ) ( X - a[j].poz ) * V,
                          dp[j] + ( long long ) ( X - a[j].poz ) * V );
        }
        dp_min[0] = dp[0];
        for ( int j = 1; j <= n; j++ )
            dp_min[j] = minim ( dp_min[j - 1], dp[j] );
        cout << dp_min[pozz] << ' ';
    }


    return 0;
}
