#include <iostream>
using namespace std;
const long long nmax = 10;
const long long mmax = 6;
const long long oo = 2000000000000000000LL;
long long dp[nmax + 1];
long long dp_min[nmax + 1];
long long sol[nmax + 1];

struct autocar {
    long long poz; long long cost;
} a[nmax + 1];

struct copil {
    long long poz; long long cost;
} c[mmax + 1];

static inline long long minim ( const long long &a, const long long &b ) {
    return a < b ? a : b;
}

int main() {
    long long n, m;
    cin >> n;
    for ( long long i = 1; i <= n; i++ ) {
        assert ( 1 <= i && i <= n );
        cin >> a[i].poz >> a[i].cost;
    }
    cin >> m;
    for ( long long i = 1; i <= m; i++ ) {
        assert ( 1 <= i && i <= m );
        cin >> c[i].poz >> c[i].cost;
    }

    for ( long long i = 0; i <= n; i++ ) {
        assert ( 0 <= i && i <= n );
        dp_min[i] = 0, dp[i] = oo;
    }

    dp[0] = 0;
    for ( long long i = 1; i <= m; i++ ) {
        long long X = c[i].poz;
        long long V = c[i].cost, pozz = 0;
        dp[0] = dp[0] + ( long long ) X * V;
        for ( long long j = 1; j <= n && a[j].poz <= X; pozz = j, j++ ) {
            dp[j] = minim ( dp_min[j - 1] + a[j].cost + ( long long ) ( X - a[j].poz ) * V,
                          dp[j] + ( long long ) ( X - a[j].poz ) * V );
            assert ( 0 <= j && j <= n && j - 1 >= 0 && X - a[j].poz >= 0 && V >= 1 );
        }
        dp_min[0] = dp[0];
        long long ans = dp[0];
        for ( long long j = 1; j <= n; j++ ) {
            if ( X >= a[j].poz )
                ans = minim ( ans, dp[j] );
            dp_min[j] = minim ( dp_min[j - 1], dp[j] );
            assert ( j - 1 <= n && j <= n && j - 1 >= 0 && j >= 0 );
        }
        assert ( 0 <= pozz && pozz <= n );
        sol[i] = ans;
    }

    for ( int i = 1; i <= m; i++ )
        cout << sol[i] << ' ';


    return 0;
}