#include <iostream>
using namespace std;
const long long nmax = 2e4;
const long long mmax = 1e3;
const long long oo = 2000000000000000000LL;
long long dp[nmax + 1];
long long dp_min[nmax + 1];
long long sol[nmax + 1];

struct autocar {
    long long poz; long long cost;
} a[nmax + 1];

struct copil {
    long long poz; long long cost;
} c[mmax + 1];

static inline long long minim ( const long long &a, const long long &b ) {
    return a < b ? a : b;
}

int main() {
    long long n, m;
    cin >> n;
    for ( long long i = 1; i <= n; i++ ) {
        cin >> a[i].poz >> a[i].cost;
    }
    cin >> m;
    for ( long long i = 1; i <= m; i++ ) {
        cin >> c[i].poz >> c[i].cost;
    }

    for ( int i = 1; i <= n; i++ )
        dp[i] = oo;
    int poz = 0;
    for ( int j = 1; j <= n && c[1].poz >= a[j].poz; poz = j, j++ )
        dp[j] = a[j].cost + ( long long ) ( c[1].poz - a[j].poz ) * c[1].cost;

    dp_min[1] = dp[1];
    for ( int i = 2; i <= n; i++ )
        dp_min[i] = minim ( dp_min[i - 1], dp[i] );

    sol[1] = dp_min[poz];


    for ( long long i = 2; i <= m; i++ ) {
        long long X = c[i].poz;
        long long V = c[i].cost;
        dp[1] = dp[1] + ( long long ) ( X - a[1].poz ) * V;
        for ( long long j = 2; j <= n && a[j].poz <= X; j++ )
            dp[j] = minim ( dp[j] + ( long long ) ( X - a[j].poz ) * V, dp_min[j - 1] + a[j].cost + ( long long ) ( X - a[j].poz ) * V );

        dp_min[1] = dp[1];
        long long ans = dp[1];
        for ( long long j = 2; j <= n; j++ ) {
            if ( X >= a[j].poz )
                ans = minim ( ans, dp[j] );
            dp_min[j] = minim ( dp_min[j - 1], dp[j] );
        }
        sol[i] = ans;
    }

    for ( int i = 1; i <= m; i++ )
        cout << sol[i] << ' ';


    return 0;
}
