#include <iostream>
#include <map>
using namespace std;
const long long nmax = 1e5;
const long long mmax = 1e5;
const long long oo = 2000000000000000000LL;

struct autocar {
    long long poz; long long cost;
} a[nmax + 1];

struct copil {
    long long poz; long long cost;
} c[mmax + 1];

static inline long long maxim ( const long long &a, const long long &b ) {
    return a > b ? a : b;
}

map < int, int > norm;
int norma[nmax + 1];
int normc[mmax + 1];

struct aib {
    long long aib[2 * nmax];
    int N;
    void update ( int poz, long long val ) {
        for ( ; poz <= N; poz += poz & -poz )
            aib[poz] = maxim ( aib[poz], val );
    }
    long long query ( int poz ) {
        long long rez;
        for ( ; poz > 0; poz -= poz & -poz )
            rez = maxim ( rez, aib[poz] );
        return rez;
    }
}aib;

int main() {
    long long n, m;
    cin >> n;

    for ( long long i = 1; i <= n; i++ )
        cin >> a[i].poz >> a[i].cost, norm[a[i].poz] = 1;

    cin >> m;
    for ( long long i = 1; i <= m; i++ )
        cin >> c[i].poz >> c[i].cost, norm[c[i].poz] = 1;

    int cheie = 0;
    for ( pair < int, int > x: norm )
        norm[x.first] = ++cheie;
    aib.N = cheie;

    for ( int i = 1; i <= n; i++ )
        norma[i] = norm[a[i].poz];
    for ( int i = 1; i <= m; i++ )
        normc[i] = norm[c[i].poz];

    int V = c[1].cost;
    for ( int i = 1; i <= n; i++ ) {
        aib.update ( norma[i], ( long long ) a[i].poz * V - a[i].cost );
      ///  cout << norma[i] << ' ' << -a[i].poz * V +  a[i].cost << '\n';
    }
    long long s = 0;
    for ( int i = 1; i <= m; i++ ) {
        s += ( long long ) c[i].poz * V - aib.query ( normc[i] );
        cout << s << ' ';
    }

    return 0;
}
