#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <cmath>
#define ll long long
#define pii pair <int, int>
#define x first
#define y second
#pragma GCC optimize("Ofast")
#define int ll

using namespace std;

const ll INF = (ll) 1e18;

int n, m;

int dp[1 << 14][105], y[105], c[105], x[105], v[105];

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> y[i] >> c[i];
    cin >> m;
    for (int i = 1; i <= m; i++)
        cin >> x[i] >> v[i];

    for (int i = 0; i <= m; i++) {
        for (int mask = 0; mask < (1 << n); mask++)
            dp[i][mask] = INF;
    }
    dp[0][0] = 0;

    for (int i = 1; i <= m; i++) {
        for (int mask = 1; mask < (1 << n); mask++) {
            for (int j = 1; j <= n; j++) {
                if (!(mask & (1 << (j - 1))))
                    continue;
                if (x[i] < y[j])
                    continue;

                int cost = (x[i] - y[j]) * v[i];
                dp[i][mask] = min(dp[i - 1][mask] + cost, dp[i - 1][mask ^ (1 << (j - 1))] + cost + c[j]);
            }
        }
    }
    
    for (int i = 1; i <= m; i++) {
        ll ans = INF;
        for (int mask = 1; mask < (1 << n); mask++)
            ans = min(ans, dp[i][mask]);
        cout << ans << " ";
    }

    return 0;
}