#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <cmath>
#define ll long long
#define pii pair <int, int>
#define x first
#define y second
#pragma GCC optimize("Ofast")
#define int ll

using namespace std;

const ll INF = (ll) 1e18;

int n, m;

int dp[20005], y[20005], c[20005], x[20005], v[20005];
int mn[20005];

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> y[i] >> c[i];
    cin >> m;
    for (int i = 1; i <= m; i++)
        cin >> x[i] >> v[i];

    for (int j = 1; j <= n; j++)
        dp[j] = INF;
    for (int i = 1; i <= m; i++)
        mn[i] = INF;

    for (int i = 1; i <= n; i++) {
        if (y[i] > x[1])
            break;

        dp[i] = (x[1] - y[i]) * v[1] + c[i];
        mn[1] = min(mn[1], dp[i]);
    }

    for (int i = 2; i <= m; i++) {
        int a = INF;
        dp[0] = INF;
        for (int j = 1; j <= n; j++) {
            if (y[j] > x[i])
                 break;
            int b = dp[j]; // dp[i - 1][j]
            int ca = a; // min({dp[1], dp[2], .., dp[j - 1]
            a = min(a, dp[j]); // min(dp[1],...dp[j])
            dp[j] = ca;

            dp[j] = dp[j] + (x[i] - y[j]) * v[i] + c[j];
            dp[j] = min(dp[j], b + (x[i] - y[j]) * v[i]);
            mn[i] = min(mn[i], dp[j]);
        }
    }
    for (int i = 1; i <= m; i++) {
        cout << mn[i] << " ";
    }

    return 0;
}
