#include "sorting.h"
#include <vector>
#include <queue>
///#include <iostream>
using namespace std;

int getDif(int a, int b, int n) {
    int d = n - 1;
    while (!divisible(a, b, d))
        d--;
    return d;
}

void inserte(vector<int> &sol, int poz, int x) {
    sol.push_back(0);
    for (int i = sol.size() - 1; i > poz; i--)
        sol[i] = sol[i - 1];
    sol[poz] = x;
}

/*void printSol(vector<int> sol) {
    for (int a: sol)
        cout << a << ' ';
}*/

vector<int> solve(int n) {
    vector<int> arr, sol;
    for (int i = 1; i <= n; i++)
        arr.push_back(i);
    int deriv = 0;
    while (!arr.empty()) {
        if (arr.size() == 1) {
            inserte(sol, deriv, arr[0]);
            break;
        }
        int difmax = 0, pozi, pozj;
        for (int i = 0; i < arr.size(); i++)
            for (int j = i + 1; j < arr.size(); j++) {
                int dif = getDif(arr[i], arr[j], n);
                if (dif > difmax) {
                    difmax = dif;
                    pozi = i;
                    pozj = j;
                }
            }
        bool aux = compare(arr[pozi], arr[pozj]);
        if (!aux)
            swap(arr[pozi], arr[pozj]);
        inserte(sol, deriv, arr[pozi]);
        inserte(sol, sol.size() - deriv, arr[pozj]);
        arr.erase(arr.begin() + pozj);
        arr.erase(arr.begin() + pozi);
        deriv++;
    }
    //printSol(sol);
    return sol;
}