#include <bits/stdc++.h>
#define NMAX 2000
#define MMAX 100000
#define BASE 200000
#define MOD 1000000007
#define int64 long long
#pragma ("O3")

using namespace std;

struct strson {
  int node, index;
};


bool f[NMAX + 1];
vector <strson> vsons[NMAX + 1];
bool is_active[MMAX + 1];
stack <int> vctc;
vector <int> vmyctct[NMAX + 1];
int vlevel[NMAX + 1];
int vhigh[NMAX + 1];
set < pair <int, int> > vset;

void find_ctc(int node, int level) {
  f[node] = 1;
  vctc.push(node);

  int i, j, nsons;

  vlevel[node] = level;
  nsons = vsons[node].size();
  vhigh[node] = node;
  vlevel[node] = level;

  for (i = 0; i < nsons; i++) {
    int newnode = vsons[node][i].node;
    if (f[newnode] == 0) {
      find_ctc(newnode, level + 1);
      if (vlevel[vhigh[newnode]] < vlevel[vhigh[node]])
        vhigh[node] = vhigh[newnode];
    }
    else {
      if (vmyctct[node].size() == 0 && vlevel[vhigh[newnode]] < vlevel[vhigh[node]])
        vhigh[node] = vhigh[newnode];
    }
  }

  if (vhigh[node] == level) {
    vector <int> vcrtctc;
    vcrtctc.push_back(node);
    while (!vctc.empty() && vctc.top() != node) {
      vcrtctc.push_back(vctc.top());
      vctc.pop();
    }
    vctc.pop();

    for (i = 0; i < vcrtctc.size(); i++) {
      for (j = i; j < vcrtctc.size(); j++) {
        vset.insert({vcrtctc[i], vcrtctc[j]});
        vset.insert({vcrtctc[j], vcrtctc[i]});
      }
    }
  }
}

signed main() {
  #ifdef iati
    freopen("a.in", "r", stdin);
    freopen("a.out", "w", stdout);
  #endif // iati

  ios_base::sync_with_stdio(NULL);
  cin.tie(0);
  cout.tie(0);

  int n, m, i, x, y, q, j, node1, node2, crtsol;
  int64 sol;
  cin >> n >> m;

  for (i = 0; i < m; i++) {
    cin >> x >> y;
    vsons[x].push_back({y, i});
    is_active[i] = 1;
  }

  for (i = 1; i <= n; i++) {
    if (f[i] == 0) {
      vsons[0].push_back({i, -1});
      find_ctc(i, 1);
    }
  }

  cin >> q;
  if (q == 0) {
    for (i = 1; i <= n; i++) {
      for (j = i; j <= n; j++) {
        if (vset.find({i, j}) != vset.end())
          crtsol = m + 1;
        else
          crtsol = 0;
        sol = ((int64)sol * BASE + crtsol) % MOD;
        //cout << crtsol << " ";
      }
    }
  }
  else {
    while (q--) {
      cin >> node1 >> node2;
      if (vset.find({node1, node2}) != vset.end())
          crtsol = m + 1;
      else
        crtsol = 0;
      sol = ((int64)sol * BASE + crtsol) % MOD;
      cout << crtsol << " ";
    }
  }

  cout << sol;
  return 0;
}
