#include <bits/stdc++.h>
#define NMAX 20000
#define MMAX 1000
#pragma ("O3")
#define int64 long long

using namespace std;

struct hatz {
  int poz;
  int64 cost;
};

hatz vbus[NMAX + 1], vstudent[MMAX + 1];
int64 sp_prod[NMAX + 1], sp_cost[NMAX + 1];
int64 dp[MMAX + 1][NMAX + 1];

int bs(int st, int dr, int val) {
  int sol, mij;

  while (st <= dr) {
    mij = (st + dr) / 2;
    if (vstudent[mij].poz >= val) {
      sol = mij;
      dr = mij - 1;
    }
    else
      st = mij + 1;
  }

  return sol;
}

signed main() {
  #ifdef iati
    freopen("a.in", "r", stdin);
    freopen("a.out", "w", stdout);
  #endif // iati

  ios_base::sync_with_stdio(NULL);
  cin.tie(0);
  cout.tie(0);

  int n, m, i, j, v;

  cin >> n;
  for (i = 1; i <= n; i++) {
    cin >> vbus[i].poz >> vbus[i].cost;
  }

  cin >> m;
  for (i = 1; i <= m; i++) {
    cin >> vstudent[i].poz >> vstudent[i].cost;
    sp_prod[i] = sp_prod[i - 1] + vstudent[i].poz * vstudent[i].cost;
    sp_cost[i] = sp_cost[i - 1] + vstudent[i].cost;
  }

  for (i = 1; i <= m; i++) {
    dp[i][0] = LLONG_MAX;
    for (j = 1; j <= n && vstudent[i].poz >= vbus[j].poz; j++) {
      int a = bs(1, m, vbus[j].poz);
      int b = i;
      //cout << i << " " << j << ": " << a << " " << b << "\n";

      int64 val = (sp_prod[b] - sp_prod[a - 1]) - (sp_cost[b] - sp_cost[a - 1]) * vbus[j].poz + vbus[j].cost;
      val += dp[a - 1][j - 1];

      dp[i][j] = min(dp[i][j - 1], val);
    }

    for (; j <= n; j++)
      dp[i][j] = dp[i][j - 1];

    cout << dp[i][n] << " ";
  }
  return 0;
}
