#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("O3")

using namespace std;

int n,m,q;
int ans[2005][2005];
vector<int>v[2005];
int badx,bady;
vector<pair<int,int>>edges;
bool pot[2005][2005],pot0[2005][2005],viz[2005];
vector<pair<int,int>>queries;

void DFS(int pos)
{
    viz[pos] = true;
    for (int i = 0; i < v[pos].size(); i++)
        if (!viz[v[pos][i]] and (pos != badx or v[pos][i] != bady))
            DFS(v[pos][i]);
}

void brute(int index,int job)
{
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= n; j++)
            pot[i][j] = false;
    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= n; j++)
            viz[j] = false;
        DFS(i);
        for (int j = 1; j <= n; j++)
            pot[i][j] = viz[j];
    }
    if (job == 0)
        for (int i = 1; i <= n; i++)
            for (int j =1; j <= n; j++)
                pot0[i][j] = false;
    if (job == 1)
        for (int i = 1; i <= n; i++)
            for (int j = 1; j <= n; j++)
                if ((pot[i][j] == false or pot[j][i] == false) and pot0[i][j] == true and ans[i][j] == 0)
                    ans[i][j] = ans[j][i] = index;
    else
        for (int i = 1; i <= n; i++)
            for (int j = 1; j <= n; j++)
                if (pot[i][j] == true or pot[j][i] == true)
                    pot0[i][j]= pot0[j][i] = true;
}

void prec()
{
    brute(0,0);
    for (int i = 0; i < edges.size(); i++)
    {
        badx = edges[i].first;
        bady = edges[i].second;
        brute(i + 1,1);
    }
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
            if (ans[i][j] == 0 and pot0[i][j] == true)
                ans[i][j] = m + 1;
}

int main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(NULL);
    //cout.tie(NULL);
    cin >> n >> m;
    for (int i = 1; i <= m; i++)
    {
        int x,y;
        cin >> x >> y;
        v[x].push_back(y);
        edges.push_back({x,y});
    }
    prec();
    /*for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= n; j++)
            cout << ans[i][j] << ' ';
        cout << '\n';
    }*/
    cin >> q;
    if (q != 0)
    {
        for (int i = 1; i <= q; i++)
        {
            int x,y;
            cin >> x >> y;
            queries.push_back({x,y});
        }
    }
    else
    {
        for (int i = 1; i <= n; i++)
            for (int j = i; j <= n; j++)
                queries.push_back({i,j});
    }
    long long b = 1,rsp = 0,modulo = 1000000007;
    for (int i = queries.size() - 1; i >= 0; i--)
    {
        rsp = (rsp + ans[queries[i].first][queries[i].second] * b) % modulo;
        b = b * 200000ll % modulo;
    }
    cout << rsp;
    return 0;
}
