/// solutie subtask 1
/// O(Q*N*M)
#include <iostream>
#include <vector>
#include <cstring>
#include <map>
#define B   200000
#define MOD 1000000007
#define MAX 2002
#define int long long
using namespace std;
int n,m,q,vf[MAX],x,y,mcx,mcy,dp[MAX][MAX];
vector<int> v[MAX];
vector< pair<int, int> > muchii;
map< pair<int, int>, int > sm;
int sol;
/// mcx,mcy = muchia stearsa
/// dp[i][j] = exista drum de la i la j

int lgpow(int n, int a){
    if(a == 0){
        return 1;
    }else{
        if(a%2 == 0){
            int val = lgpow(n, a/2)%MOD;
            return (val*val)%MOD;
        }else{
            return ((n%MOD)*(lgpow(n, a-1)%MOD))%MOD;
        }
    }
}

void dfs(int nod){
    vf[nod] = 1;
    for(int i = 0; i < v[nod].size(); i++){
        int vecin = v[nod][i];
        if( !(nod == mcx && vecin == mcy) && vf[vecin] == 0){
            dfs(vecin);
        }
    }
}

bool exist_path(int nod, int dest){
    /// exista drum de la nod la dest
    memset(vf, 0, sizeof(vf));
    dfs(nod);
    if(vf[dest] != 1){
        return false;
    }
    /// exista drum de la dest la nod
    memset(vf, 0, sizeof(vf));
    dfs(dest);
    return vf[nod];
}

void query(int x, int y){
    int ans;
    mcx = mcy = 0;
    if(exist_path(x, y)){
        /*bool found = false;
        for(int i = 0; i < muchii.size(); i++){
            pair<int, int> sters = muchii[i]; /// muchia stearsa
            if(sm[sters] > 1){
                /// mai exista aceasi muchie
                /// deci nu are niciun efect stergerea
                continue;
            }
            mcx = sters.first; mcy = sters.second;
            //cout << mcx << ", " << mcy << " = " << exist_path(x, y) << "\n";
            if(!exist_path(x, y)){
                ans = i+1;
                found = true;
                break;
            }
        }
        if(!found){
            ans = m+1;
            //cout << "nu se poate sterge nimic\n";
        }*/
        ans = m+1;
    }else{
        /// ans = 0;
        ans = 0;
    }
    //cout << ans;
    sol += (ans*lgpow(B, q))%MOD;
    if(sol > MOD){
        sol -= MOD;
    }
}

void solve(){
    cin >> x >> y;
    query(x, y);
}

int makedp(int nod, int root){
    dp[root][nod] = 1;
    vf[nod] = 1;
    for(int i = 0; i < v[nod].size(); i++){
        int vecin = v[nod][i];
        if(vf[vecin] == 0){
            makedp(vecin, root);
        }
    }
}

signed main()
{
    cin >> n >> m;
    int cm = m;
    while(m--){
        cin >> x >> y;
        v[x].push_back(y);
        pair<int, int> tmp;
        tmp.first = x; tmp.second = y;
        muchii.push_back(tmp);
        sm[tmp]++;
    }
    m = cm;
    cin >> q;
    if(q != 0){
        while(q--){
            solve();
        }
    }else{
        /// toate
        q = n*(n+1)/2;
        for(int i = 1; i <= n; i++){
            memset(vf, 0, sizeof(vf));
            //makedp(i, i);
        }
        for(int i = 1; i <= n; i++){
            for(int j = i; j <= n; j++){
                int ans = 0;
                if(dp[i][j] == 1 && dp[j][i] == 1){
                    ans = m+1;
                }
                q--;
                sol += (ans*lgpow(B, q))%MOD;
                if(sol > MOD){
                    sol -= MOD;
                }
            }
            //cout << "\n";
        }
    }
    cout << sol;
    return 0;
}
/**
8 17
5 2
6 5
4 6
4 8
4 3
3 1
2 7
7 4
5 4
8 7
8 3
3 6
6 1
2 4
1 5
1 5
5 2
1
4 6

**/
