#include <iostream>
#include <fstream>
#include <cmath>
#include <cstring>

#define DIM 10

using namespace std;
ifstream f("in.in");

typedef int nrMare[1005];
int n,m;
nrMare y[DIM+5],x[DIM+5],c[DIM+5],v[DIM+5];

void equals(nrMare &a,nrMare b){
    a[0] = b[0];
    for(int i=1;i<=a[0];i++){
        a[i] = b[i];
    }
}

bool biggerCheck(nrMare a,nrMare b){
    if(a[0]>b[0]){
        return 1;
    }else if(a[0]<b[0]){
        return 0;
    }else{
        for(int i=a[0];i>=1;i--){
            if(a[i] > b[i]){
                return 1;
            }else if(a[i] < b[i]){
                return 0;
            }
        }

        return 0;
    }
}

void reset(nrMare &a){
    a[0] = 1;
    a[1] = 0;
}

void read(nrMare &a){

    char s[1005];
    cin>>s;

    a[0] = strlen(s);
    for(int i=0;i<a[0];i++){
        a[a[0]-i] = s[i] - '0';
    }
}

void write(nrMare a){
    for(int i=a[0];i>=1;i--){
        cout<<a[i];
    }
}

void add(nrMare &r, nrMare a,nrMare b){
    r[0] = max(a[0],b[0]);
    for(int i=a[0]+1;i<=r[0];i++)a[i]=0;
    for(int i=b[0]+1;i<=r[0];i++)b[i]=0;

    int t=0;
    for(int i=1;i<=r[0];i++){
        t = t + a[i] + b[i];
        r[i] = t%10;
        t/=10;
    }
    while(t!=0){
        r[++r[0]] = t%10;
        t/=10;
    }
}

void sub(nrMare &r, nrMare a,nrMare b){
    r[0] = max(a[0],b[0]);

    //for(int i=a[0]+1;i<=r[0];i++)a[i]=0;
    //for(int i=b[0]+1;i<=r[0];i++)b[i]=0;

    for(int i=1;i<=r[0];i++){
        r[i] = a[i]-b[i];
        while(r[i]<0){
            r[i]+=10;
            a[i+1]--;
        }
    }
    for(int i=r[0];r[i] == 0 && r[0]>1;i--){
        r[0]--;
    }
}

void prod(nrMare &r, nrMare a,nrMare b){
    r[0] = a[0]+b[0]-1;
    for(int i=1;i<=r[0];i++){
        r[i] = 0;
    }

    for(int i=1;i<=a[0];i++){
        for(int j=1;j<=b[0];j++){
            r[i+j-1] = a[i] * b[j];
        }
    }

    int t=0;
    for(int i=1;i<=r[0];i++){
        t = r[i];
        r[i] = t%10;
        t/=10;
    }
    while(t!=0){
        r[++r[0]] = t%10;
        t/=10;
    }
}

int val[DIM+5];
int cnt[DIM+5];
nrMare sol,tmpsol;

void gen(int nMax,int pas){

    if(pas == nMax+1){
        reset(tmpsol);

        for(int i=1;i<=nMax;i++){
            nrMare dif;
            if(biggerCheck(y[val[i]],x[i])){
                return;
                //sub(dif,y[val[i]],x[i]);
            }else{
                sub(dif,x[i],y[val[i]]);
            }


            nrMare p;
            prod(p,dif,v[i]);


            nrMare s;
            add(s,tmpsol,p);


            equals(tmpsol,s);

        }

        for(int i=1;i<=n;i++){
            if(cnt[i]!=0){
                nrMare s;
                add(s,tmpsol,c[i]);
                equals(tmpsol,s);
            }
        }

        //write(tmpsol);cout<<'\n';
        if((sol[0] == 1 && sol[1] == 0) || biggerCheck(sol,tmpsol)){
            equals(sol,tmpsol);
        }
    }else{

        for(int i=1;i<=n;i++){
            val[pas] = i;
            cnt[i]++;
            gen(nMax,pas+1);
            cnt[i]--;
        }

    }

}

int main()
{
    /*read(x[1]);
    read(y[1]);
    nrMare dif;
    sub(dif,x[1],y[1]);
    write(dif);*/

    cin>>n;
    for(int i=1;i<=n;i++){
        read(y[i]);
        read(c[i]);

        //cout<<biggerCheck(y[i],c[i])<<" ";
    }
    //cout<<'\n';
    cin>>m;
    for(int i=1;i<=m;i++){
        read(x[i]);
        read(v[i]);

        //cout<<biggerCheck(x[i],v[i])<<" ";
    }

    for(int i=1;i<=m;i++){
        reset(sol);
        //cout<<"##########"<<i<<"###########"<<'\n';
        gen(i,1);
        write(sol);cout<<" ";
        //cout<<'\n'<<'\n'<<'\n';
    }

    return 0;
}
