#include <bits/stdc++.h>
#define all(x) (x).begin(),(x).end()
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
// #define int ll
#define sz(x) (int)(x).size()

using pii = pair<int,int>;
using tii = tuple<int,int,int>;
using tiii = tuple<int,int,int,int>;

typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> oset;

const int nmax = 2e3 + 5, mmax = 1e5 + 5;

int ans[nmax][nmax];
vector<pii> g[nmax];
int up[nmax], d[nmax];
int cringe[mmax];

int n, m;

int chosen; 

void dfs(int node, int from = -1) {
	up[node] = d[node];
	// cerr << node << '\n';
	for(auto [x, e] : g[node]) {
		if(e == from) continue;
		int atr = abs(x);
		if(d[atr] == 0 && x > 0) {
			d[x] = d[node] + 1;
			dfs(x, e);
		}
		else if(d[atr] != 0 && d[atr] < d[node]) {
			if(x > 0) {cringe[e] = 1; continue; }
			// cerr << node << " <- " << atr << '\n';
			// cerr << up[atr] << " ^^ " << up[node] << '\n';
			up[node] = min(up[atr], up[node]);
		}
	}
	for(auto [x, e] : g[node]) {
		int atr = abs(x);
		if(x > 0 && d[atr] > d[node]) {
			// cerr << node << " -> " <<  x << '\n';
			// cerr << up[x] << " && " << up[node] << '\n';
			if(up[x] > d[node])
				cringe[e] = 1;
		}
	}
	return;
}

int viz[nmax];

void setans(int node, int ee = m + 1) {
	for(auto [x, e] : g[node]) {
		if(cringe[e]) continue;
		int atr = abs(x);
		if(d[atr] < d[node] && x < 0)
			up[node] = min(up[atr], up[node]);
	}
	if(viz[node]) return;
	viz[node] = 1;
	// cerr << node << ' ' << up[node] << '\n';
	if(up[node] == 1)
		ans[chosen][node] = m + 1;
	else
		ans[chosen][node] = ee;
	for(auto [x, e] : g[node])
		if(x > 0 && d[x] > d[node])
			setans(x, cringe[e]? min(ee, e) : ee);
	return;
}

signed main() {
	cin.tie(0) -> sync_with_stdio(0);
	cin >> n >> m;
	for(int a, b, i = 1; i <= m; i++) {
		cin >> a >> b;
		g[a].emplace_back(b, i);
		g[b].emplace_back(-a, i);
	}
	
	for(int i = 1; i <= n; i++) {
		for(int i = 1; i <= m; i++)
			cringe[i] = 0;
		for(int i = 1; i <= n; i++) up[i] = nmax, viz[i] = 0, d[i] = 0;
		chosen = i;
		d[chosen] = 1;
		dfs(i); 
		for(int j = 1; j <= n; j++)
			ans[i][j] = 0;
		// for(int j = 1; j <= m; j++)
			// cerr << cringe[j] << ' ';
		// cerr << '\n';
		setans(i);
		// for(int j = 1; j <= n; j++)
			// cerr << ans[i][j] << ' ';
		// cerr << '\n';
		// exit(0);
	}
	
	int q;
	cin >> q;
	const ll mod = 1e9 + 7, b = 2e5;
	ll rez = 0;
	if(q == 0) {
		cerr << '\n';
		for(int i = 1; i <= n; i++)
			for(int j = 1; j <= n; j++)
				cerr << ans[i][j] << " \n"[j == n];
		for(int i = 1; i <= n; i++) {
			for(int j = i; j <= n; j++) {
				rez = ((ll)rez * b + (ll)min(ans[i][j], ans[j][i])) % mod;
				// cerr << min(ans[i][j], ans[j][i]) << ' ';
			}
		}
		cout << rez << '\n';
		return 0;
	}
	for(int i = 0, a, u; i < q; i++) {
		cin >> a >> u;
		rez = ((ll)rez * b + (ll)min(ans[a][u], ans[u][a])) % mod;
	}
	cout << rez << '\n';
	return 0;
}
