#pragma GCC optimize("O3,Ofast,unroll-loops")
#pragma GCC target("popcnt,lzcnt,sse,sse2,sse3,ssse3,avx,avx2,tune=native")

// nu ia suta, vreau doar sa bulanesc

#include "sorting.h"

#define magic_sauce inline __attribute__((always_inline))

using ll = long long;

const int MAXN = 5e5;
const int NIL = -1;

int ciur[1 + MAXN];
int big_primes[MAXN];
int nbp;
int delta[MAXN];
int n;

const int BULANEALA1 = 379;

std::vector<int> primes1[BULANEALA1];
int exemplu1[BULANEALA1];
int inv1[BULANEALA1];

const int BULANEALA2 = 409;

std::vector<int> primes2[BULANEALA2];
int exemplu2[BULANEALA2];
int inv2[BULANEALA2];

magic_sauce int bulaneste1( int i, int x, int ret ){
	x *= inv1[ret % BULANEALA1]; // x /= ret
	x %= BULANEALA1;
	for( int d : primes1[x] ){
		if( ret * d >= n )
			break;

		if( divisible( 1, i, ret * d ) )
			return ret * d;
	}

	return ret;
}

magic_sauce int bulaneste2( int i, int x, int ret ){
	x *= inv2[ret % BULANEALA2]; // x /= ret
	x %= BULANEALA2;
	for( int d : primes2[x] ){
		if( ret * d >= n )
			break;

		if( divisible( 1, i, ret * d ) )
			return ret * d;
	}

	return ret;
}

magic_sauce int get_delta( int i ){
	int d, ret;

	i++;

	d = 2;
	ret = 1;
	while( d * d <= n ){
		if( !ciur[d] )
			while( ret * d < n && divisible( 1, i, ret * d ) )
				ret *= d;

		d++;
	}

	// trebuie sa facem chestia cu if( ? / ret > 1 ) dar nush cum sa fac rapid -> bulanealalaaa

	if( ((ll)ret) * ret >= n )
		return ret;

	if( BULANEALA1 < n && ret % BULANEALA1 != 0 )
		for( int x = 1 ; x < BULANEALA1 ; x++ )
			if( exemplu1[x] != NIL )
				if( divisible( exemplu1[x], i, BULANEALA1 ) )
					return bulaneste1( i, x, ret );

	if( BULANEALA2 < n && ret % BULANEALA2 != 0 )
		for( int x = 1 ; x < BULANEALA2 ; x++ )
			if( exemplu2[x] != NIL )
				if( divisible( exemplu2[x], i, BULANEALA2 ) )
					return bulaneste2( i, x, ret );

	for( d = 0 ; d < nbp && big_primes[d] * ret < n ; d++ )
		if( divisible( 1, i, ret * big_primes[d] ) )
			return ret * big_primes[d];

	//if( i == 7 )
	//	printf( "bossu!\n" );

	return ret;
}

magic_sauce int good( int min, int max, int delta ){
	//printf( "ng( %d, %d, %d )\n", min, max, delta );
	if( n - 1 - delta < min )
		return 0;
	if( -delta > max )
		return 0;

	//printf( "ret1\n" );

	return 1;
}

#include <vector>
#include <unordered_set>

std::vector<int> solve( int N ){
	int i, d;
	std::vector<int> ret;
	std::unordered_set<int> prev;

	n = N; // global

	ret.reserve( N );

	for( d = 2 ; d * d <= N ; d++ )
		if( !ciur[d] )
			for( i = d * d ; i <= N ; i += d )
				ciur[i] = 1;

	//for( i = 300 ; i < 500 ; i++ )
	//	if( !ciur[i] )
	//		printf("p:%d\n", i);

	nbp = 0;
	for( ; d <= N ; d++ )
		if( !ciur[d] ){
			big_primes[nbp++] = d;
			primes1[d % BULANEALA1].push_back( d );
			primes1[(BULANEALA1 - d % BULANEALA1) % BULANEALA1].push_back( d );
			primes2[d % BULANEALA2].push_back( d );
			primes2[(BULANEALA2 - d % BULANEALA2) % BULANEALA2].push_back( d );
		}

	for( i = 0 ; i < BULANEALA1 ; i++ )
		exemplu1[i] = NIL;
	for( i = 0 ; i < BULANEALA2 ; i++ )
		exemplu2[i] = NIL;

	for( int a = 1 ; a < BULANEALA1 ; a++ )
		for( int b = 1 ; b < BULANEALA1 ; b++ )
			if( a * b % BULANEALA1 == 1 )
				inv1[a] = b;
	for( int a = 1 ; a < BULANEALA2 ; a++ )
		for( int b = 1 ; b < BULANEALA2 ; b++ )
			if( a * b % BULANEALA2 == 1 )
				inv2[a] = b;

	delta[0] = 0;
	prev.insert( 0 ); // se poate face si cu vector de frecv dar n-am chef
	int min = 0, max = N - 1;
	for( i = 1 ; i < N ; i++ ){
		int aux = get_delta( i );
		int x = prev.count( +aux );
		int y = prev.count( -aux );

		if( x || !good( min, max, +aux ) )
			delta[i] = -aux;
		else if( y || !good( min, max, -aux ) )
			delta[i] = +aux;
		else if( compare( 1, i + 1 ) )
			delta[i] = +aux;
		else
			delta[i] = -aux;

		prev.insert( delta[i] );
		aux = -delta[i];
		min = aux > min ? aux : min;
		aux = N - 1 - delta[i];
		max = aux < max ? aux : max;

		int m = (delta[i] + BULANEALA1 * MAXN) % BULANEALA1;
		//if( m < 0 )
		//	printf("COAIE\n");
		exemplu1[m] = i + 1;

		m = (delta[i] + BULANEALA2 * MAXN) % BULANEALA2;
		//if( m < 0 )
		//	printf("COAIE\n");
		exemplu2[m] = i + 1;
	}

	int m = 1e9;
	for( i = 0 ; i < N ; i++ )
		if( delta[i] < m )
			m = delta[i];

	for( i = 0 ; i < N ; i++ )
		ret.push_back( delta[i] - m + 1 );

	//for( int x : ret )
	//	printf("%d\n", x );

	return ret;
}