#include <bits/stdc++.h>

using namespace std;

int n,m,q;
vector<pair<int,int> > g[2005];

const int MOD = 1e9+7;

long long ans;

int B[4000005];

bool bfs(int start, int target, int r)
{
    queue<int> q;
    q.push(start);
    bitset<205> seen;
    seen[start]=1;
    while(!q.empty())
    {
        int nod = q.front();
        if(nod == target)
            return 1;
        q.pop();
        for(auto it:g[nod])
            if(!seen[it.first] && it.second != r)
            {
                seen[it.first]=1;
                q.push(it.first);
            }
    }
    return 0;
}

int ask(int x, int y)
{
    if(!bfs(x,y,0)||!bfs(y,x,0))
        return 0;
    for(int r=1;r<=m;r++)
        if(!bfs(x,y,r)||!bfs(y,x,r))
            return r;
    return m+1;
}

void solve()
{
    cin>>n>>m;
    for(int i=1;i<=m;i++)
    {
        int u,v;
        cin>>u>>v;
        g[u].push_back(make_pair(v,i));
    }
    cin>>q;
    B[0]=1;
    int nrq=q;
    if(!nrq)
        nrq=n*(n+1)/2;
    for(int i=1;i<=nrq;i++)
        B[i]=1LL * B[i-1] * 200000 % MOD;
    int cnt = nrq-1;
    if(!q)
    {
        for(int x=1;x<=n;x++)
            for(int y=x;y<=n;y++)
            {
                ans = (ans + 1LL * ask(x,y) * B[cnt]) % MOD;
                cnt--;
            }
    }
    else {
        while(q--)
        {
            int x,y;
            cin>>x>>y;
            ans = (ans + 1LL * ask(x,y) * B[cnt]) % MOD;
            cnt--;
        }
    }
    cout<<ans<<'\n';
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;

}
