#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
ifstream fin("input.txt");
#define cin fin
#endif

const int INF = 2e9;
const int NMAX = 1e5+5;
const int LOGN = 18;

int n, m;
int x[NMAX], y[NMAX], v[NMAX];
int64_t c[NMAX];
int mxx;
int pref_min[NMAX];

void read() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> m;
    for (int i = 1; i <= m; i++)
        cin >> y[i] >> c[i];
    y[m + 1] = INF;
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> x[i] >> v[i];
        mxx = max(mxx, x[i]);
    }
}

int64_t init_cost(int i) {
    return c[i] - (1ll * (mxx - y[i]) * v[1]);
}

int64_t dist(int i, int j) {
    if (x[i] < y[j])
        exit(-1);
    return init_cost(j) + 1ll * (x[i] - y[j]) * v[i];
}

void solve1e5() {
    for (int i = 1; i <= m; i++) {
        c[i] += 1ll * (mxx - y[i]) * v[1];
        if (c[i] < 0)
            exit(-1);
    }
    pref_min[1] = 1;
    for (int i = 2; i <= m; i++)
        if (c[pref_min[i - 1]] > c[i])
            pref_min[i] = i;
        else
            pref_min[i] = pref_min[i - 1];
    int64_t ans = 0;
    int j = 1;
    for (int i = 1; i <= n; i++) {
        while (j < m && y[j + 1] <= x[i])
            j++;
        ans += dist(i, pref_min[j]);
        cout << ans << ' ';
    }
#ifdef LOCAL
    for (int i = 1; i <= m; i++)
        cout << pref_min[i] << ' ';
        cout << endl;
    for (int i = 1; i <= m; i++)
        cout << c[i] << ' ';
        cout << endl;
    for (int i = 1; i <= m; i++)
        cout << init_cost(i) << ' ';
        cout << endl;
#endif
}

int main() {
    read();
    solve1e5();
    return 0;
}
