#include "sorting.h"
#include <bits/stdc++.h>

using namespace std;

const int NMAX = 5e5+5;

int diff[NMAX];

int find_the_diff(int n, int x, int y) {
    while (n--) {
        if (divisible(n, x, y))
            return n;
    }
    return 0;
}

vector<int> solve(int n) {
    vector<int> ans(n);
    int mn = 2e9;
    for (int i = 1; i < n; i++) {
        diff[i] = find_the_diff(n, i, i + 1);
        if (!compare(i, i + 1))
            diff[i] *= -1;
    }
    ans[0] = 1;
    for (int i = 0; i < n; i++) {
        ans[i] = diff[i] + ans[max(i - 1, 0)];
        mn = min(mn, ans[i]);
    }
    for (auto &it : ans) {
        it += 1 - mn;
    }
    return ans;
}
