#include <bits/stdc++.h>

using namespace std;

#define ll long long
const int INF=1e9;
const ll LINF=1e18,MOD=1e9+7;
#define fi first
#define se second
#define pii pair<int,int>
#define mid ((l+r)/2)
#define sz(a) (int(sz(a)))
#define all(a) a.begin(),a.end()
#define endl "\n"
#define PRINT(x) {cerr<<#x<<"="<<x<<endl; }
#define pb push_back
#define PRINTvec(niz) { cerr<<#niz<<"="; for(int _i:niz) cerr<<_i<<" "; cerr<<endl)

const int mxN=2001;

set<int> adj[mxN];
ll N,M;
bool visited[mxN];
int cnt[mxN][mxN];
int postoji_put[mxN][mxN];

void Dfs(int node){
    visited[node]=true;
    for(int v:adj[node]){
        if(!visited[v]){
            Dfs(v);
        }
    }
}

void Md(ll& x){
    if(x>=MOD){
        x%=MOD;
    }
}

ll Pow(ll x,ll stepen){
    ll ret=1;
    ll puta=x;
    for(int bit=0;bit<64;bit++){
        if((stepen>>bit)&1){
            ret*=puta;
            Md(ret);
        }
        puta*=puta;
        Md(puta);
    }
    return ret;
}

void Solve(){
    cin>>N>>M;
    for(int i=1;i<=M;i++){
        int u,v; cin>>u>>v;
        adj[u].insert(v);
        cnt[u][v]++;
    }
    int Q; cin>>Q;
    ll res=0;
    ll B=2e5;
    ll K=(N*(N+1))/2;
    vector<ll> ans(N*N+1);
    for(int i=1;i<=N;i++){
        fill(visited,visited+mxN,false);
        Dfs(i);
        for(int j=1;j<=N;j++){
            postoji_put[i][j]=visited[j];
        }
    }
    if(Q==0){
        int idx=1;
        Q=N*N;
        for(int i=1;i<=N;i++){
            for(int j=1;j<=N;j++){
                ans[idx]=(postoji_put[i][j] ? M+1 : 0);
                idx++;
            }
        }
    }
    int idx=1;
    while(Q--){
        int u,v; cin>>u>>v;
        ans[idx]=(postoji_put[u][v] ? M+1 : 0);
        idx++;
    }
    for(int i=1;i<=Q;i++){
        res+=ans[i]*Pow(B,K-i);
        Md(res);
    }
    cout<<res<<endl;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t=1;
    while(t--){
        Solve();
    }
}
