#include <bits/stdc++.h>

using namespace std;

#define ll long long
const int INF=1e9;
const ll LINF=1e18,MOD=1e9+7;
#define fi first
#define se second
#define pii pair<int,int>
#define mid ((l+r)/2)
#define sz(a) (int(sz(a)))
#define all(a) a.begin(),a.end()
#define endl "\n"
#define PRINT(x) {cerr<<#x<<"="<<x<<endl; }
#define pb push_back
#define PRINTvec(niz) { cerr<<#niz<<"="; for(int _i:niz) cerr<<_i<<" "; cerr<<endl; }

const int mxN=2001;

vector<int> adj[mxN];
ll N,M;
bool visited[mxN];
int cnt[mxN][mxN];
int postoji_put[mxN][mxN];
bool subtask2,subtask3,subtask4,subtask5;

void Dfs(int node){
    visited[node]=true;
    for(int v:adj[node]){
        if(!visited[v]){
            Dfs(v);
        }
    }
}

void Md(ll& x){
    if(x>=MOD){
        x%=MOD;
    }
}

ll Pow(ll x,ll stepen){
    ll ret=1;
    ll puta=x;
    for(int bit=0;bit<64;bit++){
        if((stepen>>bit)&1){
            ret*=puta;
            Md(ret);
        }
        puta*=puta;
        Md(puta);
    }
    return ret;
}

void Solve(){
    cin>>N>>M;
    vector<pii> edges(M+1);
    for(int i=1;i<=M;i++){
        int u,v; cin>>u>>v;
        adj[u].pb(v);
        edges[i]={u,v};
    }
    for(int i=1;i<=N;i++){
        for(int j=1;j<=N;j++){
            fill(visited+1,visited+1+N,false);
            Dfs(i);
            postoji_put[i][j]=visited[j];
            fill(visited+1,visited+1+N,false);
            Dfs(j);
            postoji_put[j][i]=visited[i];
        }
    }
    int Q; cin>>Q;
    ll res=0;
    ll B=2e5;
    if(Q==0){
        ll K=(N*(N+1))/2;
        vector<ll> ans(K+1);
        int idx=1;
        for(int i=1;i<=N;i++){
            for(int j=i;j<=N;j++){
                if(!postoji_put[i][j] || !postoji_put[j][i]){
                    ans[idx++]=0;
                }
                else ans[idx++]=M+1;
            }
        }
        for(int i=1;i<=K;i++){
            res+=ans[i]*Pow(B,K-i);
            Md(res);
        }
    }
    else{
        ll K=Q;
        vector<ll> ans(K+1);
        int idx=1;
        while(Q--){
            int u,v; cin>>u>>v;
            if(!postoji_put[u][v] || !postoji_put[v][u]){
                ans[idx++]=0;
            }
            else ans[idx++]=M+1;
        }
        for(int i=1;i<=K;i++){
            res+=ans[i]*Pow(B,K-i);
            Md(res);
        }
    }
    cout<<res<<endl;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t=1;
    while(t--){
        Solve();
    }
}
