#include <bits/stdc++.h>

using namespace std;

#define MAXN 2010

long long n,m;
long long q;
vector<long long> adj[MAXN];
bool pos[MAXN];

void dfs(long long node)
{
    pos[node]=true;

    long long s=adj[node].size();

    for (long long i=0;i<s;i++)
    {
        long long sled=adj[node][i];

        if (pos[sled]==false) dfs(sled);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    
    cin>>n>>m;

    for (long long i=1;i<=m;i++)
    {
        long long x,y;
        cin>>x>>y;

        adj[x].push_back(y);
    }

    cin>>q;

    for (long long i=1;i<=q;i++)
    {
        long long a,b;
        cin>>a>>b;

        dfs(a);

        if (pos[b])
        {
            for (long long i=0;i<MAXN;i++) pos[i]=false;

            dfs(b);

            if (pos[a]) cout<<m+1<<endl;
            else cout<<0<<endl;
        }

        else cout<<0<<endl;
    }

    if (q==0)
    {
        for (long long i=1;i<n;i++)
        {
            for (long long j=i+1;j<=n;j++)
            {
                dfs(i);

                if (pos[j]==true)
                {
                    dfs(j);

                    if (pos[i]) cout<<m+1<<endl;
                    else cout<<0<<endl;
                }

                else cout<<0<<endl;
            }
        }
    }
}