#include <bits/stdc++.h>
#pragma GCC optimize ("O3")
#pragma GCC optimize ("unroll-loops")
#pragma GCC target ("avx,avx2,tune=native")
#define int long long
#define mp make_pair
#define X first
#define Y second

using namespace std;
using pii = pair <int, int>;

constexpr int maxn = 1e5 + 10;
constexpr int inf = 2e18 + 10;
constexpr int B = 200000;
constexpr int mod = 1e9 + 7;

vector <int> res = {};

inline void goodbye (int k) {
    int P = 0, bb = 1;
    reverse (res.begin (), res.end ());
    for (int i : res) {
        P += (i * bb) % mod;
        P %= mod;
        bb = (bb * B) % mod;
    }
    cout << P << '\n';
    exit (0);
}


vector <pii> graph [2222];
vector <int> g [2222], gr [2222];
vector <pii> Q;
int n, ans [3000000];
vector <int> used, ls, comp;

inline void dfs0 (int v) {
    used[v] = true;
    for (int i : g[v]) if (!used[i]) dfs0 (i);
    ls.push_back (v);
}

inline void dfs1 (int v) {
    used[v] = true;
    comp.push_back (v);
    for (int i : gr[v]) if (!used[i]) dfs1 (i);
}

int group [maxn], q;
vector <int> check;

inline void find_component (int cur, int ban) {
    for (int i = 0; i < n; ++i) g[i].clear (), gr[i].clear ();
    for (int i = 0; i < n; ++i)
    for (pii j : graph[i]) if (j.Y != ban) {
        g[i].push_back (j.X);
        gr[j.X].push_back (i);
    }
    used.assign (n, 0);
    ls.clear ();
    for (int i = 0; i < n; ++i) if (!used[i]) dfs0 (i);
    used.assign (n, 0);
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
            int v = ls[n - 1 - i];
            if (!used[v]) {
                comp.clear ();
                dfs1 (v);
                ++cnt;
                for (int i : comp) group[i] = cnt;
            }
    }
    vector <int> f = {};
    for (int i : check) if (group[Q[i].X] != group[Q[i].Y]) {
        ans[i] = min (ans[i], cur);
    } else f.push_back (i);
    check = f;
}

inline void solve () {
    check.clear ();
    int m, u, v;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        cin >> u >> v, --u, --v;
        graph[u].push_back (mp (v, i));
    }
    cin >> q;
    if (q == 0) {
            q = (n * (n - 1) / 2) + n;
            for (int i = 0; i < n; ++i)
                for (int j = i; j < n; ++j) Q.push_back (mp (i, j));
            } else {
        Q.resize (q);
        for (pii &i : Q) cin >> i.X >> i.Y, i.X--, i.Y--;
            }
    check.resize (q);
    iota (check.begin (), check.end (), 0);
    for (int i = 0; i < q; ++i) ans[i] = m + 1;
    find_component (0, -1);
    //find_component (1, 0);
    if (m < 8001) for (int i = 0; i < m; ++i) find_component (i + 1, i);
    for (int i = 0; i < q; ++i) res.push_back (ans[i]);
    //for (int i : res) cout << i << ' ';
    //cout << '\n';
    goodbye (q);
}

signed main() {
    ios_base::sync_with_stdio (false);
    cin.tie (nullptr);
    int t = 1;
    //cin >> t;
    while (t--) solve ();
    return 0;
}
