//#include "sorting.h"
#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e18 + 123;

const ll MAXM = 100, MAXN = 100;

ll M, N;

struct Bus {
    ll y, c;
};
Bus b[MAXM];

struct Student {
    ll x, v;
};
Student s[MAXN];

ll n;
ll res;

bool used[MAXM];

void Recursion(ll ind, ll cost) {
    //cout << ind << " : ";
    //for (int i = 0; i < M; i ++) cout << used[i];
    //cout << '\n';
    if (ind == n) {
        for (ll i = 0; i < M; i ++)
            if (used[i])
                cost += b[i].c;
        res = min(res, cost);
        //cout << "----- " << cost << '\n';
        return;
    }
    for (ll i = 0; i < M; i ++) {
        if (b[i].y > s[ind].x) break;
        
        bool save = used[i];
        used[i] = true;
        Recursion(ind + 1, cost + s[ind].v * (s[ind].x - b[i].y));
        used[i] = save;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    /*#ifndef ONLINE_JUDGE
        freopen("input123.txt", "r", stdin);
        freopen("output123.txt", "w", stdout);
    #endif*/

    cin >> M;
    for (ll i = 0; i < M; i ++)
        cin >> b[i].y >> b[i].c;
    cin >> N;
    for (ll i = 0; i < N; i ++)
        cin >> s[i].x >> s[i].v;

    for (n = 1; n <= N; n ++) {
        res = INF;
        for (ll i = 0; i < M; i ++)
            used[i] = false;
        Recursion(0, 0);
        cout << res << ' ';
    }
    return 0;
}