//#include "sorting.h"
#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int perm[5] = {2, 1, 4, 5, 3};

const int NN = 75003;

bool prime[NN];

vector <int> pr;
int cnt = 0;

void Seive() {
    for (int i = 0; i < NN; i ++) prime[i] = true;
    prime[0] = prime[1] = false;
    for (int i = 2; i < NN; i ++) {
        if (!prime[i]) continue;
        //cout << i << '\n';
        pr.push_back(i);
        cnt ++;
        if (1ll * i * i < NN)
            for (int j = i * i; j < NN; j += i)
                prime[j] = false;
    }
}

bool compare(int x, int y);

bool divisible(int x, int y, int d);

std::vector <int> solve(int N) {
    Seive();

    vector <int> p(N);
    int ind = 1;
    for (int i = 2; i <= N / 2 + 1; i ++) {
        if (compare(ind, i))
            ind = i;
    }
    p[ind - 1] = 0;
    for (int i = 0; i < N; i ++) {
        if (i == ind - 1) continue;
        int a = min(ind, i + 1), b = max(ind, i + 1);
        for (int d = N - 1; d >= 1; d --) {
            if (divisible(a, b, d)) {
                p[i] = d;
                break;
            }
        }
    }
    int pos = 0;
    for (int i = 1; i < N; i ++) {
        if (p[i] > p[pos])
            pos = i;
    }
    //--------------------------------------------------
    ind = pos + 1;
    p[ind - 1] = 1;
    for (int i = 0; i < N; i ++) {
        if (i == ind - 1) continue;
        int val = 1;
        for (auto pp : pr) {
            //int pw = 1;
            int a = min(ind, i + 1), b = max(ind, i + 1);
            int num = 1;
            while (divisible(a, b, num)) {
                //if (num != 1)
                    //cout << perm[a - 1] << ' ' << perm[b - 1] << " | " << num << '\n';
                num *= pp;
                //pw ++;
            }
            num /= pp;
            //cout << num << '\n';
            val *= num;
            //cout << num << '\n';
        }
        p[i] = 1 + val;
    }
    return p;
}

bool compare(int x, int y) {
    return perm[x - 1] < perm[y - 1];
}

bool divisible(int a, int b, int d) {
    return (abs(perm[a - 1] - perm[b - 1]) % d == 0);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    auto vec = solve(5);
    for (auto v : vec) cout << v << ' ';
    return 0;
}
