#include <bits/stdc++.h>

#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define watch(x) cout << (#x) << " : " << x << '\n'
#define boost ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)

using namespace std;

#define int ll

const int N = 2222;
const int M = 1e5 + 128;

vector <int> g[N];
int n, m;

const int MOD = 1e9 + 7;
const int B = 2e5;

ll binpow(ll a, int n) {
    ll res = 1ll;
    while (n) {
        if (n & 1)
            res = (res * a) % MOD;
        a = (a * a) % MOD;
        n >>= 1;
    }
    return res;
}

char used[N][N];

void solve() {
    cin >> n >> m;

    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
    }

    int q;
    cin >> q;

    vector < pair<int, int> > Q;
    if (!q) {
        for (int i = 1; i <= n; i++)
            for (int j = i; j <= n; j++)
                Q.push_back({i, j});
    } else {
        for (int i = 0; i < q; i++) {
            int a, b;
            cin >> a >> b;
            Q.push_back({a, b});
        }
    }

    // has path?
    // just bfs

    for (int i = 1; i <= n; i++) {
        used[i][i] = true;
        queue <int> q;
        q.push(i);
        while (!q.empty()) {
            int v = q.front(); q.pop();

            for (auto to : g[v])
                if (!used[i][to])
                    used[i][to] = true, q.push(to);
        }
    }

    ll res = 0ll;

    ll K = Q.size();

    for (auto [a, b] : Q) {
        ll ans = used[a][b];
        if (ans) ans = m+1;
        K--;
        ll st = binpow(B, K);
        st = (st * ans) % MOD;
        res = (res + st) % MOD;
    }

    cout << res << '\n';
}

main() {
    boost;
    solve();
    return 0;
}
