#include <bits/stdc++.h>

#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define watch(x) cout << (#x) << " : " << x << '\n'
#define boost ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define ret g[e[i].first].push_back(e[i].second)

using namespace std;

#define int ll

const int N = 2222;
const int M = 1e5 + 128;

vector <int> g[N];
int n, m;

const int MOD = 1e9 + 7;
const int B = 2e5;

ll binpow(ll a, ll n) {
    ll res = 1ll;
    while (n) {
        if (n & 1)
            res *= a, res %= MOD;
        a *= a;
        a %= MOD;
        n >>= 1;
    }
    return res;
}

bool has[N][N];

void solve() {
    cin >> n >> m;

    vector < pair<int, int> > e;

    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        e.push_back({a, b});
        g[a].push_back(b);
    }

    int q;
    cin >> q;

    vector < pair<int, int> > Q;
    for (int i = 0; i < q; i++) {
        int a, b;
        cin >> a >> b;
        Q.push_back({a, b});
    }

    for (int i = 1; i <= n; i++) {
        queue <int> q;
        q.push(i);
        has[i][i] = true;
        while (!q.empty()) {
            int v = q.front(); q.pop();
            for (auto to : g[v])
                if (!has[i][to])
                    has[i][to] = true, q.push(to);
        }
    }

    if (Q.empty()) {
        for (int i = 1; i <= n; i++) for (int j = i; j <= n; j++) Q.push_back({i, j});
    }

    ll K = (int) Q.size();
    ll res = 0ll;

    for (auto [a, b] : Q) {
        int ans = m + 1;
        if (!has[a][b] || !has[b][a]) {
            ans = 0;
        } else {
            for (int i = 0; i < m; i++) {
                auto it = find(all(g[e[i].first]), e[i].second);
                assert(it != g[e[i].first].end());
                g[e[i].first].erase(it);
                queue <int> q;
                vector <char> used(n+1, false);
                used[a] = true;
                q.push(a);
                while (!q.empty()) {
                    int v = q.front(); q.pop();
                    for (auto to : g[v])
                        if (!used[to])
                            used[to] = true, q.push(to);
                }
                if (!used[b]) {
                    ans = i + 1; ret; break;
                }
                fill(all(used), false);
                q.push(b);
                used[b] = true;
                while (!q.empty()) {
                    int v = q.front(); q.pop();
                    for (auto to : g[v])
                        if (!used[to])
                            used[to] = true, q.push(to);
                }
                ret;
                if (!used[a]) {
                    ans = i + 1; break;
                }
            }
        }
        K--;
        ll st = binpow(B, K);
        st = (st * ans) % MOD;
        res = (res + st) % MOD;
//        cout << ans << ' ';
    }

    cout << res << '\n';
}

main() {
    boost;
    solve();
    return 0;
}

