#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr ll INF = 1000000000000000000LL;

ll n, m, q, k, x, y, a, b, c;
ll dp[20001][1001];
ll mdp[20001][1001];

void solve() {
    cin >> n;
    vector< pair<ll, ll> > v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].first >> v[i].second;
    }
    cin >> m;
    vector< pair<ll, ll> > u(m);
    for (int i = 0; i < m; i++) {
        cin >> u[i].first >> u[i].second;
    }
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= m; j++) {
            if (j == 0) {
                dp[i][j] = 0;
                mdp[i][j] = 0;
                continue;
            }
            dp[i][j] = INF;
            mdp[i][j] = INF;
            if (i == 0) {
                continue;
            }
            if (v[i - 1].first <= u[j - 1].first) {
                dp[i][j] = min(dp[i][j], mdp[i - 1][j - 1] + (u[j - 1].first - v[i - 1].first) * u[j - 1].second + v[i - 1].second);
            }
            if (j >= 2 && v[i - 1].first <= u[j - 2].first) {
                dp[i][j] = min(dp[i][j], dp[i][j - 1] + (u[j - 1].first - v[i - 1].first) * u[j - 1].second);
            }
            mdp[i][j] = min(dp[i][j], mdp[i - 1][j]);
        }
    }
    // for (int i = 0; i <= n; i++) {
    //     for (int j = 0; j <= m; j++) {
    //         cout << dp[i][j] << ' ';
    //     }
    //     cout << '\n';
    // }
    // cout << '\n';
    for (int i = 1; i <= m; i++) {
        cout << mdp[n][i] << ' ';
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie();
    solve();
}