#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr ll INF = 1000000000000000000LL;

ll n, m, q, k, x, y, a, b, c;
ll dp[20001][2];
ll mdp[20001][2];

void solve() {
    cin >> n;
    vector< pair<ll, ll> > v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].first >> v[i].second;
    }
    cin >> m;
    vector< pair<ll, ll> > u(m);
    for (int i = 0; i < m; i++) {
        cin >> u[i].first >> u[i].second;
    }
    for (int j = 1; j <= m; j++) {
        for (int i = 0; i <= n; i++) {
            dp[i][1] = INF;
            mdp[i][1] = INF;
            if (i == 0) {
                continue;
            }
            if (v[i - 1].first <= u[j - 1].first) {
                dp[i][1] = min(dp[i][1], mdp[i - 1][0] + (u[j - 1].first - v[i - 1].first) * u[j - 1].second + v[i - 1].second);
            }
            if (j >= 2 && v[i - 1].first <= u[j - 2].first) {
                dp[i][1] = min(dp[i][1], dp[i][0] + (u[j - 1].first - v[i - 1].first) * u[j - 1].second);
            }
            mdp[i][1] = min(dp[i][1], mdp[i - 1][1]);
        }
        cout << mdp[n][1] << ' ';
        for (int i = 0; i <= n; i++) {
            swap(dp[i][0], dp[i][1]);
            swap(mdp[i][0], mdp[i][1]);
        }
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie();
    solve();
}