#include <bits/stdc++.h>
#include "sorting.h"

using namespace std;
using ll = long long;
constexpr ll INF = 1000000000000000000LL;

ll n, m, q, k, x, y, a, b, c;

bool prime(ll x) {
    for (int i = 2; i <= sqrt(x); i++) {
        if (x % i == 0) {
            return 0;
        }
    }
    return 1;
}

vector<int> solve2(set<ll> st, ll x) {
    // cout << "!!!" << endl;
    // for (int i : st) {
    //     cout << i << ' ';
    // }
    // cout << '\n';
    n = st.size();
    vector<int> v(n);
    bool fl = 0;
    for (int i : st) {
        for (int j : st) {
            if (i >= j) {
                continue;
            }
            // cout << i << ' ' << j << ' ' << x * (st.size() - 1) << endl;
            if (divisible(i, j, x * (st.size() - 1))) {
                if (compare(i, j)) {
                    v[0] = i;
                    v[n - 1] = j;
                }
                else {
                    v[0] = j;
                    v[n - 1] = i;
                }
                st.erase(i);
                st.erase(j);
                fl = 1;
                break;
            }
        }
        if (fl) {
            break;
        }
    }
    fl = 1;
    ll l = 1, r = n - 2;
    while (r > l) {
        if (fl) {
            for (int i : st) {
                if (divisible(v[l - 1], i, x * (r - l + 1))) {
                    v[r] = i;
                    st.erase(i);
                    break;
                }
            }
            r--;
        }   
        else {
            for (int i : st) {
                if (divisible(v[r + 1], i, x * (r - l + 1))) {
                    v[l] = i;
                    st.erase(i);
                    break;
                }
            }
            l++;
        }     
    }
    if (st.size() > 0) {
        v[l] = *st.begin();
    }
    // cout << "! ";
    // for (int i = 0; i < m; i++) {
    //     cout << v[i] << ' ';
    // }
    // cout << '\n';
    vector<int> ans(n);
    for (int i = 0; i < n; i++) {
        ans[i] = v[i];
    }
    // for (int j : ans) {
    //     cout << j << ' ';
    // }
    // cout << endl;
    return ans;
}

vector<int> solve1(set<ll> st, ll mult, ll e) {
    ll n = st.size();
    set<ll> st2;
    for (int i : st) {
        st2.insert(i);
    }
    vector<int> ans(n);
    if (n == 1) {
        ans[0] = *st.begin();
        return ans;
    }
    if (mult * e > m || n <= 100) {
        return solve2(st, mult);
    }
    while (!prime(e)) {
        e++;
    }
    vector< set<ll> > v;
    while (st.size() > 0) {
        v.resize(v.size() + 1);
        v[v.size() - 1].insert(*st.begin());
        x = *st.begin();
        st.erase(st.begin());
        set<ll> st1;
        for (int i : st) {
            if (divisible(x, i, mult * e)) {
                v[v.size() - 1].insert(i);
            }
            else {
                st1.insert(i);
            }
        }
        swap(st1, st);
    }
    set<ll> st3;
    vector< vector<int> > ansv;
    for (int i = 0; i < v.size(); i++) {
        ansv.push_back(solve1(v[i], mult * e, e + 1));
        st3.insert(ansv[ansv.size() - 1][0]);
    }
    // for (int i : st2) {
    //     cout << i << ' ';
    // }
    // cout << '\n';
    // for (int i = 0; i < ansv.size(); i++) {
    //     cout << *v[i].begin() << '\t';
    //     for (int j : ansv[i]) {
    //         cout << j << ' ';
    //     }
    //     cout << '\n';
    // }
    auto v2 = solve2(st3, mult);
    // for (int i = 0; i < v2.size(); i++) {
    //     cout << v2[i] << ' ';
    // }
    // cout << '\n';
    // cout << endl;
    vector<ll> v3(m + 1);
    for (int i = 0; i < v2.size(); i++) {
        v3[v2[i]] = i;
    }
    for (int i = 0; i < ansv.size(); i++) {
        for (int j = 0; j < ansv[i].size(); j++) {
            ans[v3[ansv[i][0]] + e * j] = ansv[i][j];
        }
    }
    return ans;
}

vector<int> inv(vector<int> v) {
    vector<int> ans(v.size());
    for (int i = 0; i < v.size(); i++) {
        ans[v[i] - 1] = i + 1;
    }
    return ans;
}

std::vector <int> solve(int n) {
    m = n;
    set<ll> st;
    for (int i = 0; i < n; i++) {
        st.insert(i + 1);
    }
    return inv(solve1(st, 1, 2));
}