#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <string>
#include <math.h>
#include <cmath>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <deque>
#include <bitset>
#include <cstring>
#include <unordered_map>

using namespace std;
typedef long long ll;

#define endl '\n'

struct one{
    ll x, type, v, rent, prev, ind;
};

bool cmp(one p1, one p2){
    if(p1.x == p2.x)
        return p1.type < p2.type; // bus - 0
    return p1.x < p2.x;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    ll n;
    cin >> n;
     
    vector<one>a;
    
    for(int i = 0; i < n; i++){
        ll x, rent;
        cin >> x  >> rent;
        
        a.push_back({x, 0, (ll)-1, rent, 0, (ll)-1});
    }
    
    ll m;
    cin >> m;
    
    ll V = 0;
    
    for(int i = 0; i < m; i++){
        ll x, v;
        cin >> x >> v;
        
        V = v;
        
        a.push_back({x, (ll)1, v, (ll)-1, (ll)-1, (ll)i});
    }
    
    sort(a.begin(), a.end(), cmp);
    
    vector<ll>dp(m);
    
    ll mx = 3 * -1e18;
    
    for(auto i: a){
        if(i.type == 0){
            mx = max(mx, i.x * V - i.rent);
            continue;
        }
        
        dp[i.ind] = (i.ind == 0 ? 0 : dp[i.ind - 1]);
        dp[i.ind] += (i.x * V) - mx;
    }
    
    for(int i = 0; i < m; i++)
        cout << dp[i] << ' ';
    cout << endl;
    
    return 0;
}
