#include <bits/stdc++.h>
using namespace std;
using ll = long long;

int n, m;

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>n;
    vector<ll> y(n + 1), c(n + 1);
    for (int i = 1; i <= n; i++){
        cin>>y[i]>>c[i];
    }
    cin>>m;
    vector<ll> x(m + 1), v(m + 1);
    for (int i = 1; i <= m; i++){
        cin>>x[i]>>v[i];
    }
    // path(i, j) = abs(x[i] - y[j]) * v[i] + c[j];
    ll path[m + 1][n + 1];
    for (int i = 1; i <= m; i++){
        for (int j = 1; j <= n; j++){
            path[i][j] = abs(x[i] - y[j]) * v[i] + c[j];
        }
    }
    for (int j = 1; j <= m; j++){ // first j students
        map<int, vector<int>> a; // place: students
        ll suma[n + 1];
        for (int i = 1; i <= n; i++){
            suma[i] = 0;
        }
        for (int k = 1; k <= j; k++){ // student k
            for (int i = 1; i <= 1; i++){ // place i
                int index = 0;
                ll d2 = 1e18;
                for (int t = 1; t <= n; t++){
                    if (!a[t].empty()){
                        if (path[k][t] <= d2){
                            index = t;
                            d2 = path[k][t];
                        }
                    }
                    else {
                        if (path[k][t] + c[t] <= d2){
                            index = t;
                            d2 = path[k][t] + c[t];
                        }
                    }
                }
                a[index].push_back(k);
                suma[index] += path[k][index];
            }
        }
        /*
        for (int i = 1; i <= n; i++){
            if (!a[i].empty()){
                cout<<"Place "<<i<<": ";
                for (int j = 0; j < a[i].size(); j++){
                    cout<<a[i][j]<<" ";
                }
                cout<<endl;
            }
        }
        cout<<"hi"<<endl;
        */
        ll ans = 0;
        for (int i = 1; i <= n; i++){
            ans += suma[i];
        }
        cout<<ans<<" ";
    }
}