#include <bits/stdc++.h>
using namespace std;
using ll = long long;

int n, m;

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>n;
    vector<ll> y(n + 1), c(n + 1);
    for (int i = 1; i <= n; i++){
        cin>>y[i]>>c[i];
    }
    cin>>m;
    vector<ll> x(m + 1), v(m + 1);
    for (int i = 1; i <= m; i++){
        cin>>x[i]>>v[i];
    }
    // path[i][j] = (x[i] - y[j]) * v[i]
    for (int d = 1; d <= m; d++){ // first d students
        ll ans = 1e18;
        for (int j = 1; j <= n && y[j] <= x[1]; j++){ // where should first student go
            map<int, vector<int>> a; // place: students
            ll suma[n + 1];
            for (int i = 1; i <= n; i++){
                suma[i] = 0;
            }
            a[j].push_back(1);
            suma[j] = (x[1] - y[j]) * v[1] + c[j];
            for (int i = 2; i <= d; i++){ // student i
                int index = 1;
                ll dist = 1e18;
                for (int p = 1; p <= n && y[p] <= x[i]; p++){
                    ll pa = (x[i] - y[p]) * v[i];
                    if (!a[p].empty()){
                        if (pa <= dist){
                            dist = pa;
                            index = p;
                        }
                    }
                    else {
                        if (pa + c[p] <= dist){
                            dist = pa + c[p];
                            index = p;
                        }
                    }
                }
                a[index].push_back(i);
                suma[index] += dist;
            }
            ll res = 0;
            for (int i = 1; i <= n; i++){
                res += suma[i];
            }
            ans = min(ans, res);
        }
        cout<<ans<<" ";
    }
}