#include <bits/stdc++.h>
using namespace std;

#define DIM 2001
#define MOD 1000000007
#define INF 1e15

typedef long long ll;

int n, m;
vector<vector<int>> a;
vector<pair<int,int>> p;
ll d[DIM][DIM];

ll pp[1000000];

void powmod(ll a, ll b) {
    pp[0] = 1;
    for(int i = 1; i <= b; i++) {
        pp[i] = (pp[i-1]*a)%MOD;
    }
}

ll calc(ll a, ll b) {
    if (d[a][b] == 0 || d[b][a] == 0) return 0;
    return min(d[a][b],d[b][a]);
}

void bfs2(int st) {
    queue<int> q;
    vector<int> u(n,0);
    q.push(st);
    while(!q.empty()) {
        int v = q.front();
        q.pop();
        if (u[v]) continue;
        u[v] = 1;
        for (auto to : a[v]) {
            q.push(to);
        }
    }
    for (int i = 0; i < n; i++) if (u[i] == 0) {
        d[st][i] = 0;
    }
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> n >> m;
    a.resize(n);
    p.resize(m);
    for (int i = 0; i < m; i++) {
        cin >> p[i].first >> p[i].second; p[i].first--; p[i].second--;
        a[p[i].first].push_back(p[i].second);
    }
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            d[i][j] = m+1;

    for (int i = 0; i< n; i++) bfs2(i);

    ll res = 0;
    int q;
    cin >> q;
    if (q == 0) {
        powmod(2e5,n*(n+1)/2);
        int k = n*(n+1)/2-1;
        for (int i = 0; i < n; i++) {
            for (int j = i; j < n; j++) {
                res = (res + (calc(i,j)*pp[k])%MOD)%MOD;
                k--;
                //cout << d[i][j] << " ";
                //cout << calc(i,j) << " ";
            }
            //cout << endl;
        }
    }
    else powmod(2e5,q);
    int k = q-1;
    for (int i = 0; i < q; i++) {
        int u,v;
        cin >> u >> v;
        res = (res + (calc(v-1,u-1)*pp[k])%MOD)%MOD;
        //cout << d[u-1][v-1] << " " << d[v-1][u-1] << " " <<calc(v-1,u-1) << '\n';;
        k--;
    }
    cout << res;
}










