#include <bits/stdc++.h>
using namespace std;

#define DIM 5001
#define MOD 1000000007
#define INF 1e15

typedef long long ll;

ll n, m;
vector<vector<ll>> a;
vector<pair<ll,ll>> p;
ll d[DIM][DIM];

ll pp[1000000];

void powmod(ll a, ll b) {
    pp[0] = 1;
    for(ll i = 1; i <= b; i++) {
        pp[i] = (pp[i-1]*a)%MOD;
    }
}

ll calc(ll a, ll b) {
    if (d[a][b] == 0 || d[b][a] == 0) return 0;
    return m+1;
}

void bfs2(ll st) {
    queue<ll> q;
    vector<ll> u(n,0);
    q.push(st);
    while(!q.empty()) {
        ll v = q.front();
        q.pop();
        if (u[v]) continue;
        u[v] = 1;
        for (auto to : a[v]) {
            q.push(to);
        }
    }
    for (ll i = 0; i < n; i++)
    if (u[i] == 0) {
        d[st][i] = 0;
        d[i][st] = 0;
    }
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> n >> m;
    a.resize(n);
    p.resize(m);
    for (ll i = 0; i < m; i++) {
        cin >> p[i].first >> p[i].second; p[i].first--; p[i].second--;
        a[p[i].first].push_back(p[i].second);
    }
    for (ll i = 0; i < n; i++)
        for (ll j = 0; j < n; j++)
            d[i][j] = m+1;

    for (ll i = 0; i < n; i++) bfs2(i);

    ll res = 0;
    ll q;
    cin >> q;
    if (q == 0) {
        powmod(200000,n*(n+1)/2 + 1);
        ll k = n*(n+1)/2+1;
        for (ll i = 0; i < n; i++) {
            for (ll j = i; j < n; j++) {
                res = (res%MOD + (calc(j,i)%MOD*pp[k]%MOD)%MOD)%MOD;
                k--;
                //cout << d[i][j] << " ";
                //cout << calc(i,j) << " ";
            }
            //cout << endl;
        }
        //cout << c << " " << n*(n+1)/2;
        cout << res;
        return 0;
    }
    else {
        powmod(200000,q);
        ll k = q-1;
        for (ll i = 0; i < q; i++) {
            ll u,v;
            cin >> u >> v;
            res = (res + (calc(u-1,v-1)%MOD*pp[k]%MOD)%MOD)%MOD;
            //cout << d[u-1][v-1] << " " << d[v-1][u-1] << " " <<calc(v-1,u-1) << '\n';;
            k--;
        }
        if (res < 0) return 1;
        cout << res;
    }
}
