#include <bits/stdc++.h>
//#define ll int
typedef long long ll;
using namespace std;
const int __MAXN = 500000 + 10;

int __compareCnt;
int __n, __p[__MAXN];
bool compare(int x, int y)
{
    __compareCnt++;
    if (!(1 <= x && x <= __n && 1 <= y && y <= __n))
    {
        std::cerr << "Invalid compare query!\n";
        exit(0);
    }

    return __p[x] < __p[y];
}
bool divisible(int x, int y, int d)
{
    if (!(1 <= x && x <= __n && 1 <= y && y <= __n && 1 <= d && d <= __n))
    {
        std::cerr << "Invalid divisible query!\n";
        exit(0);
    }

    return abs(__p[x] - __p[y]) % d == 0;
}
void read()
{
    std::cin >> __n;
    for (int i = 1 ; i <= __n ; ++i)
    {
        std::cin >> __p[i];
    }
}
double score()
{
    int logn = 0;
    while ((1 << logn) < __n) ++logn;
    if (__compareCnt <= __n/2) return 1.;
    if (__compareCnt <= 2*__n/2) return 0.7;
    if (__compareCnt <= 2*__n) return 0.5;
    if (__compareCnt <= __n * logn) return 0.15;
    if (__compareCnt <= __n * (1+logn)) return 0.1;
    return 0.05;
}
void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}
vector <int> ans(500010),vv(500010);
ll n;
ll solv(ll x,ll y)
{
    for (ll i=1;i<=n;i++)
    {
        if (ans[i]==0)
        {
            bool f;
            f=divisible(i,x,y);
            if (f) return i;
        }
    }
}
vector <int> solve(ll N)
{
    n=N;
    vector <ll> v(n+1);
    ll x;
    for (ll i=0;i<=n;i++)
    {
        v[i]=i;
    }
    for (ll i=0;i<=n;i++)
    {
        v[i]=0;
    }
    ll sum=0;
    x=1;
    for (ll i=1;i<=n;i++)
    {
        if (i!=x)
        {
            bool f;
            f=compare(x,i);
            if (f) v[i]=-1; else v[i]=1;
            if (f) sum++;
        }
    }
    ll sm=0;
    ll y;
    if (sum>n/2 || sum==1)
    {
        y=solv(x,sum-1);
        ans[y]=1;
        for (ll i=n-1;i>=1;i--)
        {
            ll e=solv(y,i);
            ans[e]=i+1;
        }
    }
    else
    {
        y=solv(x,n-sum);
        ans[y]=n;
        for (ll i=n-1;i>=1;i--)
        {
            ll e=solv(y,i);
            ans[e]=n-i;
        }
    }
    vector <int> w;
    for (ll i=1;i<=n;i++)
    {
        cout<<ans[i]<<" ";
        w.push_back(ans[i]);

    }
    return w;
}
int main ()
{
    fastIO();
    read();

    std::vector < int > res = solve(__n);
    if (res.size() != __n)
    {
        std::cout << "Invalid result! WA!\n";
        exit(0);
    }

    for (int i = 1 ; i <= __n ; ++i)
    {
        if (res[i-1] != __p[i])
        {
            std::cout << "Incorrect element! WA!\n";
            exit(0);
        }
    }

    std::cout << "Correct!: " << score() << "%\n";
    return 0;
}
