#include<iostream>
#include<set>
#define INT_MAX 1e9+7
using namespace std;
const long long MAXN = 11;
const long long MAXM = 7;
long long dp[MAXM];
long long n,m;
long long nbus[MAXM];
struct bus{
    long long dist;
    long long cost;
};
struct student{
    long long dist;
    long long cost;
};
bus b[MAXN];
student s[MAXM];
long long test(long long x){
    long long ans=0;
    set<int> used;
    for(long long i=0;i<x;i++){
        long long curr=nbus[i];
        if(s[i].dist<b[curr].dist) return INT_MAX;
        ans+=(s[i].dist-b[curr].dist)*s[i].cost;
        used.insert(curr);
    }
    for(auto t:used){
        ans+=b[t].cost;
    }
    return ans;
}
void next(long long x){
    long long temp=x;
    x--;
    nbus[x]++;
    while(nbus[x]==n){
        nbus[x]=0;
        nbus[x-1]++;
        x--;
        if(x==-1){
            nbus[0]=n;
            nbus[temp-1]=n;
        }
    }
    return ;
}
void reset(){
    for(long long i=0;i<m;i++) nbus[i]=0;
}
int main(){
    cin>>n;
    for(long long i=0;i<n;i++){
        cin>>b[i].dist>>b[i].cost;
    }
    cin>>m;
    for(long long i=0;i<m;i++){
        cin>>s[i].dist>>s[i].cost;
        nbus[i]=0;
    }
    for(long long i=1;i<=m;i++){
        long long currans=INT_MAX;
        while(!(nbus[0]==n and nbus[i-1]==n)){
            currans=min(currans,test(i));
            next(i);
        }
        cout<<currans<<" ";
        reset();
    }
    cout<<"\n";
    return 0;
}
