#include<bits/stdc++.h>
using namespace std;

bool visited[100005];
vector<long long> graph[100005];
long long n, m;
long long bb = 2*100000;
long long mod = 1000000000+7;
long long ans= 0;

long long power(long long p){
    if(p == 0) return 1;
    long long curr = bb;
    for(int i = 2; i < p; i++){
        for(int j = 0; j < 6; j++){
            curr=(curr*2)%mod;
        }
        for(int j = 0; j < 5; j++){
            curr=(curr*5)%mod;
        }

    }
    return curr;
}

/*bool dfs(int finish, int curr){
    cout << curr << endl;
    visited[curr] = true;
    bool nopath = true;
    if(curr == finish) {
            cout << "eloooooo" << endl;
            return true;
    }
    for(auto i : graph[curr]){
        if(!visited[i]){
            dfs(finish, i);
            nopath = false;
        }
    }
}*/

bool bfs(long long start, long long finish){
    queue<long long> q;
    q.push(start);
    if(start == finish) return true;
    while(!q.empty()){
        long long curr = q.front();
        q.pop();
        for(auto i : graph[curr]){
            if(!visited[i]){
                q.push(i);
                visited[i] = true;
                if(i == finish){
                    return true;
                }
            }
        }
    }
    return false;
}

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m;
    for(long long i = 0; i < m; i++){
        long long s, f;
        cin >> s >> f;
        graph[s].push_back(f);
    }
    long long qq;
    cin >> qq;
    long long a, b;
    bool ab = false;
    bool ba = false;
    int k = qq;
    for(long long idx =0; idx < qq; idx++){
        k--;
        cin >> a >> b;
        ab = false;
        ba = false;
        for(long long i = 1; i <= n; i++) visited[i] = false;
        ab = bfs(b, a);
        for(long long i = 1; i <= n; i++) visited[i] = false;
        ba = bfs(a, b);
        if(ab and ba){
            ans+=((m+1)*power(k))%mod;
            ans%=mod;
        }
    }

    cout << ans%mod;
    //cout << pow(10, 0);

return 0;
}
