#include<bits/stdc++.h>
#include "sorting.h"
using namespace std;

// compare(int x,int y);
// divisible(int x,int y,int d);

vector<vector<int>> chains;
vector<int> joinChain(int x,int y){
    vector<int> new_res;
    for(int i=0;i<chains.size();i++){
        new_res.push_back(chains[x][i]);
        new_res.push_back(chains[y][i]);
    }
    return new_res;
}

std::vector<int> solve(int N){
    int d=pow(2,ceil(log2(N)));
    for(int i=1;i<N;i++){
        for(int j=i+1;j<=N+1;j++){
            if(j==N+1){
                chains.push_back({i,j});
                break;
            }
            if(divisible(i,j,d)){
                if(compare(i,j)) {
                    chains.push_back({i,j});
                } else {
                    chains.push_back({j,i});
                }
                break;
            }
        }
    }
    vector<vector<int>> new_chain;
    while(d>0){
        d/=2;
        for(int i=0;i<N-1;i++){
            for(int j=i+1;j<N;j++){
                if(divisible(chains[i][0],chains[j][0],d)){
                    if(compare(chains[i][0],chains[j][0])) new_chain.push_back(joinChain(i,j));
                    else new_chain.push_back(joinChain(j,i));
                    break;
                }
            }
        }
        chains=new_chain;
        new_chain.clear();
    }
    vector<int> res;
    res.resize(N);
    for(int i=0;i<N;i++){
        res[chains[0][i]-1]=i+1;
    }
    return res;
}
