#include <bits/stdc++.h>
#include "sorting.h"

using namespace std;

const int maxn = 5e5 + 10;
int tree[4 * maxn];

void make_tree(int i, int l, int r){
    if(l == r){
        tree[i] = l;
        return;
    }
    int mid = (l + r) / 2;
    make_tree(2 * i, l, mid);
    make_tree(2 * i + 1, mid + 1, r);
    if(compare(tree[2 * i], tree[2 * i + 1]))
        tree[i] = tree[2 * i];
    else
        tree[i] = tree[2 * i + 1];
}

void update(int i, int l, int r, int x){
    if(l == r){
        tree[i] = 0;
        return;
    }
    int mid = (l + r) / 2;
    if(x <= mid) update(2 * i, l, mid, x);
    else update(2 * i + 1, mid + 1, r, x);
    if(tree[2 * i] && tree[2 * i + 1]){
        if(compare(tree[2 * i], tree[2 * i + 1]))
            tree[i] = tree[2 * i];
        else
            tree[i] = tree[2 * i + 1];
    }
    else
        tree[i] = tree[2 * i] + tree[2 * i + 1];
}

vector<int> solve(int N){
    vector<int> ans;
    make_tree(1, 1, N);
    ans.resize(N);
    ans[tree[1] - 1] = 1;
    for(int i = 1;i <= N - 1;i++){
        update(1, 1, N, tree[1]);
        ans[tree[1] - 1] = i + 1;
    }
    return ans;
}
