#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int64_t MAXN = int64_t(2e4) + 50;
const int64_t MAXM = int64_t(1e3) + 50;
const int64_t INF = int64_t(2e18) + 50LL;
struct Bus
{
    int64_t x, c;
    Bus(){}
    Bus(int64_t x, int64_t c)
        :x(x), c(c){}
};

struct Person
{
    int64_t x, v;
    Person(){}
    Person(int64_t x, int64_t v)
        :x(x), v(v){}
};

int64_t n, m, prevV;
Bus buses[MAXN];
Person people[MAXM];

int64_t dp[MAXN][2], ans[MAXM]; //minimal price if the first j people go on buses from 1 to i

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    bool isSecondSubtask = true;

    cin >> n;
    for (int64_t i = 1; i <= n; i++)
        cin >> buses[i].x >> buses[i].c;

    cin >> m;
    cin >> people[1].x >> people[1].v;
    prevV = people[1].v;

    for (int64_t i = 2; i <= m; i++)
    {
        cin >> people[i].x >> people[i].v;

        if (people[i].v != prevV)
            isSecondSubtask = false;
    }

    /*if (isSecondSubtask == true)
    {
        secondSubtask();
        return 0;
    }*/

    for (int64_t i = 1; i <= n; i++)
        dp[i][0] = dp[i][1] = INF;
    for (int64_t i = 1; i <= m; i++)
        ans[i] = INF;

    for (int64_t i = 1; i <= n; i++)
    {
        if (people[1].x < buses[i].x)
            break;

        dp[i][(1&1)] = (people[1].x - buses[i].x)*people[1].v + buses[i].c;
        ans[1] = min(ans[1], dp[i][(1&1)]);
    }

    for (int64_t i = 1; i <= n; i++)
    {
        for (int64_t j = 2; j <= m; j++)
        {
            if (people[j].x < buses[i].x)
                continue;

            dp[i][j&1] = min(dp[i][(j-1)&1], ans[j-1]+buses[i].c);

            dp[i][j&1] += (people[j].x - buses[i].x)*people[j].v;
            ans[j] = min(ans[j], dp[i][j&1]);
        }
    }

    for (int64_t j = 1; j <= m; j++)
    {
        cout << ans[j] << " ";
    }

    cout << endl;
    return 0;
}
