#include <bits/stdc++.h>
#define endl '\n'

#ifdef __LOCAL__
    #include "Lgrader.cpp"
#else
    #include "sorting.h"
#endif // __LOCAL__
using namespace std;

vector <int> primes;
bool isPrime(int n)
{
    for (int i = 2; i*i <= n; i++)
        if (n%i == 0)
            return false;

    return true;
}

void precompute(int n)
{
    primes.reserve(41000);
    primes.push_back(1);
    for (int i = 2; i <= n; i++)
        if (isPrime(i))
            primes.push_back(i);
}
int findBiggestDivisor(int n, int a, int b)
{
    for (int i = n-1; i>= 1; i--)
        if (divisible(a, b, i))
            return i;

    return -1;
}

vector <int> solve(int n)
{
    vector <int> deltaValue(n);

    int br1 = 0;
    deltaValue[0] = 0;
    for (int i = 1; i < n; i++)
    {
        bool cmp = compare(1, i+1);
        int biggestDivisor = findBiggestDivisor(n, 1, i+1);

        if (cmp == true)
        {
            deltaValue[i] = biggestDivisor;
            br1++;
        }

        else
            deltaValue[i] = -biggestDivisor;
    }
    deltaValue[0] = n-br1;

    for (int i = 1; i < n; i++)
        deltaValue[i] += deltaValue[0];

    return deltaValue;

}
