#include <bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN = 2005, MAXQ = 1e5+1;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int n, m;
vector < pair <int, int > > v[MAXN];

void read_graph()
{
    cin >> n >> m;
    int x, y;
    for (int i = 0; i < m; ++ i)
    {
        cin >> x >> y;
        v[x].push_back(make_pair(y, i+1));
    }
}
vector < int > ans;
int a, b;
int need;
int used[MAXN], del = 0;
bool dfs(int beg)
{
    used[beg] = 1;
if(beg == need)return true;
    int nb;
    bool ok = false;
    for (int i = 0; i < v[beg].size(); ++ i)
    {
        nb = v[beg][i].first;
        if(!used[nb] && v[beg][i].second != del)
        {
            if(dfs(nb) == true)ok = true;
        }
    }
    return ok;
}
void solve_query()
{
    memset(used, 0, sizeof(used));
    del = 0;
    need = b;
    int res1 = dfs(a);
    memset(used, 0, sizeof(used));
    need = a;
    int res2 = dfs(b);
    if(!res1 || !res2)
    {
        ans.push_back(0);
        return;
    }

    ans.push_back(m+1);
}
long long st[MAXQ], mod  = 1e9 + 7;
void precompute_st()
{
    st[0] = 1;
    for (int i = 1; i <= MAXQ - 1; ++ i)
    {
        st[i] = st[i-1] * 2e5;
        st[i] %= mod;
    }
}
void queries()
{
    int q;
    cin >> q;
    int q1;
    if(q != 0)
    {
        q1 = q;
    while(q --)
    {
        cin >> a >> b;
        solve_query();
    }
    }
    else
    {
        for (int i = 1; i <= n; ++ i)
        {
            for (int j = i+1; j <= n; ++ j)
            {
                a = i;
                b = j;
                solve_query();
            }
        }
        q1 = n * (n-1)/2;
    }
    long long res = 0;
    for (int i = 0; i < ans.size(); ++ i)
    {
       // cout << ans[i] << " ";
        res += st[q1-1-i] * ans[i];
        res %= mod;
    }
   // cout << endl;
    cout << res << endl;
}
int main()
{
    speed();

    read_graph();
    precompute_st();
    queries();
    return 0;
}
