#include<iostream>
#include<bits/stdc++.h>
using namespace std;
vector<int> edges[2022];
bool bfs(int st, int en,int ban)
{
    bool used[2022],fl=0;
    memset(used,0,2022);
    queue<int> q;
    q.push(st);
    used[st]=1;
    while(!q.empty())
    {
        int curr=q.front();
        q.pop();
        for(int i=0;i<edges[curr].size();i++)
        {
            int now=edges[curr][i];
            if(now==en){fl=1;break;}
            if(used[now]==0 && now!=ban)
            {
                used[now]=1;
                q.push(now);
            }
        }
        if(fl==1)break;
    }
    if(fl==0)return 0;
    queue<int> q2;
    q2.push(en);
    memset(used,0,2022);
    fl=0;
    while(!q2.empty())
    {
        int curr=q2.front();
        q2.pop();
        for(int i=0;i<edges[curr].size();i++)
        {
            int now=edges[curr][i];
            if(now==st){fl=1;break;}
            if(used[now]==0 && now!=ban)
            {
                used[now]=1;
                q2.push(now);
            }
        }
        if(fl==1)break;
    }
    if(fl==0)return 0;
    else return 1;
}
int calc(int st, int en,int m,int n)
{
    if(bfs(st,en,-1)==0)return 0;
    for(int i=1;i<=n;i++)
    {
        if(i==st || i==en)continue;
        if(bfs(st,en,i)==0)return i;
    }
    return m+1;
}
int main()
{
    int n,m,a,b,q,B=200000;
    long long ans=0,mod=1000000007,kq;
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n>>m;
    kq=(n*(n+1))/2;
    for(int i=0;i<m;i++)
    {
        cin>>a>>b;
        edges[a].push_back(b);
        edges[b].push_back(a);
    }
    cin>>q;
    if(q>0)
    {
        for(int t=0;t<q;t++)
        {
            long long res,calca;
            cin>>a>>b;
            res=calc(a,b,m,n);
            calca=pow(B,q-1);
            calca%=mod;
            ans+=(res*calca)%mod;
            ans%=mod;
        }
    }
    else
    {
        for(int i=1;i<=n-1;i++)
        {
            for(int j=i+1;j<=n;j++)
            {
                long long res,calca;
                res=calc(i,j,m,n);
                calca=pow(B,kq);
                calca%=mod;
                ans+=(res*calca)%m;
                ans%=mod;
            }
        }
    }
    cout<<ans<<"\n";
}