#include<bits/stdc++.h>
#include "sorting.h"


using namespace std;


int a[500001];
int tree[2000001];

void maketree(int i, int l, int r)
{
    if(l==r)
    {
        tree[i]=l;
        return;
    }
    int m=(l+r)/2;
    maketree(2*i, l, m);
    maketree(2*i+1, m+1, r);
    bool b=compare(tree[2*i], tree[2*i+1]);
    if(b)
    {
        tree[i]=tree[2*i+1];
    }
    else
        tree[i]=tree[2*i];
}

void update(int i, int l, int r, int mx)
{
    if(l==r)
    {
        tree[i]=0;
        return;
    }
    int m=(l+r)/2;
    if(tree[2*i]==mx)
    {
        update(2*i, l, m, mx);
    }
    else if(tree[2*i+1]==mx)
    {
        update(2*i+1, m+1, r, mx);
    }

    if(tree[2*i]==0)
    {
        tree[i]=tree[2*i+1];
    }
    else if(tree[2*i+1]==0)
    {
        tree[i]=tree[2*i];
    }
    else
    {
        bool b=compare(tree[2*i], tree[2*i+1]);
        if(b)
        {
            tree[i]=tree[2*i+1];
        }
        else
            tree[i]=tree[2*i];
    }
}

std::vector<int> solve(int N)
{
    vector<int>ans;
    maketree(1, 1, N);
    a[tree[1]]=N;
    for(int i=1; i<N; i++)
    {
        update(1, 1, N, tree[1]);
        a[tree[1]]=N-i;
    }
    for(int i=1; i<=N; i++)
    {
        //cout<<a[i]<<endl;
        ans.push_back(a[i]);
    }
    return ans;
}
