#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <deque>
#include <queue>
#include <stack>
#include <ctime>
using namespace std;

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second

struct Point {
	ll pos;
	ll v;
	ll c;
	bool is_bus;
	Point(ll _pos, ll _v) {
		is_bus = false;
		pos = _pos;
		v = _v;
		c = 0;
	}
	Point(ll _pos, ll _c, ll _t) {
		is_bus = true;
		c = _c;
		pos = _pos;
		v = 0;
	}
	bool operator<(const Point& x)const {
		if (pos == x.pos) {
			return is_bus;
		}
		return pos < x.pos;
	}
};

ll ttt;
const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ll N = 2e5 + 7;
ll n, m, k;
vector<Point>p;
ll ans[N];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	for (int i = 0; i < n; i++) {
		ll pos, c;
		cin >> pos >> c;
		p.push_back(Point(pos, c, 0));
	}
	cin >> m;
	ll vs;
	for (int i = 0; i < m; i++) {
		ll pos, v;
		cin >> pos >> v;
		vs = v;
		p.push_back(Point(pos, v));
	}
	sort(p.begin(), p.end());
	ll cur_val = 0;
	ll lst_pos = 0;
	for (Point x : p) {
		cur_val += (x.pos - lst_pos) * vs;
		lst_pos = x.pos;
		if (x.is_bus) {
			cur_val = min(cur_val, x.c);
		}
		else {
			cout << cur_val << " ";
		}
	}
	cout << endl;
}