#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <deque>
#include <queue>
#include <stack>
#include <ctime>
using namespace std;

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second

struct Point {
	ll pos;
	ll ind;
	ll v;
	bool is_bus;
	Point(ll _pos, ll _v, ll _ind, bool _is_bus) {
		is_bus = _is_bus;
		pos = _pos;
		v = _v;
		ind = _ind;
	}
	bool operator<(const Point& x)const {
		if (pos == x.pos) {
			if (is_bus && !x.is_bus)return true;
			if (!is_bus && x.is_bus)return false;
			return ind < x.ind;
		}
		return pos < x.pos;
	}
};

ll ttt;
const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ll N = 2e5 + 7;
ll n, m, k;
vector<Point>p;
ll ans[N];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	for (int i = 0; i < n; i++) {
		ll pos, c;
		cin >> pos >> c;
		p.push_back(Point(pos, c, i, true));
	}
	cin >> m;
	ll vs = 0;
	for (int i = 0; i < m; i++) {
		ll pos, v;
		cin >> pos >> v;
		vs = v;
		p.push_back(Point(pos, v, i, false));
	}
	sort(p.begin(), p.end());
	ll cur_val = 0;
	ll lst_pos = 0;
	ll cur_ans = 0;
	for (Point x : p) {
		//cout << x.pos << " " << x.is_bus << endl;
		cur_val += (x.pos - lst_pos) * vs;
		lst_pos = x.pos;
		if (x.is_bus) {
			cur_val = min(cur_val, x.v);
		}
		else {
			cur_ans += cur_val;
			cout << cur_ans << " ";
		}
	}
	cout << endl;
}