#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <set>
#include <queue>
#include <map>
#include <iomanip>
using namespace std;

#define ll long long
#define vi vector<int>
#define vll vector<ll>
#define pii pair<int, int>
#define mpr make_pair
#define yes cout<<"YES\n"
#define no cout<<"NO\n"

const int N = 100005, M = 2005;
const ll MOD = 1000000007, B = 200000;
vi g[N];
bool color[M][M];
int n, m, st;

ll bpow(ll a, ll b) {
    if (!a) {
        return 0;
    }
    ll ans = 1;
    while (b) {
        if (b & 1) {
            ans *= a;
            ans %= MOD;
        }
        b >>= 1;
        a *= a;
        a %= MOD;
    }
    return ans;
}

void dfs(int v) {
    color[st][v] = true;
    for (auto u : g[v]) {
        if (!color[st][u]) {
            dfs(u);
        }
    }
}

void solve() {
    cin >> n >> m;
    for (int i = 1; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        g[x].push_back(y);
    }
    int w, e;
    cin >> w >> e;
    for (int i = 1; i <= n; ++i) {
        st = i;
        dfs(i);
    }
    ll ans = 0;
    int q;
    cin >> q;
    ll num = 1;
    if (q != 0) {
        ll num = q - 1;
        while (q--) {
            int x, y;
            cin >> x >> y;
            if (color[x][y]) {
                ans += bpow(B, num) * (long long)(m + 1);
                ans %= MOD;
            }
            --num;
        }
    }
    else {
        ll num = (long long)n * (long long)(n + 1) / 2LL - 1LL;
        for (int i = 1; i <= n; ++i) {
            for (int j = i; j <= n; ++j) {
                if (color[i][j]) {
                    ans += bpow(B, num) * (long long)(m + 1);
                    ans %= MOD;
                }
                --num;
            }
        }
    }
    cout << ans << "\n";
}

void precalc() {

    return;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    precalc();
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}