#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <set>
#include <queue>
#include <map>
#include <iomanip>
#include <assert.h>
using namespace std;

#define ll long long
#define vi vector<int>
#define vll vector<ll>
#define pii pair<int, int>
#define mpr make_pair
#define yes cout<<"YES\n"
#define no cout<<"NO\n"

const int N = 100005, M = 2005;
const ll MOD = 1000000007, B = 200000;
vi g[N];
bool color[M][M];
ll b[5000005];
int n, m, st;

void dfs(int v) {
    color[st][v] = true;
    for (auto u : g[v]) {
        if (!color[st][u]) {
            dfs(u);
        }
    }
}

void solve() {
    cin >> n >> m;
    for (int i = 1; i <= m; ++i) {
        int x, y;
        cin >> x >> y;
        g[x].push_back(y);
    }
    for (int i = 1; i <= n; ++i) {
        st = i;
        dfs(i);
    }
    ll ans = 0;
    int q;
    cin >> q;
    b[0] = 1LL;
    int k = (q == 0) ? (n * (n + 1) / 2) : q;
    ll s = 1;
    for (int i = 1; i <= k; ++i) {
        s *= B;
        s %= MOD;
        b[i] = s;
    }
    if (q != 0) {
        int num = q - 1;
        while (q--) {
            int x, y;
            cin >> x >> y;
            if (color[x][y]) {
                ans += b[num] * (long long)(m + 1);
                ans %= MOD;
            }
            --num;
        }
    }
    else {
        int num = n * (n + 1) / 2 - 1;
        int hashv = 0;
        for (int i = 1; i <= n; ++i) {
            for (int j = i; j <= n; ++j) {
                if (color[i][j]) {
                    ans += b[num] * (long long)(m + 1);
                    ans %= MOD;
                }
                --num;
                ++hashv;
            }
        }
        assert(hashv == n * (n + 1) / 2);
    }
    cout << ans << "\n";
}

void precalc() {

    return;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    precalc();
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}