#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <set>
#include <queue>
#include <map>
#include <iomanip>
#include <assert.h>
using namespace std;

#define ll long long
#define vi vector<int>
#define vll vector<ll>
#define pii pair<int, int>
#define mpr make_pair
#define yes cout<<"YES\n"
#define no cout<<"NO\n"

const int N = 1005, M = 205;
const ll MOD = 1000000007, B = 200000;
vi g[N];
bool color[M][N][M];
pii c[N];
ll b[5000005];
int n, m;
int x1, x2;
map<pii, int> mp;

void dfs(int v) {
    color[x1][x2][v] = true;
    for (auto u : g[v]) {
        if (!color[x1][x2][u] && (mp[mpr(v, u)] > m || mp[mpr(v, u)] != x2)) {
            dfs(u);
        }
    }
}

void solve() {
    cin >> n >> m;
    for (int i = 1; i <= m; ++i) {
        int x, y;
        cin >> x >> y;
        c[i] = mpr(x, y);
        g[x].push_back(y);
        if (mp[mpr(x, y)]) {
            mp[mpr(x, y)] = m + 5;
        }
        else {
            mp[mpr(x, y)] = i;
        }
    }
    /*for (int i = 1; i <= m; ++i) {
        cout << mp[c[i]] << ' ';
    }
    cout << "\n";*/
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j <= m; ++j) {
            x1 = i, x2 = j;
            dfs(i);
        }
    }
    ll ans = 0;
    int q;
    cin >> q;
    ll s = 1;
    b[0] = 1;
    for (int i = 1; i <= q; ++i) {
        b[i] = b[i - 1] * B;
        b[i] %= MOD;
    }
    int num = q - 1;
    assert(q != 0);
    while (q--) {
        int x, y;
        cin >> x >> y;
        if (!color[x][0][y] || !color[y][0][x])
            continue;
        bool f = true;
        for (int j = 1; j <= m; ++j) {
            if (!color[x][j][y] || !color[y][j][x]) {
                ans += b[num] * (long long)(j);
                ans %= MOD;
                //cout << j << '\n';
                f = false;
                break;
            }
        }
        if (f) {
            //cout << m + 1 << "\n";
            ans += b[num] * (long long)(m + 1);
            ans %= MOD;
        }
        --num;
    }
    cout << ans << "\n";
}

void precalc() {

    return;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    precalc();
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}