#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <cmath>
using ll = long long;
using namespace std;
vector<int> v[2005], vf[2005];
vector<int> tout;
int used[2005];

void Dfs1(int g)
{
	used[g] = 1;
	for (auto to : v[g])
	{
		if (used[to] == 0)
			Dfs1(to);
	}
	tout.push_back(g);
}

int gu = 1;
int color[2005];
void Dfs2(int g)
{
	color[g] = gu;
	for (auto to : vf[g])
	{
		if (color[to] == 0)
			Dfs2(to);
	}
}

int ma[2005][2005];
vector<int> vv[2005];
int aj[2005], dzax[2005];

void solve()
{
	int n, m, i, j, x, y, stt = 0;
	cin >> n >> m;
	for ( i = 0; i < m; i++)
	{
		cin >> x >> y;
		v[x].push_back(y);
		vf[y].push_back(x);
		if (abs(x - y) == 1 && ma[x][y] == 0)
		{
			ma[x][y] = i + 1;
			stt++;
		}
		else
			vv[x].push_back(y);
	}
	if (stt == (n - 1) * 2)
	{
		for (i = 1; i <= n; i++)
		{
			aj[i] = i;
			dzax[i] = i;
		}
		for (i = 1; i <= n; i++)
		{
			for (auto to : vv[i])
			{
				aj[i] = max(aj[i], to);
			}
			for (j = i; j <= aj[i]; j++)
			{
				aj[j] = max(aj[j], aj[i]);
			}
		}
		for (i = n; i >= 1; i--)
		{
			for (auto to : vv[i])
			{
				dzax[i] = min(dzax[i], to);
			}
			for (j = i; j >= dzax[i]; j--)
			{
				dzax[j] = min(dzax[j], dzax[i]);
			}
		}
		int q;
		cin >> q;
		vector<int> ja;
		for (i = 0; i < q; i++)
		{
			cin >> x >> y;
			if (x > y)
				swap(x, y);
			int minind = 1000000000;
			for ( j = x; j <= y; j++)
			{
				if (aj[j] < y)
				{
					minind = min(minind, ma[aj[j]][aj[j] + 1]);
				}
			}
			for ( j = x; j <= y; j++)
			{
				if (x < dzax[j])
				{
					minind = min(minind, ma[j + 1][j]);
				}
			}
			if (minind == 1000000000)
			{
				ja.push_back(m + 1);
			}
			else
			{
				ja.push_back(minind);
			}
		}
		ll b = 1, ans = 0, mod = 1000000007;
		for (i = ja.size() - 1; i >= 0; i--)
		{
			ans = (ans + (ja[i] * b) % mod) % mod;
			b = (b * 200000LL) % mod;
		}
		cout << ans;
	}
	else
	{
		for (i = 1; i <= n; i++)
		{
			if (used[i] == 0)
				Dfs1(i);
		}
		for (i = 1; i <= n; i++)
		{
			if (color[tout[n - i]] == 0)
			{
				Dfs2(tout[n - i]);
				gu++;
			}
		}
		int q;
		cin >> q;
		if (q == 0)
		{
			ll b = 1, ans = 0, mod = 1000000007;
			for (i = n; i >= 1; i--)
			{
				for (j = n; j >= i; j--)
				{
					if (color[i] == color[j])
					{
						ans = (ans + ((m + 1LL) * b) % mod) % mod;
					}
					b = (b * 200000LL) % mod;
				}
			}
			cout << ans;
		}
		else
		{
			vector<int> ja;
			for (i = 0; i < q; i++)
			{
				cin >> x >> y;
				if (color[x] == color[y])
					ja.push_back(m + 1);
				else
					ja.push_back(0);
			}
			ll b = 1, ans = 0, mod = 1000000007;
			for (i = ja.size() - 1; i >= 0; i--)
			{
				ans = (ans + (ja[i] * b) % mod) % mod;
				b = (b * 200000LL) % mod;
			}
			cout << ans;
		}
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int tt = 1;
	//cin >> tt;
	while (tt--)
	{
		solve();
	}
	return 0;
}