#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
const int N = 1e3 + 10, M = 1e2 + 10;
const long long INF = 2e18 + 10;
long long y[N], c[N], x[N], v[N];
struct esim {
	int t;
	long long a;
	long long b;
};
bool cmp(esim x, esim y) {
	if (x.a != y.a) return x.a < y.a;
	return x.t < y.t;
}
int main()
{
	int n, m;
	cin >> n;
	vector <esim> vec;
	for (int i = 1; i <= n; i++) {
		scanf("%lld%lld", &y[i], &c[i]);
		vec.push_back({ 1, y[i], c[i] });
	}
	cin >> m;
	for (int i = 1; i <= m; i++) {
		scanf("%lld%lld", &x[i], &v[i]);
		vec.push_back({ 2, x[i], v[i] });
	}
	sort(vec.begin(), vec.end(), cmp);
	vector <long long> ans;
	long long mn = INF;
	for (auto it : vec) {
		if (it.t == 1) {
			mn = min(mn, it.b - v[1] * it.a);
		}
		else {
			if (ans.empty()) ans.push_back(it.a * it.b + mn);
			else ans.push_back(ans.back() + it.a * it.b + mn);
		}
	}
	for (auto it : ans)
		printf("%lld ", it);
}