#include "sorting.h"
#include <vector>
#include <iostream>
using namespace std;
std::vector < int > solve(int N)
{ 
	vector <bool> prime(N, true);
	vector <int> primes;
	prime[0] = false;
	prime[1] = false;
	for (long long i = 2; i < N; i++) {
		if (prime[i]) {
			primes.push_back(i);
			for (long long j = i * i; j < N; j += i)
				prime[j] = false;
		}
	}
	int num = 1;
	for (int i = 2; i <= N; i++) {
		if (compare(num, i) == false) num = i;
	}
	std::vector <int> ans(N);
	ans[num - 1] = 1;
	for (int i = 1; i <= N; i++) {
		if (i == num) continue;
		int k = 1;
		for (auto it : primes) {
			int q = it;
			bool ch = true;
			while (q < N && divisible(num, i, q)) {
				q *= it;
			}
			q /= it;
			k *= q;
		}
		ans[i - 1] = k + 1;
	}
	return ans;
}