#include "sorting.h"
#include <vector>
#include <iostream>
#include <algorithm>
#include <cmath>
using namespace std;
long long gcd(long long a, long long b) {
	while (a && b) {
		if (a > b) a %= b;
		else b %= a;
	}
	return a + b;
}
std::vector < int > solve(int N)
{ 
	int num = 1;
	for (int i = 2; i <= N; i++) {
		if (compare(num, i) == false) num = i;
	}
	std::vector <int> ans(N);
	ans[num - 1] = 1;
	for (int i = 1; i <= N; i++) {
		if (i == num) continue;
		long long last = 1;
		for (long long j = 2; j < N; j += last) {
			if (divisible(i, num, j)) {
				last = last * j / gcd(last, j);
				j = last;
			}
		}
		ans[i - 1] = last + 1;
	}
	return ans;
}