#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <random>
using namespace std;

typedef long long ll;

#define pb push_back
#define ff first
#define ss second
#define mpr make_pair

const ll MOD = ll(1000000007);

// ------------------------------------------------- //

const int N = 2005;
bool g[N][N];
int n;

vector<int> ans;

void solve()
{
	int i, j;
	int k;

	int m, q;

	cin >> n >> m;
	for (i = 1; i <= m; i++) {
		int u, v;
		cin >> u >> v;
		g[u][v] = 1;
	}

	for (k = 1; k <= n; k++) {
		for (i = 1; i <= n; i++) {
			for (j = 1; j <= n; j++) {
				if (k != i && k != j && i != j) {
					g[i][j] |= (g[i][k] & g[k][j]);
				}
			}
		}
	}

	cin >> q;

	for (i = 1; i <= q; i++) {
		int a, b;
		cin >> a >> b;

		if (!g[a][b] || !g[b][a]) ans.pb(0);
		else ans.pb(m + 1);
	}

	reverse(ans.begin(), ans.end());

	ll res = 0, curr = 1;

	for (i = 0; i < q; i++) {
		res += curr * ll(ans[i]);
		res %= MOD;
		curr *= 200000;
		curr %= MOD;
	}

	cout << res << "\n";

	return;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	solve();

	return 0;
}