#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <random>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;

#define pb push_back
#define ff first
#define ss second
#define mpr make_pair

const ll MOD = ll(1000000007);
const ull MAXL = ull(2000000000000000005);

// ------------------------------------------------- //

const int N = 20005, M = 1005;
ull x[M], v[M];
ull y[N], c[N];
int n, m;

ull dp[M][N];

void solve()
{
	int i, j;

	ull mn = MAXL, mx = 0, p = 0;

	cin >> n;
	for (i = 1; i <= n; i++) {
		cin >> y[i] >> c[i];
	}

	cin >> m;
	for (i = 1; i <= m; i++) {
		cin >> x[i] >> v[i];
		mn = min(mn, v[i]);
		mx = max(mx, v[i]);
	}

	if (mn == mx) p = 1;

	for (i = 0; i <= m + 2; i++) {
		for (j = 0; j <= n + 2; j++) {
			dp[i][j] = MAXL;
		}
	}

	dp[0][0] = 0;

	int k;

	for (i = 0; i < m; i++) {
		for (j = 0; j <= n; j++) {
			for (k = j + 1; y[k] <= x[i + 1] && k <= n; k++) {
				dp[i + 1][k] = min(dp[i + 1][k], dp[i][j] + (x[i + 1] - y[k]) * v[i + 1] + c[k]);
			}
			if (j) {
				dp[i + 1][j] = min(dp[i + 1][j], dp[i][j] + (x[i + 1] - y[j]) * v[i + 1] + p * c[j]);
			}
		}
	}

	/*for (i = 0; i <= m; i++) {
		for (j = 0; j <= n; j++) {
			cout << i << ' ' << j << ' ' << dp[i][j] << "\n";
		}
	}*/

	ull ans;

	for (i = 1; i <= m; i++) {
		ans = MAXL;
		for (j = 1; j <= n; j++) {
			ans = min(ans, dp[i][j]);
		}

		cout << ans << ' ';
	}
	cout << "\n";
	
	return;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	solve();

	return 0;
}