#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <random>
#include <cstdio>
#include <stdio.h>
#include <cstdlib>
#include <stdlib.h>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;

#define pb push_back
#define ff first
#define ss second
#define mpr make_pair

const ll MOD = ll(1000000007);
const ull MAXL = ull(2000000000000000005);

// ------------------------------------------------- //

const int N = 20005, M = 1005;
ull x[M], v[M];
ull y[N], c[N];
int n, m;

ull dp[N][2], ndp[N][2];

void solve()
{
	int i, j;

	cin >> n;
	for (i = 1; i <= n; i++) {
		cin >> y[i] >> c[i];
	}

	ull cc;

	cin >> m;
	for (i = 1; i <= m; i++) {
		cin >> x[i] >> v[i];
	}

	for (i = 0; i <= m + 2; i++) {
		for (j = 0; j <= n + 2; j++) {
			dp[j][0] = dp[j][1] = ndp[j][0] = ndp[j][1] = MAXL;
		}
	}

	ull ans;

	dp[0][1] = 0;

	int k;

	for (i = 0; i < m; i++) {
		for (j = 0; j <= n; j++) {
			if (j < n) {
				dp[j + 1][0] = min(dp[j + 1][0], min(dp[j][0], dp[j][1]));
			}
			if (j < n && y[j + 1] <= x[i + 1]) {
				ndp[j + 1][1] = min(ndp[j + 1][1], min(dp[j][0], dp[j][1]) + (x[i + 1] - y[j + 1]) * v[i + 1] + c[j + 1]);
			}
			if (j && y[j] <= x[i + 1]) {
				ndp[j][1] = min(ndp[j][1], dp[j][1] + (x[i + 1] - y[j]) * v[i + 1]);
				ndp[j][1] = min(ndp[j][1], dp[j][0] + (x[i + 1] - y[j]) * v[i + 1] + c[j]);
			}
		}

		ans = MAXL;

		for (j = 0; j <= n; j++) {
			//cout << i << ' ' << j << ' ' << dp[j][0] << ' ' << dp[j][1] << "\n";
			dp[j][0] = ndp[j][0];
			dp[j][1] = ndp[j][1];
			ndp[j][0] = ndp[j][1] = MAXL;

			ans = min(ans, min(dp[j][0], dp[j][1]));
		}

		printf("%lu ", ans);
	}

	cout << "\n";
	
	return;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	solve();

	return 0;
}