#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <random>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;

#define pb push_back
#define ff first
#define ss second
#define mpr make_pair

const ll MOD = ll(1000000007);
const ull MAXL = ull(2000000000000000005);

// ------------------------------------------------- //

const int N = 20005, M = 1005;
ull x[M], v[M];
ull y[N], c[N];
ull h[N];
int n, m;

ull ans[M], p[M];

void solve()
{
	int i, j;

	cin >> n;
	for (i = 1; i <= n; i++) {
		cin >> y[i] >> c[i];
	}

	ull vv;

	cin >> m;
	for (i = 1; i <= m; i++) {
		cin >> x[i] >> v[i];
		vv = v[i];
	}

	h[0] = MAXL;

	for (i = 1; i <= n; i++) {
		h[i] = min(h[i - 1] + vv * (y[i] - y[i - 1]), c[i]);
	}

	for (i = 1; i <= m; i++) {
		j = upper_bound(y + 1, y + n + 1, x[i]) - y;
		j--;

		ans[i] = vv * (x[i] - y[j]) + h[j];
		p[i] = p[i - 1] + ans[i];

		cout << p[i] << ' ';
	}

	cout << "\n";

	return;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	solve();

	return 0;
}