#include <iostream>
#include <cmath>
#include <algorithm>
#include <cstdio>
#include <stdio.h>
#include <cstdlib>
#include <stdlib.h>
#include <numeric>
#include <climits>
#include <limits.h>
#include <chrono>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;

const ll MAXL = ll(2000000000000000005);

// ------------------------------------------------- //

const int N = 20001, M = 1001;
ll x[M], v[M];
ll y[N], c[N];
int n, m;

ll dp[N][2], ndp[N][2];

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int i, j;

	cin >> n;
	for (i = 1; i <= n; i++) {
		cin >> y[i] >> c[i];
	}

	cin >> m;
	for (i = 1; i <= m; i++) {
		cin >> x[i] >> v[i];
	}

	for (i = 0; i <= m; i++) {
		for (j = 0; j <= n; j++) {
			dp[j][0] = dp[j][1] = ndp[j][0] = ndp[j][1] = MAXL;
		}
	}

	ll ans;

	dp[0][1] = 0;

	int k;

	for (i = 0; i < m; i++) {
		for (j = 0; j <= n; j++) {
			if (j < n) {
				dp[j + 1][0] = min(dp[j + 1][0], min(dp[j][0], dp[j][1]));
			}
			if (j < n && y[j + 1] <= x[i + 1]) {
				ndp[j + 1][1] = min(ndp[j + 1][1], min(dp[j][0], dp[j][1]) + (x[i + 1] - y[j + 1]) * v[i + 1] + c[j + 1]);
			}
			if (j && y[j] <= x[i + 1]) {
				ndp[j][1] = min(ndp[j][1], dp[j][1] + (x[i + 1] - y[j]) * v[i + 1]);
				ndp[j][1] = min(ndp[j][1], dp[j][0] + (x[i + 1] - y[j]) * v[i + 1] + c[j]);
			}
		}

		ans = MAXL;

		for (j = 0; j <= n; j++) {
			dp[j][0] = ndp[j][0];
			dp[j][1] = ndp[j][1];
			ndp[j][0] = ndp[j][1] = MAXL;

			ans = min(ans, dp[j][1]);
		}

		cout << ans << " ";
	}

	cout << "\n";

	return 0;
}