#include "sorting.h"
#include <vector>
#include <set>
#include <map>
using namespace std;

vector<int> solve(int n) {
	vector<int> v(n);
	if (n == 1) {
		v[0] = 1;
		return v;
	}
	int i1, i2;
	set<int> s;
	for (int i = 1; i < n - 1; i++) s.insert(i);
	map<int, int> mp;
	for (int i = 1; i < n; i++) {
		bool f = false;
		for (int j = i + 1; j <= n; j++) {
			if (divisible(i, j, n - 1)) {
				i1 = i, i2 = j;
				f = true;
				break;
			}
		}
		if (f) break;
	}
	int ind;
	mp[i1] = 1, mp[i2] = 1;
	if (compare(i1, i2)) {
		ind = i2;
		v[i1 - 1] = 1;
		v[i2 - 1] = n;
	}
	else {
		ind = i1;
		v[i1 - 1] = n;
		v[i2 - 1] = 1;
	}
	for (int i = 0; i < n; i++) {
		if (mp[i + 1]) continue;
		for (int j = 1; j < n; j++) {
			if (divisible(ind, i + 1, j)) {
				v[i] = n - j;
				mp[i + 1] = 1;
				break;
			}
		}
	}
	return v;
}