#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
#define endl '\n'
const int mod = 1e9+7;
const int B = 2e5;
ll power(ll a,ll b){
    if(b == 0) return 1;
    if(b == 1) return a%mod;
    ll r = power(a,b/2)%mod;
    if(b&1){
        return (((r*r)%mod)*a)%mod;
    }
    return (r*r)%mod;
}
void solve(){
    int n,m;
    cin>>n>>m;
    vector<vector<int>> adj(n+1);
    for(int i=0;i<m;i++){
        int a,b;
        cin>>a>>b;
        adj[a].push_back(b);
    }
    vector<vector<bool>> can(n+1,vector<bool>(n+1));
    for(int i=1;i<=n;i++){
        vector<bool> vis(n+1);
        queue<int> q;
        vis[i] = 1;
        q.push(i);
        while(q.size()){
            int cur = q.front();        q.pop();
            for(auto ch : adj[cur]){
                if(vis[ch]) continue;
                vis[ch] = 1;
                q.push(ch);
            }
        }
        for(int j=1;j<=n;j++){
            can[i][j] = vis[j];
        }
    }
    int q;
    cin>>q;
    vector<pair<int,int>> Q(q);
    for(int i=0;i<q;i++){
        cin>>Q[i].first>>Q[i].second;
    }
    if(q == 0){
        for(int i=1;i<=n;i++){
            for(int j=i;j<=n;j++){
                Q.push_back({i,j});
            }
        }
    }
    ll ans = 0;
    ll k = Q.size();
    k --;
    for(auto i : Q){
        ll a = 0;
        if(can[i.first][i.second] && can[i.second][i.first]) a = m+1;
        ans += (a*power(B,k))%mod;
        ans %= mod;
        k --;
    }
    cout<<ans<<endl;
}
void solve2(){
    int n,m;
    cin>>n>>m;
    vector<vector<int>> adj(n+1);
    vector<pair<int,int>> edges;
    for(int i=0;i<m;i++){
        int a,b;
        cin>>a>>b;
        adj[a].push_back(b);
        edges.push_back({a,b});
    }
    vector<vector<int>> v(n+1,vector<int>(n+1,m+1));
    for(int i=1;i<=n;i++){
        vector<bool> vis(n+1);
        queue<int> q;
        q.push(i);
        vis[i] = 1;
        while(q.size()){
            int cur = q.front();        q.pop();
            for(auto ch : adj[cur]){
                if(vis[ch]) continue;
                q.push(ch);
                vis[ch] = 1;
            }
        }
        for(int j=1;j<=n;j++){
            if(!vis[j]) {
                v[i][j] = 0;
            }
        }
    }
    for(int i=1;i<=n;i++){
        for(int edge=0;edge<m;edge++){
            queue<int> q;
            vector<bool> vis(n+1);
            q.push(i);
            vis[i] = 1;
            while(q.size()){
                int cur = q.front();       q.pop();
                int cnt = 0;
                for(auto ch : adj[cur]){
                    if(vis[ch]) continue;
                    if(cur == edges[edge].first && ch == edges[edge].second && cnt == 0) {
                        cnt ++;
                        continue;
                    }
                    q.push(ch);
                    vis[ch] = 1;
                }
            }
            for(int j=1;j<=n;j++){
                if(!vis[j] && v[i][j] == m+1) {
                    v[i][j] = edge+1;
                }
            }
        }
    }
    int q;
    cin>>q;
    ll ans = 0;
    while(q--){
        int a,b;
        cin>>a>>b;
        ll x = min(v[a][b],v[b][a]);
        x *= power(B,q);
        x %= mod;
        ans += x;
        ans %= mod;
    }
    cout<<ans<<endl;
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);     cout.tie(0);
    int t=1;
    //cin>>t;
    while(t--){
        solve2();
    }
    return 0;
}
