#include "bits/stdc++.h"
using namespace std;
typedef long long ll;
const ll mod=1e9+7;
ll power(ll a,ll b){
	if(b==0)return 1;
	if(b==1)return a%mod;
	ll r=power(a%mod,b/2)%mod;
	if(b&1){
		return (((r*r)%mod)*(a%mod));
	}
	else{
		return (r*r)%mod;
	}
}
int main(){
	int n,m;cin>>n>>m;
	vector<int>adj[n+5];
	for(int i=0;i<m;i++){
		int u,v;cin>>u>>v;
		adj[u].push_back(v);
		adj[v].push_back(u);
	}
	vector<vector<bool>>vis(n+1,vector<bool>(n+1));
	for(int i=1;i<=n;i++){
		queue<int>q;
		q.push(i);
		vector<bool>g(n+1);
		while(q.size()){
			int j=q.front();
			q.pop();
			vis[i][j]=1;
			g[j]=1;
			for(auto ch:adj[j]){
				if(!g[ch]){
					q.push(ch);
				}
			}
		}
	}
	int q;cin>>q;
	if(q==0){
		vector<ll>e;
		int u=1,v=1;
		while(1){
			if(u==n && v==n)break;
			if(vis[u][v]){
				e.push_back(m+1);
			}
			else{
				e.push_back(0);
			}
			if(v<n)v++;
			else{
				u++;
				v=u;
			}
		}
		ll p=e.size();
		ll ans=0;
		for(ll i=0;i<e.size();i++){
			p--;
			ans+=(e[i]*power((ll)200000,(ll)p))%mod;
			ans%=mod;
		}
		cout<<ans<<endl;
		return 0;
	}
	vector<ll>e;
	while(q--){
		int u,v;cin>>u>>v;
		if(vis[u][v]){
			e.push_back(m+1);
		}
		else{
			e.push_back(0);
		}
	}
	ll p=e.size();
	ll ans=0;
	for(ll i=0;i<e.size();i++){
		p--;
		ans+=(e[i]*power((ll)200000,(ll)p))%mod;
		ans%=mod;
	}
	cout<<ans<<endl;
}