#include <bits/stdc++.h>

using namespace std;

#define lg long long

const lg N = 2e3+5, MOD = 1e9+7;

vector<multiset<lg>> adj(N);
lg vis[N], tmp;
lg reach[N][N];

void dfs(lg src)
{
	vis[src] = tmp;
	for(auto it : adj[src])
	{
		if(vis[it] == tmp)	continue;
		dfs(it);
	}
	return;
}

lg fast_power(lg n, lg k)
{	
	lg ans = 1;
	while(k)
	{
		if((k&1))	ans = (ans*n)%MOD;
		n = (n*n)%MOD;
		k >>= 1;
	}
	return ans;
}

int main()
{
	ios_base::sync_with_stdio(0);cin.tie(NULL);cout.tie(NULL);
	lg n, m;
	cin >> n >> m;
	vector<pair<lg, lg>> edges;
	for(int i = 0; i < m; i++)
	{
		lg u, v;
		cin >> u >> v;
		edges.push_back({u, v});
		adj[u].insert(v);
	}
	for(int i = 1; i <= n; i++)
	{
		tmp++;
		dfs(i);
		for(int j = 1; j <= n; j++)
		{
			reach[i][j] = (vis[i][j] == tmp);
		}
	}
	lg q;
	cin >> q;
	lg ans = 0, cur = fast_power(2e5, q-1);
	lg inv = fast_power(2e5, MOD-2);
	while(q--)
	{
		lg a, b;
		cin >> a >> b;
		ans = (ans+((reach[a][b] && reach[b][a] ? m+1 : 0)*cur)%MOD)%MOD;
		//cout << curAns << '\n';
		cur = (cur*inv)%MOD;
	}
	cout << ans << '\n';
	return 0;
}