#include <vector>
#include <bits/stdc++.h>
#include "sorting.h"

#define lg long long

using namespace std;

#ifdef CYBER
#include "Lgrader.cpp"
#endif

const lg N = 5e5+5;

bitset<N> primes;
vector<int> prim, mult[N];

void sieve()
{
	primes.set();
	primes[0] = primes[1] = 0;
	for(int i = 2; i < N; i++)
	{
		if(!primes[i])	continue;
		prim.push_back(i);
		for(int j = i; j < N; j += i)
		{
			primes[j] = false;
			mult[i].push_back(j);
		}
	}
	return;
}

vector<int> d_c(int l, int r, int &n)
{
	if(r == l)	return {0};
	int mid = (r-l)/2;
	vector<int> a = d_c(l, mid+l, n);
	vector<int> b = d_c(l+mid+1, r, n);
	vector<int> ans(r-l+1);
	int mxm = 1;
	for(auto it : prim)
	{
		if(it > n)	break;
		for(auto it2 : mult[it])
		{
			if(it2 > n)	break;
			if(divisible(l+1, l+mid+2, it2))	
			{
				mxm = max(mxm, it2);
			}
		}
	}
	if(compare(l+1, l+mid+2))	
	{
		for(int i = 0; i < a.size(); i++)	ans[i] = a[i];
		for(int i = 0; i < b.size(); i++)	ans[i+a.size()] = b[i]+mxm;
	}
	else	
	{
		for(int i = 0; i < a.size(); i++)	ans[i] = a[i];
		for(int i = 0; i < b.size(); i++)	ans[i+a.size()] = b[i]-mxm;
	}
	return ans;
}

std::vector < int > solve(int n)
{
	sieve();
	int l = 0, r = n-1;
	vector<int> ans = d_c(l, r, n);
	int lRange = 1, rRange = n;
	for(int j = 1; j < n; j++)
	{
		lRange = max(lRange , 1-ans[j]);
		rRange  = min(rRange , n-ans[j]);
	}		
	int best = -1;
	for(int i = lRange ; i <= rRange  && best == -1; i++)	best = i;
	for(auto &it : ans)	it += best;
	return ans;
}