#include <iostream>
#include <vector>
#include <algorithm>
#define into(a); for(auto &i : (a)) cin >> i;
#define outo(a); for(auto i : (a)) cout << i;
#define int int_fast64_t

using namespace std;

void solve() {
	int n, m;
	cin >> n;
	vector<pair<int, int>> buses(n);
	for (auto& [a, b] : buses) {
		cin >> a >> b;
	}
	cin >> m;
	vector<pair<int, int>> students(m);
	for (auto& [a, b] : students) {
		cin >> a >> b;
	}
	vector<vector<int>> dp(m, vector<int>(n, 2e9));
	auto [x0, v0] = students[0];
	int res = 2e9;
	for (int i = 0; i < n; ++i) {
		auto [y, c] = buses[i];
		if (y <= x0) {
			dp[0][i] = (x0 - y) * v0 + c;
		}
		res = min(res, dp[0][i]);
	}
	cout << res << ' ';
	for (int i = 1; i < m; ++i) {
		int nextres = 2e9;
		auto [x, v] = students[i];
		for (int j = 0; j < n; ++j) {
			auto [y, c] = buses[j];
			if (y <= x) {
				dp[i][j] = min((x - y) * v + c + res, (x - y) * v + dp[i - 1][j]);
			}
			else {
				break;
			}
			nextres = min(nextres, dp[i][j]);
		}
		res = nextres;
		cout << res << ' ';
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}