#include <vector>
#include "sorting.h"
#include <algorithm>
#include <map>

using namespace std;

map<pair<int, int>, int> anses;

bool cmp(int a, int b) {
	int mn = 0;
	bool res = 0;
	if (a > b) {
		mn = 1;
	}
	if (anses.find({ min(a, b), max(a, b) }) != anses.end()) {
		res = anses[{ min(a, b), max(a, b) }] ^ mn;
	}
	else {
		res = compare(a, b);
		anses[{ min(a, b), max(a, b) }] = res ^ mn;
	}
	return res;
}

void mergesort(int l, int r, vector<int>& a) {
	int mg = (r + l) / 2;
	if (r - l <= 1)
		return;
	mergesort(l, mg, a);
	mergesort(mg, r, a);
	vector<int> res(r - l);
	int _l = l, _r = mg, cur = 0;
	while (_l < mg || _r < r) {
		if (_l == mg) {
			res[cur++] = a[_r++];
			continue;
		}
		if (_r == r) {
			res[cur++] = a[_l++];
			continue;
		}
		if (cmp(a[_l], a[_r])) {
			res[cur++] = a[_l++];
		}
		else {
			res[cur++] = a[_r++];
		}
	}
	for (int i = l; i < r; ++i) {
		a[i] = res[i - l];
	}
}

std::vector < int > solve(int N)
{
	vector<int> ok(N), gg(N);
	for (int i = 0; i < N; ++i) {
		ok[i] = i + 1;
	}
	mergesort(0, N, ok);
	for (int i = 0; i < N; ++i) {
		gg[ok[i] - 1] = i + 1;
	}
	return gg;
}