#include <vector>
#include "sorting.h"
#include <algorithm>
#include <map>

using namespace std;

map<pair<int, int>, int> anses;

bool cmp(int a, int b) {
	if (a > b)
		return !cmp(b, a);
	if (anses.find({ a, b }) != anses.end())
		return anses[{a, b}];
	return anses[{a, b}] = compare(a, b);
}

std::vector < int > solve(int N)
{
	vector<int> ok(N), gg(N);
	for (int i = 0; i < N; ++i) {
		ok[i] = i + 1;
	}
	sort(ok.begin(), ok.end(), cmp);
	for (int i = 0; i < N; ++i) {
		gg[ok[i] - 1] = i + 1;
	}
	return gg;
}