#include "bits/stdc++.h"
#include "sorting.h"
using namespace std;

vector<int> solve(int N) {
    vector<int> res(N);

    int p1, pn;
    bool __p1_pn_found = false;
    for (int i = 1; i <= N; i++) {
        if (__p1_pn_found) {
            break;
        }
        for (int j = i + 1; j <= N; j++) {
            if (divisible(i, j, N - 1)) {
                p1 = i;
                pn = j;
                __p1_pn_found = true;
                break;
            }
        }
    }

    if (!compare(p1, pn)) {
        swap(p1, pn);
    }

    res[p1 - 1] = 1;
    res[pn - 1] = N;

    for (int d = N - 1; d >= 1; d--) {
        for (int i = 1; i <= N; i++) {
            if (res[i - 1] != 0) {
                continue;
            }

            if (divisible(pn, i, d)) {
                res[i - 1] = N - d;
                break;
            }
        }
    }

    return res;
}