
#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>

const int __MAXN = 500000 + 10;
//#include "sorting.h"
#include <bits/stdc++.h>
using namespace std;
#define ll int
bool compare(int x, int y);
bool divisible(int x, int y, int d);
vector <int> solve(int N) {
    ll n = N;
    if (n <= 500) {
        vector <int > p(n), ans(n);
        vector <vector <ll > > g;
        g.resize(n);
        for (ll i = 1; i <= n; i++) {
            for (ll j = i + 1; j <= n; j++) {
                bool srg = 0;
                for (ll d = n - 1; d >= 2; d--) {
                    if (i == j) continue;
                    if (divisible(i, j, d)) {
                        srg = 1;
                        break;
                    }
                }
                if (!srg) {
                    g[i - 1].push_back(j - 1);
                    g[j - 1].push_back(i - 1);
                }
            }
        }

        vector <ll > xx;
        for (ll i = 0; i < n; i++) {
            if (g[i].size() == 1) {
                xx.push_back(i);
            }
        }
        ll c = compare(xx[0] + 1, xx[1] + 1);
        vector <ll > used(n);
        if (c) {
            ans[xx[0]] = 1;
            ll now = 2;
            for (ll i = xx[0]; i != xx[1];) {
                used[i] = 1;
                for (auto e : g[i]) {
                    if (!used[e]) {
                        i = e;
                        ans[i] = now++;
                    }
                }
            }
            ans[xx[1]] = n;
        } else {
            ans[xx[1]] = 1;
            ll now = 2;
            for (ll i = xx[1]; i != xx[0];) {
                for (auto e : g[i]) {
                    if (e != i) {
                        i = e;
                        ans[i] = now++;
                    }
                }
            }
            ans[xx[0]] = n;
        }
        return ans;
    }
    vector <int > p(n), ans(n);
    for (ll i = 0; i < n - 1; i++) {
        ll dd = 0;
        for (ll d = n - 1; d >= 1; d--) {
            if (divisible(i + 1, i + 2, d)) {
                dd = d;
                break;
            }
        }
        if (compare(i + 1, i + 2)) {
            p[i + 1] = dd;
        } else {
            p[i + 1] = -dd;
        }
    }
    for (ll one = 1; one <= n; one++) {
        ans[0] = one;
        bool srg = 0;
        for (ll i = 1; i < n; i++) {
            ans[i] = ans[i - 1] + p[i];
            if (ans[i] <= 0 || ans[i] > n) {
                srg = 1;
                break;
            }
        }
        if (srg) continue;
        break;
    }
    return ans;
}

int __compareCnt;
int __n, __p[__MAXN];
bool compare(int x, int y)
{
    __compareCnt++;
    if (!(1 <= x && x <= __n && 1 <= y && y <= __n))
    {
        std::cerr << "Invalid compare query!\n";
        exit(0);
    }

    return __p[x] < __p[y];
}

bool divisible(int x, int y, int d)
{
    if (!(1 <= x && x <= __n && 1 <= y && y <= __n && 1 <= d && d <= __n))
    {
        std::cerr << "Invalid divisible query!\n";
        exit(0);
    }

    return abs(__p[x] - __p[y]) % d == 0;
}

void read()
{
    std::cin >> __n;
    for (int i = 1 ; i <= __n ; ++i)
    {
        std::cin >> __p[i];
    }
}

double score()
{
    int logn = 0;
    while ((1 << logn) < __n) ++logn;
    if (__compareCnt <= __n/2) return 1.;
    if (__compareCnt <= 2*__n/2) return 0.7;
    if (__compareCnt <= 2*__n) return 0.5;
    if (__compareCnt <= __n * logn) return 0.15;
    if (__compareCnt <= __n * (1+logn)) return 0.1;
    return 0.05;
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

int main ()
{
    // fastIO();
    read();

    std::vector < int > res = solve(__n);
    if (res.size() != __n)
    {
        std::cout << "Invalid result! WA!\n";
        exit(0);
    }

    for (int i = 1 ; i <= __n ; ++i)
    {
        if (res[i-1] != __p[i])
        {
            std::cout << "Incorrect element! WA!\n";
            exit(0);
        }
    }

    std::cout << "Correct!: " << score() << "%\n";
    return 0;
}
