﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <random>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define forr(i, n) for (ll i = 0;i<n;i++)
const ll INF = 4e18;
struct A {
    ll x, c;
    bool operator<(const A& other) const {
        return x < other.x;
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll m;
    cin >> m;
    vector<A> a(m + 1);
    for (ll i = 0; i < m; i++) {
        cin >> a[i].x >> a[i].c;
    }
    ll n;
    cin >> n;
    vector<ll> x(n), v(n), pvx(n + 1 ,0), pv(n + 1, 0);
    for (ll i = 0; i < n; i++) {
        cin >> x[i] >> v[i];
        pvx[i + 1] = pvx[i] + x[i] * v[i];
        pv[i + 1] = pv[i] + v[i];
    }
    vector<ll> dp(n + 1, INF);
    vector<ll> kk(a.size());
    for (ll i = 0; i < a.size(); i++) {
        kk[i] = lower_bound(all(x), a[i].x) - x.begin();
    }
    dp[0] = 0;
    ll mn = INF;
    ll j = 0;
    for (ll i = 1; i <= n; i++) {
        while (j < a.size() && a[j].x <= x[i - 1]) {
            mn = min(mn, a[j].c - a[j].x * v[i - 1]);
            j++;
        }
        dp[i] = (__int128)dp[i - 1] + mn + x[i - 1] * v[i - 1];
        if (dp[i] > (long long)2e18) {
            exit(-1);
        }
        cout << dp[i] << " ";
    }
    return 0;
}
