#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

random_device rd;
mt19937 rnd(time(0));

const ll INF = 2000000000000000000;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

void solve() {
	ll n;
	cin >> n;
	vector<pair<ll, ll>> bus(n);
	for (ll i = 0; i < n; i++) {
		cin >> bus[i].first >> bus[i].second;
	}
	sort(bus.begin(), bus.end());
	ll m;
	cin >> m;
	vector<pair<ll, ll>> st(m);
	for (ll i = 0; i < m; i++) {
		cin >> st[i].first >> st[i].second;
	}
	ll u1 = 0;
	vector<ll> ans(m, INF);
	for (ll i = 0; i < m; i++) {
		while (u1 < n - 1 && bus[u1 + 1].first <= st[i].first && (abs(bus[u1].first - st[i].first) * st[i].second + bus[u1].second) > (abs(bus[u1 + 1].first - st[i].first) * st[i].second + bus[u1 + 1].second)) {
			u1++;
		}
		assign_min(ans[i], (abs(bus[u1].first - st[i].first) * st[i].second + bus[u1].second));
	}
	u1 = n - 1;
	for (ll i = m - 1; i >= 0; i--) {
		while (u1 >= 1 && ((abs(bus[u1].first - st[i].first) * st[i].second + bus[u1].second) > (abs(bus[u1 - 1].first - st[i].first) * st[i].second + bus[u1 - 1].second) || bus[u1].first > st[i].first)) {
			u1--;
		}
		assign_min(ans[i], (abs(bus[u1].first - st[i].first) * st[i].second + bus[u1].second));
	}
	ll sum = 0;
	for (ll i = 0; i < m; i++) {
		sum += ans[i];
		cout << sum << ' ';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
