#include<bits/stdc++.h>
#include "sorting.h"

using namespace std;

typedef int ll;

random_device rd;
mt19937 rnd(rd());

const ll INF = 2000000000;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

vector<ll> solve(ll n) {
	ll me = 0;
	for (ll i = 1; i < n; i++) {
		if (compare(i + 1, me + 1)) {
			me = i;
		}
	}
	vector<ll> ans(n);
	ans[me] = 1;
	for (ll i = 0; i < n; i++) {
		if (i == me) {
			continue;
		}
		ll now = 1;
		for (ll j = 1; j < n; j += now) {
			if (divisible(i + 1, me + 1, j)) {
				now = j;
			}
		}
		ans[i] = now + 1;
	}
	return ans;
}
