#include "bits/stdc++.h"
using namespace std;


using ll = long long;
#define all(x) x.begin(), x.end()

#define int ll

const int INF = 1e18;

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    int n;
    cin >> n;
    vector<int> y(n), c(n);
    for (int i = 0; i < n; ++i) {
        cin >> y[i] >> c[i];
    }
    int m;
    cin >> m;
    vector<int> x(m), v(m);
    for (int i = 0; i < m; ++i) {
        cin >> x[i] >> v[i];
    }
    swap(n, m);
    swap(y, x);
    swap(v, c);

    vector<ll> dp(m, INF);
    for (int i = 0; i < m; ++i) {
        if (x[i] <= y[0])
        dp[i] = abs(y[0] - x[i]) * c[0] + v[i];
    }
    cout << *min_element(all(dp)) << '\n';
//    for (auto i : dp) cout << i << ' ';
//    cout << '\n';
    for (int i = 1; i < n; ++i) {
        int mn = INF;
        vector<ll> nw(m, INF);
        for (int j = 0; j < m; ++j) {
            if (x[j] <= y[i])
                nw[j] = min(mn + abs(y[i] - x[j]) * c[i] + v[j], dp[j] + abs(y[i] - x[j]) * c[i]);
            mn = min(mn, dp[j]);
        }
        swap(nw, dp);
        cout << *min_element(all(dp)) << '\n';
//        for (auto j : dp) cout << j << ' ';
//        cout << '\n';
    }
}