#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int main() {
#ifdef DEBUG_Q
    freopen("INPUT.TXT", "r", stdin);
    freopen("OUTPUT.TXT", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n;
    cin >> n;
    vector<ll> y(n), c(n);
    for (ll i = 0; i < n; i++) {
        cin >> y[i] >> c[i];
    }

    ll m;
    cin >> m;
    vector<ll> x(m);
    ll v;
    for (ll i = 0; i < m; i++) {
        cin >> x[i] >> v;
    }

    vector<ll> p(n);
    for (ll i = 0; i < n; i++) {
        p[i] = c[i] - y[i] * v;
    }
    for (ll i = 1; i < n; i++) {
        p[i] = min(p[i], p[i - 1]);
    }

    vector<ll> ans(m);
    for (ll i = 0; i < m; i++) {
        ll i2 = upper_bound(y.begin(), y.end(), x[i]) - y.begin() - 1;
        ans[i] += p[i2] + x[i] * v;
    }
    ll sum = 0;
    for (ll i = 0; i < m; i++) {
        sum += ans[i];
        cout << sum << ' ';
    }
}