#include <bits/stdc++.h>
#include "sorting.h"


using namespace std;

vector<int> solve(int l, int r) {
    if (l == r - 1) {
        return {l};
    }
    int m = (l + r) / 2;
    vector<int> x = solve(l, m);
    vector<int> y = solve(m, r);
    vector<int> ans;
    int i = 0, j = 0;
    while (i < x.size() && j < y.size()) {
        if (compare(x[i] + 1, y[j] + 1)) {
            ans.push_back(x[i]);
            i++;
        } else {
            ans.push_back(y[j]);
            j++;
        }
    }
    while (i < x.size()) {
        ans.push_back(x[i]);
        i++;
    }
    while (j < y.size()) {
        ans.push_back(y[j]);
        j++;
    }
    return ans;
}

vector<int> solve(int n) {
    vector<int> x = solve(0, n);
    vector<int> ans(n);
    for (int i = 0; i < n; i++) {
        ans[x[i]] = i + 1;
    }
    return ans;
}