#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define int ll

vector<vector<int>> g;
pair<int, int> d1;
vector<bool> used;
map<pair<int, int>, int> cnt;

void dfs(int v){
    used[v] = true;
    for(auto u : g[v]){
        if(used[u] || (make_pair(v, u) == d1 && cnt[{v, u}] == 1))
            continue;
        dfs(u);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int n, m, q;
    cin >> n >> m;
    g.resize(n + 1);
    used.resize(n + 1);
    vector<pair<int, int>> edge;
    for(int i = 0; i < m; i++){
        int u, v;
        cin >> u >> v;
        cnt[{u, v}]++;
        g[u].emplace_back(v);
        edge.emplace_back(u, v);
    }
    cin >> q;
    vector<int> res;
    while(q--){
        int u, v;
        cin >> u >> v;
        fill(all(used), false);
        d1 = {-1, -1};
        dfs(u);
        if(!used[v]) {
            res.emplace_back(0);
            continue;
        }
        fill(all(used), false);
        d1 = {-1, -1};
        dfs(v);
        if(!used[u]){
            res.emplace_back(0);
            continue;
        }
        int ans = -1;
        for(int i = 0; i < m; i++){
            d1 = make_pair(edge[i].first, edge[i].second);
            fill(all(used), false);
            dfs(u);
            if(!used[v]){
                ans = i;
                break;
            }

            fill(all(used), false);
            dfs(v);
            if(!used[u]){
                ans = i;
                break;
            }
        }
        if(ans == -1)
            res.emplace_back(m + 1);
        else
            res.emplace_back(ans + 1);
    }
    reverse(all(res));
    const int mod = int(1e9) + 7, b = int(2e5);
    int p = 1, answer = 0;
    for(int i = 0; i < int(res.size()); i++){
        answer += (res[i] * p) % mod;
        answer %= mod;
        p = p * b;
        p %= mod;
    }
    cout << answer;
    return 0;
}