#include <bits/stdc++.h>
#include "sorting.h"
using namespace std;
using ll = long long;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()



int Find(int x, int y, int N) {
    vector<bool> check(N + 1, false);
    int last = 1;
    for (int d = 2; d <= N - 1; d++) {
        if (check[d])
            continue;
        if (divisible(x, y, d)) {
            last = d;
            break;
        }
        int j = 2 * d;
        while (j <= N - 1) {
            check[j] = true;
            j += d;
        }
    }
    for(int j = last; j <= N - 1; j += last){
        if (divisible(x, y, j)) {
            last = j;
        }
    }
    return last;
}

vector<int> solve(int N) {
    vector<bool> comp(N / 2 + 1);
    for (int i = 1; i <= N - (N % 2); i += 2) {
        comp[(i + 1) / 2] = compare(i, i + 1);
    }
    vector<int> ans(N + 1, -1);
    ans[1] = 1;
    for (int i = 1; i <= N - (N % 2); i += 2) {
        if (ans[i + 1] == -1) {
            int d = Find(i, i + 1, N);
            if (comp[(i + 1) / 2])
                ans[i + 1] = ans[i] + d;
            else
                ans[i + 1] = ans[i] - d;
        }
        if (i + 2 > N)
            continue;
        int d1 = Find(i, i + 2, N), d2 = Find(i + 1, i + 2, N);
        if (ans[i] + d1 == ans[i + 1] + d2)
            ans[i + 2] = ans[i + 1] + d2;
        else if(ans[i] + d1 == ans[i + 1] - d2)
            ans[i + 2] = ans[i] + d1;
        else if(ans[i] - d1 == ans[i + 1] + d2)
            ans[i + 2] = ans[i + 1] + d2;
        else if(ans[i] - d1 == ans[i + 1] - d2)
            ans[i + 2] = ans[i] - d1;
    }
    int mn = int(1e9);
    for(int i = 1; i <= N; i++)
        mn = min(mn, ans[i]);
    mn = abs(mn) + 1;
    for(int i = 1; i <= N; i++)
        ans[i] += mn;
    vector<int> res(N);
    for(int i = 0; i < N; i++)
        res[i] = ans[i + 1];
    return res;
}