#include<bits/stdc++.h>

#define int long long
#define x first
#define y second
#define endl "\n"

using namespace std;

void fast()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
}

const int mod = 1e9 + 7, N = 2000, cst = 2e5;
int B[N * (N + 1) / 2];
vector<bool> used;
vector<int> g[N];

void calcB()
{
    B[0] = 1;
    for(int i = 1; i <= N * (N + 1) / 2; i++)
        B[i] = (B[i - 1] * cst) % mod;
}

void dfs(int v)
{
    used[v] = true;
    for(int i : g[v])
        if(!used[i])
            dfs(i);
}

int32_t main()
{
    fast();
    calcB();
    int n, m;
    cin >> n >> m;
    for(int i = 0, u, v; i < m; i++)
    {
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
    }
    int ans[n][n];
    for(int i = 0; i < n; i++)
    {
        used.assign(n, false);
        dfs(i);
        for(int j = 0; j < n; j++)
            if(used[j])
                ans[i][j] = m + 1;
            else ans[i][j] = 0;
    }
    int q, res = 0;
    cin >> q;
    if(q)
    {
        while(q--)
        {
            int a, b;
            cin >> a >> b;
            a--; b--;
            res += (ans[a][b] * B[q]) % mod;
            res %= mod;
        }
    }
    else
    {
        q = n * (n + 1) / 2;
        for(int i = 0; i < n; i++)
            for(int j = i; j < n; j++)
            {
                q--;
                res += (ans[i][j] * B[q]) % mod;
                res %= mod;
            }
    }
    cout << res;
    return 0;
}
