#include<bits/stdc++.h>

#define int long long
#define x first
#define y second
#define endl "\n"

using namespace std;

void fast()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
}

const int mod = 1e9 + 7, N = 2000, cst = 2e5;
int B[N * (N + 1) / 2];
void calcB()
{
    B[0] = 1;
    for(int i = 1; i < N * (N + 1) / 2; i++)
        B[i] = (B[i - 1] * cst) % mod;
}

vector<pair<int, int>> g[N];
vector<bool> used;

void dfs(int v)
{
    used[v] = true;
    for(auto i : g[v])
        if(!used[i.x])
            dfs(i.x);
}

void tdfs(int v, int bad)
{
    used[v] = true;
    for(auto i : g[v])
        if(!used[i.x] && i.y != bad)
            tdfs(i.x, bad);
}

int32_t main()
{
    fast();
    calcB();
    int n, m;
    cin >> n >> m;
    for(int i = 1, u, v; i <= m; i++)
    {
        cin >> u >> v;
        u--; v--;
        g[u].push_back({v, i});
    }
    int ans[n][n];
    for(int i = 0; i < n; i++)
    {
        used.assign(n, false);
        dfs(i);
        for(int j = 0; j < n; j++)
            ans[i][j] = used[j];
    }
    for(int i = 0; i < n; i++)
    for(int j = 0; j < n; j++)
        ans[i][j] = min(ans[i][j], ans[j][i]), ans[j][i] = ans[i][j];
    int q, res = 0;
    cin >> q;
    if(n <= 200 && m <= 1000 && q != 0)
    {
        while(q--)
        {
            int a, b;
            cin >> a >> b;
            a--; b--;
            if(ans[a][b])
            {
                int cnt = 0, mn = m + 1;
                for(int i = m; i >= 1; i--)
                {
                    int tt = 0;
                    used.assign(n, false);
                    tdfs(a, i);
                    if(used[b])
                        tt++;
                    used.assign(n, false);
                    tdfs(b, i);
                    if(used[a])
                        tt++;
                    if(tt < 2)
                        mn = i, cnt++;
                }
                if(cnt != m)
                {
                    res += (mn * B[q]) % mod;
                    res %= mod;
                }
                else
                {
                    res += ((m + 1) * B[q]) % mod;
                    res %= mod;
                }
            }
        }
        cout << res;
        return 0;
    }
    if(n <= 500 && m <= 8000)
    {
        for(int i = 0; i < n; i++)
        {
            for(int j = i; j < n; j++)
            {
                int a = i, b = j;
                if(ans[a][b])
                {
                    int cnt = 0, mn = m + 1;
                    for(int x = m; x >= 1; x--)
                    {
                        int tt = 0;
                        used.assign(n, false);
                        tdfs(a, x);
                        if(used[b])
                            tt++;
                        used.assign(n, false);
                        tdfs(b, x);
                        if(used[a])
                            tt++;
                        if(tt < 2)
                            mn = x, cnt++;
                    }
                    if(cnt != m)
                        ans[i][j] = mn, ans[j][i] = mn;
                    else ans[i][j] = m + 1, ans[j][i] = m + 1;
                }
            }
        }
        if(q)
        {
            while(q--)
            {
                int a, b;
                cin >> a >> b;
                a--; b--;
                res += (ans[a][b] * B[q]) % mod;
                res %= mod;
            }
        }
        else
        {
            int q = n * (n + 1) / 2;
            for(int i = 0; i < n; i++)
            for(int j = i; j < n; j++)
            {
                q--;
                res += (ans[i][j] * B[q]) % mod;
                res %= mod;
            }
        }
        cout << res;
        return 0;
    }
    if(q)
    {
        while(q--)
        {
            int a, b;
            cin >> a >> b;
            a--; b--;
            res += (ans[a][b] * (m + 1) * B[q]) % mod;
            res %= mod;
        }
    }
    else
    {
        int q = n * (n + 1) / 2;
        for(int i = 0; i < n; i++)
        for(int j = i; j < n; j++)
        {
            q--;
            res += (ans[i][j] * (m + 1) * B[q]) % mod;
            res %= mod;
        }
    }
    cout << res;
    return 0;
}
