#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define vec vector
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) (x).begin(), (x).end()
#define f first
#define s second

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int mod = 1e9 + 7;
const int B = 2e5;
const int N = 2010;
const int K = 5e6;
int n, m, q, ans[N][N], k, p[K], exists[N][N], used[N];
vec<pii> g[N];

void dfs1(int v, int del)
{
    used[v] = true;
    for (auto &to : g[v])
    {
        if (!used[to.f] && to.s != del) dfs1(to.f, del);
    }
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m;
    for (int i = 0; i < m; i++)
    {
        int u, v;
        cin >> u >> v;
        g[u].pb({v, i + 1});
        exists[u][v] = 1;
    }
    p[0] = 1;
    for (int i = 1; i < K; i++) p[i] = p[i - 1] * B % mod;
    for (int a = 1; a <= n; a++)
    {
        for (int b = 1; b <= n; b++)
            ans[a][b] = m + 1;
    }
    for (int v = 1; v <= n; v++)
    {
        fill(used, used + n + 1, 0);
        dfs1(v, 0);
        for (int u = 1; u <= n; u++)
        {
            if (!used[u]) ans[v][u] = 0;
        }
    }
//    if (n <= 200 && m <= 1000)
//    {
        for (int del = 1; del <= m; del++)
        {
            for (int v = 1; v <= n; v++)
            {
                fill(used, used + n + 1, 0);
                dfs1(v, del);
                for (int u = 1; u <= n; u++)
                {
                    if (!used[u]) ans[v][u] = min(ans[v][u], del);
                }
            }
        }
//    }
    int res = 0;
    cin >> q;
    if (q == 0)
    {
        k = (n * (n + 1)) / 2;
        int c = 1;
        for (int a = 1; a <= n; a++)
        {
            for (int b = a; b <= n; b++)
            {
                int cur = min(ans[a][b], ans[b][a]);
                (res += cur * p[k - c]) %= mod;
                c++;
            }
        }
    }
    else
    {
        k = q;
        for (int t = 1; t <= q; t++)
        {
            int a, b;
            cin >> a >> b;
            int cur = min(ans[a][b], ans[b][a]);
            (res += cur * p[k - t]) %= mod;
        }
    }
    cout << res;
    return 0;
}
