#pragma GCC optimize("O3,unroll-loops")
#include "sorting.h"
#include <algorithm>
#include <vector>

using namespace std;

bool compare(int x, int y);

bool divisible(int x, int y, int d);

int lcm(int a, int b)
{
    return a / __gcd(a, b) * b;
}

vector<int> solve(int n)
{
    int p = 0;
    for (int i = 1; i < n; i++)
    {
        if (compare(i + 1, p + 1)) p = i;
    }
    vector<int> res(n);
    res[p] = 1;
    for (int i = 0; i < n; i++)
    {
        if (i == p) continue;
        int mx = 1, l = 1;
        for (int j = 2; j <= n; j += l)
        {
            if (divisible(i + 1, p + 1, j)) mx = j, l = lcm(l, j);
        }
        res[i] = mx + 1;
    }
    return res;
}
