#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

#define F first
#define S second
#define pii pair<int, int>
#define ins insert
#define pb push_back
#define bpp __builtin_popcount
#define ll long long
#define int long long

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> oset;

mt19937 gen(time(0));

const int N = 2e3+10;
const int B = 2e5;
const int mod = 1e9+7;


vector<pii> g[N], g1[N];
int u[N];
vector<int> vec;
int comp[N];
int cnt = 0;
int calc[N*N];
int comp1[N];

int n,m;

int hv[N][N];


map<pii, int> mp;
set<int> cycle[N];
set<int> bad;
int nm = -1;
void dfs(int v)
{
    u[v] = 1;
    for(auto to : g[v])
        if(!u[to.F] && to.S!=nm)
        dfs(to.F);

    vec.pb(v);
}

vector<int> ver;

void dfs1(int v)
{
//    ver.pb(v);

    u[v] = 1;
//    en = v;
    comp[v] = cnt;
    for(auto to : g1[v])
        if(!u[to.F] && to.S!=nm)
        {
            dfs1(to.F);
        }
}

void dfs2(int v)
{
    u[v] = 1;
    comp1[v] = cnt;

    for(auto to : g1[v])
        if(!u[to.F] && !bad.count(to.S))
        dfs2(to.F);
}

vector<pii> all;
int q;

void make_query()
{

    cin>>q;


//    cout<<"Q "<<q<<endl;
    if(q==0)
    {
        q = (n*(n+1))/2;
        for(int i = 0; i<n; i++)
            for(int j = i; j<n; j++)
        all.pb({i,j});
    }
    else
    {
        for(int i = 0; i<q; i++)
        {
            int u,v;
            cin>>u>>v;
            u--;
            v--;
            all.pb({u,v});

        }
    }

    calc[0] = 1;
    for(int i = 1; i<q; i++)
        calc[i] = (calc[i-1]*B)%mod;
}
int res[N*1000];

void solve5()
{
    fill(res,res+q,m+1);

     for(int i = 0; i<n; i++)
        if(!u[i])
        dfs(i);

    reverse(vec.begin(),vec.end());
    fill(u,u+n,0);


    for(auto to : vec)
        if(!u[to])
    {
        cnt++;
        dfs1(to);
    }

    for(int i = 0; i<q; i++)
        if(comp[all[i].F]!=comp[all[i].S])
        res[i] = -1;

     vector<int> ver;
     for(int i = 0; i<n; i++)
        ver.pb(i);
     for(int i = n-2; i>=0; i--)
        ver.pb(i);

     for(int i = 0; i<ver.size()-1; i++)
     {

         nm = mp[{ver[i],ver[i+1]}];

         fill(u,u+n,0);
         cnt = 0;
         vec.clear();
          for(int j = 0; j<n; j++)
        if(!u[j])
        dfs(j);

    reverse(vec.begin(),vec.end());
    fill(u,u+n,0);

    for(auto to : vec)
        if(!u[to])
    {
        cnt++;
        dfs1(to);
    }


     for(int j = 0; j<q; j++)
        if(res[j]!=-1)
     {
//         cout<<comp[all[i].F]<<' '<<comp[all[i].S]<<endl;

         if(comp[all[j].F]!=comp[all[j].S])
            res[j] = min(res[j],nm);
     }


     }


     int ans = 0;
     int k = q;
     for(int i = 0; i<q; i++)
     {
//         cout<<res[i]<<' ';
         k--;
         if(res[i]==-1)
            continue;
         ans+=(calc[k]*res[i])%mod;
         ans%=mod;
     }

     cout<<ans;

}
int32_t main()
{
    #ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
    #else

    #endif // LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    cin>>n>>m;

    for(int i = 0; i<m; i++)
    {
        int u,v;
        cin>>u>>v;
        u--;
        v--;
        hv[u][v] = 1;

        if(!mp.count({u,v}))
            mp[{u,v}] = i+1;

        g[u].pb({v,i+1});
        g1[v].pb({u,i+1});

    }
    bool ok = 1;
    for(int i = 0; i<n-1; i++)
        if(!hv[i][i+1] || !hv[i+1][i])
        ok = 0;

//        cout<<"!!! "<<ok<<endl;
    if(ok)
    {
       make_query();
       solve5();
       return 0;
    }

    for(int i = 0; i<n; i++)
        if(!u[i])
        dfs(i);

    reverse(vec.begin(),vec.end());
    fill(u,u+n,0);

    for(auto to : vec)
        if(!u[to])
    {
        cnt++;
        dfs1(to);
    }

    make_query();

    int ans = 0;
    int k = q-1;
    for(auto to : all)
    {
//        if(comp[to.F]==comp[to.S])
//            cout<<m+1<<' ';
//        else
//           cout<<0<<' ';

        if(comp[to.F]==comp[to.S])
        ans+=(m+1)*calc[k],
        ans%=mod;

        k--;
    }

//    cout<<endl;

    cout<<ans;

    return 0;
}
