#include <bits/stdc++.h>

#define fi first
#define se second

#define pb push_back
#define sz(x) int((x).size())

using namespace std;

const int N = 2002;
const int M = 2001000;
const int B = 2e5;
const int MOD = 1e9 + 7;

int bpow(int a, int b){
    int res = 1;

    while(b){
        if(b & 1)res = (1LL * res * a) % MOD;
        a = (1LL * a * a) % MOD;
        b >>= 1;
    }

    return res;
}

bool used[N], d[N][N];
int n, m, a[M], b[M], q;
vector<pair<int, int>> g[N];
int qA[M], qB[M];
int s[M];

void solve1(){
    for(int i = 1; i <= n; i++){
        queue<int> q;

        q.push(i);

        d[i][i] = 1;

        while(sz(q)){
            int v = q.front();

            for(auto to : g[v]){
                if(d[i][to.fi] == 0){
                    q.push(to.fi);
                    d[i][to.fi] = 1;
                }
            }

            q.pop();
        }
    }

    for(int i = 1; i <= q; i++){
        if(!d[qA[i]][qB[i]] or !d[qB[i]][qA[i]]){
            s[i] = 0;
            continue;
        }

        int mn = m + 1;

        for(int j = 1; j <= m; j++){
            queue<int> q;

            q.push(qA[i]);

            int flag = 0;

            for(int p = 1; p <= n; p++){
                used[p] = 0;
            }

            while(sz(q)){
                int v = q.front();

                if(v == qB[i]){
                    flag++;
                    break;
                }

                for(auto to : g[v]){
                    if(to.se == j)continue;
                    if(!used[to.fi] and to.se != j){
                        used[to.fi] = 1;
                        q.push(to.fi);
                    }
                }

                q.pop();
            }

            while(sz(q))q.pop();

            q.push(qB[i]);

            for(int p = 1; p <= n; p++){
                used[p] = 0;
            }

            while(sz(q)){
                int v = q.front();

                if(v == qA[i]){
                    flag++;
                    break;
                }

                for(auto to : g[v]){
                    if(to.se == j)continue;
                    if(!used[to.fi] and to.se != j){
                        used[to.fi] = 1;
                        q.push(to.fi);
                    }
                }

                q.pop();
            }

            while(sz(q))q.pop();

            if(flag != 2){
                mn = j;
                break;
            }
        }

        s[i] = mn;
    }

    int K = q, P = 0;

//    for(int i = 1; i <= q; i++){
//        cout << s[i] << " ";
//    }

    for(int i = 1; i <= q; i++){
        P = (P + ((1LL * s[i] * bpow(B, K - i)) % MOD)) % MOD;
    }

    cout << P << "\n";
}

void solve2(){
    for(int i = 1; i <= n; i++){
        queue<int> q;

        q.push(i);

        d[i][i] = 1;

        while(sz(q)){
            int v = q.front();

            for(auto to : g[v]){
                if(d[i][to.fi] == 0){
                    q.push(to.fi);
                    d[i][to.fi] = 1;
                }
            }

            q.pop();
        }
    }
    

    for(int i = 1; i <= q; i++){
        if(!d[qA[i]][qB[i]] or !d[qB[i]][qA[i]]){
            s[i] = 0;
        } else {
            s[i] = m + 1;
        }
    }

    int K = q, P = 0;

    exit(0);
    for(int i = 1; i <= q; i++){
        P = (P + ((1LL * s[i] * bpow(B, K - i)) % MOD)) % MOD;
    }

    cout << P << "\n";
}

int main()
{
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    cin >> n >> m;

    for(int i = 1; i <= m; i++){
        cin >> a[i] >> b[i];
        g[a[i]].pb({b[i], i});
    }

    cin >> q;

    for(int i = 1; i <= q; i++){
        cin >> qA[i] >> qB[i];
    }

    if(q == 0){
        for(int i = 1; i <= n; i++){
            for(int j = i; j <= n; j++){
                q++;
                qA[q] = i, qB[q] = j;
            }
        }
    }

    if(n <= 200 and m <= 1000 and q <= 500 and q != 0)solve1();
    else solve2();

    return 0;
}
