#include <bits/stdc++.h>
#include "sorting.h"

#define pb push_back
#define sz(x) int((x).size())
#define all(x) (x).begin(), (x).end()

using namespace std;

const int N = 5e5 + 5;

bool comp(int a, int b){
    return compare(b, a);
}

vector<int> solve(int n){
    if(n > 10000){
        vector<int> v;

        for(int i = 1; i <= n; i++){
            v.pb(i);
        }

        sort(all(v), comp);

        int num = n;

        vector<int> ans(n);

        for(int i = 0; i < sz(v); i++){
            ans[v[i] - 1] = num;
            num--;
        }
        return ans;
    }

    vector<int> v;

    v.pb(1);

    int S = 1;

    for(int i = 2; i <= n; i++){
        int l = 0, r = S;

        while(l < r){
            int mid = (l + r) >> 1;
            if(compare(i, v[mid]))r = mid;
            else l = mid + 1;
        }

        v.insert(v.begin() + l, i);
        S++;
    }

    vector<int> ans;
    ans.resize(n);

    for(int i = 0; i < sz(v); i++){
        ans[v[i] - 1] = i + 1;
    }

    return ans;
}
