#include <vector>
#include <cmath>
#include "sorting.h"




using namespace std;
using ll = long long;



vector<bool> first_num_ans;


void all_rishoni_num(vector<ll>& rishni_nums, ll until_n) 
{
	vector<bool> is_divisable(until_n + 1, false);
	for (int i = 2; i <= ((until_n/2) + 1); i++)
	{
		if (is_divisable[i] == true) 
		{
			continue;
		}
		rishni_nums.push_back(i);
		for (int j = i * i; j < is_divisable.size(); j += i)
		{
			is_divisable[j] = true;
		}
	}
}

ll find_first_num(ll n)
{
	first_num_ans.push_back(true);
	int first = 1;
	int last = n;
	bool temp;

	for (int i = 2; i <= n; i++)
	{
		temp = compare(1, i);
		first_num_ans.push_back(temp);
		if (temp)
		{
			last--;
		}
		else 
		{
			first++;
		}
	}
	return first;
}



ll find_num_with_first_num(ll first_num, ll index_of_num_to_find,vector<ll>& rishni_nums, ll n)
{
	int num = 1;
	int j = 1;

	for (int i = 0; i < rishni_nums.size(); i++)
	{
		j = rishni_nums[i];
		while (divisible(1, index_of_num_to_find, j))
		{
			num *= rishni_nums[i];
			j *= rishni_nums[i];
			if (j > n) 
			{
				break;
			}
		}

	}

	if (first_num_ans[index_of_num_to_find - 1])
	{
		
		return (num + first_num);
	}
	return (first_num - num);
}

void find_all_nums_with_first_num(ll first_num, vector<ll>& rishni_nums, vector<int>& ans)
{
	ans[0] = first_num;

	for (int i = 1; i < ans.size(); i++)
	{
		ans[i] = find_num_with_first_num(first_num, i + 1, rishni_nums, ans.size());
	}
}

std::vector < int > solve(int N)
{
	ll first_num = find_first_num(N);
	vector<int> ans(N);
	vector<ll> rishni_nums;

	all_rishoni_num(rishni_nums, N);
	find_all_nums_with_first_num(first_num, rishni_nums, ans);
	return ans;

}