#include <iostream>
#include <vector>
using namespace std;
//use dp to know cheapest way with t kilometers
//add the students

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0); cerr.tie(0);
	int N, M;
	cin >> N;//the number of places that have buses for rent.
	vector<int> bus_dist(N, 0);
	vector<int> bus_cost(N, 0);
	for (int i = 0; i < N; i++)
	{
		int y;
		int c;
		cin >> y; //the distance from Shumen to the corresponding place in which a bus can be rent;
		cin >> c; //the cost for renting a bus in that place.
		bus_cost[i] = c;
		bus_dist[i] = y;
	}
	cin >> M;
	vector<int> students(M, 0);
	int v; //the amount of money that student needs for walking one kilometer. //for me is a const
	for (int i = 0; i < M; i++)
	{
		int x; //the distance from Shumen to the place where the corresponding student was sent on ethnographic expedition
		cin >> x;
		cin >> v;

		students[i] = x;
	}
	int cost = bus_cost[0] + (students[0] - bus_dist[0]) * v;
	int dist = students[0];
	int j = 0;
	int sum = 0;
	for (int i = 0; i < M; i++)
	{
		cost = cost + (students[i] - dist) * v;
		for (j; j < N && bus_dist[j] <= students[i]; j++)
		{
			if ((students[i] - bus_dist[j]) * v + bus_cost[j] < cost) {
				dist = students[i]; //check
				cost = (students[i] - bus_dist[j]) * v + bus_cost[j];
			}
		}
		sum += cost;
		cout << sum << endl;
	}
}