#include "sorting.h"
#include <vector>

using namespace std;

vector <int> solve2(vector<int> u, int n)
{
	int m = u.size();
	if (m == 1)
	{
		return u;
	}

	vector<vector<vector<int>>> v(1, vector<vector<int>>(1));
	for (int x : u)
	{
		v[0][0].push_back(x);
	}


	int i = 0;
	for (int k = 1; 2 * k < m; k *= 2)
	{
		v.push_back(vector<vector<int>>(0));
		for (int j = 0; j < v[i].size(); j++)
		{
			int x = v[i][j][0];
			vector<int> v1; v1.push_back(x);
			vector<int> v2;
			for (int y : v[i][j])
			{
				if (x != y)
				{
					if (divisible(x, y, 2 * k))
					{
						v1.push_back(y);
					}
					else
					{
						v2.push_back(y);
					}
				}
			}
			v[i + 1].push_back(v1);
			v[i + 1].push_back(v2);
		}
		i++;
	}

	int k = 1;
	while (2 * k < m)
	{
		k *= 2;
	}
	vector<int> l, r;
	for (int j = 0; j < v[i].size(); j++)
	{
		if (v[i][j].size() == 2)
		{
			if (compare(v[i][j][0], v[i][j][1]))
			{
				l.push_back(v[i][j][0]);
				r.push_back(v[i][j][1]);
			}
			else
			{
				l.push_back(v[i][j][1]);
				r.push_back(v[i][j][0]);
			}
		}
		else
		{
			l.push_back(v[i][j][0]);
		}
	}


	vector<int> v1 = solve2(l, n), v2 = solve2(r, n), res;
	for (int j = 0; j < m; j++)
	{
		if (j < l.size())
		{
			res.push_back(v1[j]);
		}
		else
		{
			res.push_back(v2[j - l.size()]);
		}
	}
	return res;
}


vector <int> solve(int n)
{
	vector<int> v(n);
	for (int i = 0; i < n; i++)
	{
		v[i] = i + 1;
	}
	
	v = solve2(v, n);
	vector<int> res(n);

	for (int i = 0; i < n; i++)
	{
		res[v[i] - 1] = i;
	}

	return res;
}
