#include "sorting.h"
#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define vll vector<ll>
#define vvll vector<vll>

vector<int> solve(int n) {
    if (n <= 1000) {
        vll dist1(n);
        vll dist2(n);
        dist1[0] = 0;
        for (ll i = 1; i < n; i++) {
            for (ll d = n; d; d--) {
                if (divisible(1, i+1, d)) {
                    dist1[i] = d;
                    break;
                }
            }
        }
        ll i2 = find(dist1.begin(), dist1.end(), 1) - dist1.begin();
        ll order = compare(1, i2+1);
        for (ll i = 0; i < n; i++) {
            if (i == i2) continue;
            for (ll d = n; d; d--) {
                if (divisible(i2+1, i+1, d)) {
                    dist2[i] = d;
                    break;
                }
            }
        }
        for (ll i = 0; i < n; i++) {
            if (order ^ (dist1[i] > dist2[i])) {
                dist1[i] *= -1;
            }
        }
        vector<int> ans(n);
        iota(ans.begin(), ans.end(), 0);
        sort(ans.begin(), ans.end(), [&](ll a, ll b){
            return dist1[a] < dist1[b];
        });
        vector<int> ans2(n);
        for (ll i = 0; i < n; i++) ans2[ans[i]] = i+1;
        return ans2;
    }

    vll primes{2,3,5,7,11,13,17};
    ll MOD = 510510;
    vll crt{255255, 170170, 306306, 145860, 46410, 157080, 450450};
    ll sz = primes.size();
    vvll primepart(sz, vll(n, -1));
    vvll primepartmap(sz);
    for (ll i = 0; i < sz; i++) {
        primepartmap[i].resize(primes[i]);
        for (ll p = 0; p < primes[i]; p++) {
            ll j = find(primepart[i].begin(), primepart[i].end(), -1) - primepart[i].begin();
            primepart[i][j] = p;
            for (ll k = j + 1; k < n; k++) {
                if (primepart[i][k] == -1 && divisible(j+1, k+1, primes[i])) primepart[i][k] = p;
            }
        }
    }
    vll g1;
    for (ll i = 0; i < n; i++) if (primepart[0][i]) g1.push_back(i);
    ll mv = *max_element(g1.begin(), g1.end(), [&](ll a, ll b){return compare(a+1, b+1);});
    ll mvv = n-1;
    for (ll i = 0; i < n; i++) {
        if (i == mv) continue;
        if (divisible(mv+1, i+1, n-1)) {
            mvv = n;
            break;
        }
    }
    for (ll i = 1; i <= 17; i++) {
        for (ll j = 0; j < n; j++) {
            if (j == mv) continue;
            if (divisible(mv+1, j+1, mvv - i)) {
                for (ll k = 0; k < sz; k++) {
                    primepartmap[k][primepart[k][j]] = i % primes[k];
                }
                break;
            }
        }
    }
    vector<int> ans(n);
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < sz; j++) {
            ans[i] += crt[j] * primepartmap[j][primepart[j][i]];
        }
        ans[i] %= MOD;
    }
    return ans;
}