#include <iostream>
#include <vector>
#include "sorting.h"

using namespace std;

bool compare(int x, int y);
bool divisible(int x, int y, int d);

vector<int> solve(int n){
    vector<int> res(n,0);
    int bound = (n%2)?(n-2):(n-1);
    int a, b, m;
    int k, l;
    vector<bool> v(n, 1);
    for (int i = 1; i<=bound; i+=2){
        a = (i+1)/2; b = n - (i-1)/2;
        m = n - i;
        bool f = 1;
        for (int x=1; x<=n; i++){
            if (!v[x-1]) continue;
            for (int y = x+1; y<=n; y++){
                if (!v[y-1]) continue;
                if (divisible(x,y,m)){
                    if (compare(x,y)) {
                        res[x-1] = a;
                        res[y-1] = b;
                    } else {
                        res[x-1] = b;
                        res[y-1] = a;
                    }
                    v[x-1]=0; v[y-1] = 0;
                    f = 0; break;
                }

            }
            if (!f) break;
        }

    }
    if (n%2){
        for (int i=0; i<n; i++){
            if (!res[i]) res[i] = (n+1)/2;
        }
    }
    return res;

}

