#include <iostream>
#include <unordered_set>
#include <vector>
#include "sorting.h"

using namespace std;

vector<int> p;
bool compare(int x, int y);
bool divisible(int x, int y, int d) ;

vector<int> solve(int n){
    vector<int> res(n,0);
    int bound = (n%2)?(n-2):(n-1);
    int a, b, m;
    bool f= 1;
    for (int x=1; x<=n; x++){
        for (int y=x+1; y<=n; y++){
            if (divisible(x,y,n-1)){
                if (compare(x,y)) {
                    res[x-1] = 1;
                    res[y-1] = n;
                    a = x; b = y;

                } else {
                    res[x-1] = n;
                    res[y-1] = 1;
                    a = y; b=x;
                }
                f = 0; break;
            }

        }
        if (!f) break;
    }
    unordered_set<int> big, med;
    vector<int> pairs(n,0);
    int i = 1; int j = n;
    while (i<j){
        if (i==a) i++; if (i==b) i++;
        if (j==b) j--; if (j==a) j--;
        if (compare(i,j)){
            big.insert(j);
            pairs[j-1] = i;
        } else {
            big.insert(i);
            pairs[i-1] =j;
        }
        i++; j--;
    }
    if (i==j) med.insert(i);


    m = n-2;
    while (m>1){
        f=0;
        for (auto x: big){
            if (divisible(a, x, m)){
                res[x-1] = m+1;
                m--;
                f=1;
                big.erase(x);
                med.insert(pairs[x-1]);
                break;
            }
        }
        if (f) continue;
        for (auto x: med){
            if (divisible(a, x, m)){
                res[x-1] = m+1;
                m--;
                f=1;
                med.erase(x);
                break;
            }
        }

    }
    for (auto x: med) res[x-1] = 2;
    return res;


}

