#include <iostream>
#include <map>
#include <vector>
#include "sorting.h"
using namespace std;

int const N=500+10;
vector<int> g[N];
bool vis[N];
int val[N];

void dfs_up(int v)
{
	vis[v]=true;
	for(int u:g[v])
		if(!vis[u])
		{
			val[u]++;
			dfs_up(u);
		}
}

void dfs(int v)
{
	vis[v]=true;
	for(int u:g[v])
		if(!vis[u])
			dfs(u);
}

vector<int> solve(int n)
{
	if(n>=N)
	{
		map<int,int> val;
	    for (int i = 1; i <= n; ++i)
	        for (int j = i+1; j <= n; ++j)
	        {
	            if(i==j)
	                continue;
	            bool che=compare(i,j);
	            if(che==true)
	                val[j]++;
	            else
	                val[i]++;
	        }
	    vector<int> ans;
	    for (int i = 1; i <= n; ++i)
	        ans.push_back(val[i]+1);
	    return ans;
	}
    for (int i = 1; i <= n; ++i)
    {
    	for (int j = 0; j < n+2; ++j)
    		vis[j]=false;
    	dfs(i);
    	for (int j = i; j <= n; ++j)
    		if(!vis[j])
    		{
    			bool var=compare(i,j);
    			if(var)
    				g[i].push_back(j);
    			else
    				g[j].push_back(i);
    		}
    }
    for (int i = 1; i <= n; ++i)
    {
    	for (int j = 0; j < n+2; ++j)
    		vis[j]=false;
    	dfs_up(i);
    }
    vector<int> ans;
    for (int i = 1; i <= n; ++i)
    	ans.push_back(val[i]+1);
    return ans;
}