/*********************ALLAH HO AKBAR***********************/
/************HAZRAT MUHAMMAD (Peace be upon him)***********/
#include <iostream>
#include <algorithm>
#include <string>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <iomanip>
#include <cassert>
#include <cstring>
#include <sstream>
#include <numeric>
#include <cstdio>
#include <bitset>
using namespace std;
int const N=2005;
int const mod=1e9+7;
vector<int> adj[N];
int edgenum[N][N];
int vis[N][N];
int vis1[N][N];
int curdfs=0;
void dfs(int node){
    vis[curdfs][node]=1;
    for (int i:adj[node])
        if(vis[curdfs][i]==0)
            dfs(i);
}
void dfs1(int node){
    vis1[curdfs][node]=1;
    for (int i:adj[node])
        if(vis1[curdfs][i]==0)
            dfs1(i);
}
long long power(int a,int b){
    if(b==0)
        return 1;
    else if(b==1)
        return a;
    long long p=power(a,b/2);
    p%=mod;
    p*=p;
    p%=mod;
    if(b%2)
        p*=a;
    p%=mod;
    return p;
}
void solve(){
    int n,m;
    cin>>n>>m;
    for (int i = 0; i < m; ++i)
    {
        int a,b;
        cin>>a>>b;
        adj[a].push_back(b);
    }
    for (int i = 1; i <=n; ++i){
        curdfs=i;
        dfs(i);
    }
    for (int i = 0; i <=n; ++i)
        reverse(adj[i].begin(), adj[i].end());
    for (int i = 1; i <=n; ++i){
        curdfs=i;
        dfs1(i);
    }
    int q;
    cin>>q;
    vector<int> ans;
    vector<int> B;
    if(q==0){
        q=(n*(n+1))/2;
        for (int i = 1; i <=n; ++i)
            for (int j = i; j <=n; ++j)
            {
                B.push_back(j);
                if(vis[i][j]+vis1[i][j]>1&&vis[j][i]+vis1[j][i]>1)
                    ans.push_back(m+1);
                else
                    ans.push_back(0);
            }
    }
    for (int i = 0; i < q; ++i){
        int a,b;
        cin>>a>>b;
        B.push_back(b);
        if(vis[a][b]+vis1[a][b]+vis[b][a]+vis1[b][a]>2)
            ans.push_back(m+1);
        else
            ans.push_back(0);
    }
    long long x=0;
    for (int i = 1; i <=ans.size(); ++i)
    {
        x+=(ans[i-1]*(power(B[i-1],q-i)))%mod;
        x%=mod;
    }
    cout<<x<<endl;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);
    int t=1;
    // cin>>t;
    while(t--)
        solve();
    return 0;
}