#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <map>
#include <cmath>
#define ll long long
#define pii pair <int, int>
#define x first
#define y second
#pragma GCC optimize("Ofast")
#define int ll

using namespace std;

int n, m, q;

vector <int> g[2005];
vector <pii> edges;
bool viz[2005], ok[2005];

void bfs(int a, int edg) {
    queue <int> q;
    for (int i = 1; i <= n; i++)
        viz[i] = 0;
    q.push(a);
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        if (viz[u])
            continue;
        viz[u] = 1;

        for (int i = 0; i < g[u].size(); i++) {
            int v = g[u][i];
            if (u == edges[edg].x && v == edges[edg].y)
                continue;
            if (viz[v] == 0) {
                q.push(v);
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    cin >> n >> m;
    for (int i = 1; i <= m; i++) {
        int x, y;
        cin >> x >> y;
        g[x].push_back(y);
        pii aux;
        aux.x = x;
        aux.y = y;
        edges.push_back(aux);
    }

    cin >> q;
    for (int iq = 1; iq <= q; iq++) {
        int a, b;
        cin >> a >> b;
        int cnt = 0;
        for (int i = 0; i < m; i++) {
            bfs(a, i);
            cnt += viz[b];
        }
        if (cnt == m)
            cnt = m + 1;
        cout << cnt << " ";
    }
    return 0;
}
