#include <iostream>
#include <fstream>
#include <vector>
#include <bitset>

using namespace std;

#define modul 1000000007
#define dim1 2001
#define dim 2001002
//ifstream fin("date.in");
//ofstream fout("date.out");
bool val[dim1][dim1];
vector<vector<int>> v;
bitset<dim> fr;
const int bb=200000;
void dfs(int in,int a)
{
    val[in][a]=1;
    int i;
    for(i=0;i<v[a].size();i++)
    {
        if(val[in][ v[a][i] ]==0)
            dfs(in,v[a][i]);
    }

}
bool drum(int a,int b)
{
    if(val[a][b]==1)
        return true;
    dfs(a,a);
    if(val[a][b]==1)
        return true;
    return false;
}

int main()
{
    int n,m,x,y,i,q,k,j;
    cin>>n>>m;
    v.resize(n+1);
    for(i=0;i<m;i++)
    {
        cin>>x>>y;
        v[x].push_back(y);
    }
    cin>>q;
    for(i=0;i<q;i++)
    {
        cin>>x>>y;
        fr[i]=0;
        if(drum(x,y)==true && drum(y,x)==true)
        {
            fr[i]=1;
        }
    }
    if(q==0)
    {
        k=0;
        for(i=1;i<=n;i++)
        {
            for(j=i;j<=n;j++,k++)
            {
                if(j==i)
                    fr[k]=1;
                else
                {
                    if(drum(i,j)==true && drum(j,i)==true)
                        fr[k]=1;
                    else
                        fr[k]=0;
                }
            }
        }
        q=k;
    }
    long long sum=0,p=1;
    for(i=q-1;i>=0;i--)
    {
        sum+=fr[i]*p;
        p*=bb;p%=modul;
        sum%=modul;
    }
    sum*=m+1;
    sum%=modul;
    cout<<sum;
    return 0;
}
