#include <bits/stdc++.h>
#define NMAX 2000
#define MMAX 100000
#define BASE 200000
#define MOD 1000000007
#define int64 long long

using namespace std;

struct strson {
  int node, index;
};


bool f[NMAX + 1];
vector <strson> vsons[NMAX + 1];
bool is_active[MMAX + 1];

void reset_f(int n) {
  int i;
  for (i = 1; i <= n; i++)
    f[i] = 0;
}

bool dfs(int node, int finish) {
  int nsons, i;
  bool ok;

  if (node == finish)
    return true;

  f[node] = 1;

  ok = false;
  nsons = vsons[node].size();
  for (i = 0; i < nsons && !ok; i++) {
    if (is_active[vsons[node][i].index]) {
      int newnode = vsons[node][i].node;
      if (f[newnode] == 0 && dfs(newnode, finish))
        ok = true;
    }
  }

  f[node] = 0;

  return ok;
}

signed main() {
  #ifdef iati
    freopen("a.in", "r", stdin);
    freopen("a.out", "w", stdout);
  #endif // iati

  ios_base::sync_with_stdio(NULL);
  cin.tie(0);
  cout.tie(0);

  int n, m, i, sol, x, y, q, j, node1, node2;
  cin >> n >> m;

  for (i = 0; i < m; i++) {
    cin >> x >> y;
    vsons[x].push_back({y, i});
    is_active[i] = 1;
  }

  cin >> q;
  sol = 0;

  while (q--) {
    cin >> node1 >> node2;

    bool ok = true;
    int cnt_true = 0, cnt_false = 0;
    int index_road;

    for (j = 0; j < m; j++) {
      is_active[j] = 0;

      bool ok1 = dfs(node1, node2);
      bool ok2 = dfs(node2, node1);
      ok = (ok1 & ok2);

      cnt_true += (ok == 1);
      cnt_false += (ok == 0);

      if (cnt_false == 1 && ok == 0)
        index_road = j;

      is_active[j] = 1;
    }

    int crtsol;
    if (cnt_false == 0)
      crtsol = m + 1;
    else {
      //reset_f(n);
      bool ok1 = dfs(node1, node2);
      //reset_f(n);
      bool ok2 = dfs(node2, node1);
      ok = (ok1 & ok2);

      if (ok == false)
        crtsol = 0;
      else {
        crtsol = index_road + 1;
      }
    }

//    cout << crtsol << " ";
    sol = ((int64)sol * BASE + crtsol) % MOD;
  }

  cout << sol;
  return 0;
}
