#include <bits/stdc++.h>
#define NMAX 2000
#define MMAX 100000
#define BASE 200000
#define MOD 1000000007
#define int64 long long
#define int long long
#pragma ("O3")

using namespace std;

struct strson {
  int node, index;
};

int n;
bool f[NMAX + 1];
vector <strson> vsons[NMAX + 1];
bool is_active[MMAX + 1];
stack <int> vctc;
vector <int> vmyctct[NMAX + 1];
int vlevel[NMAX + 1];
int vhigh[NMAX + 1];
set < pair <int, int> > vset;

bool is_path(int node1, int node2) {
  int i;
  queue <int> vbfs;

  for (i = 1; i <= n; i++)
    f[i] = 0;

  vbfs.push(node1);
  while (!vbfs.empty()) {
    int node = vbfs.front();
    vbfs.pop();
    f[node] = 1;
    if (node == node2)
      return 1;

    int nsons = vsons[node].size();
    for (i = 0; i < nsons; i++) {
      int newnode = vsons[node][i].node;
      if (is_active[vsons[node][i].index] && f[vsons[node][i].node] == 0)
        vbfs.push(vsons[node][i].node);
    }
  }

  return 0;
}

signed main() {
  #ifdef iati
    freopen("a.in", "r", stdin);
    freopen("a.out", "w", stdout);
  #endif // iati

  ios_base::sync_with_stdio(NULL);
  cin.tie(0);
  cout.tie(0);

  int m, i, x, y, q, j, node1, node2, crtsol, cnt_true, cnt_false;
  int64 sol;
  cin >> n >> m;

  for (i = 0; i < m; i++) {
    cin >> x >> y;
    vsons[x].push_back({y, i});
    is_active[i] = 1;
  }

//  for (i = 1; i <= n; i++) {
//    if (f[i] == 0) {
//      vsons[0].push_back({i, -1});
//      find_ctc(i, 1);
//    }
//  }

  cin >> q;
  sol = 0;
  while (q--) {
    cin >> node1 >> node2;

    cnt_false = cnt_true = 0;
    for (i = 0; i < m; i++) {
      is_active[i] = 0;

      bool ok1 = is_path(node1, node2);
      bool ok2 = is_path(node2, node1);


      if (ok1 == true && ok2 == true)
        cnt_true++;
      else {
        cnt_false++;
        if (cnt_false == 1)
          crtsol = i + 1;
      }

      is_active[i] = 1;
    }

    if (cnt_false == 0)
      crtsol = m + 1;
    else {
      bool ok1 = is_path(node1, node2);
      bool ok2 = is_path(node2, node1);

      if (ok1 == 0 || ok2 == 0)
        crtsol = 0;
    }

    sol = ((int64)sol * BASE + crtsol) % MOD;
  }

  cout << sol;
  return 0;
}
