#include <iostream>
#include <vector>
#include <climits>
#define int unsigned long long
#define MAX 100002
using namespace std;
pair<int, int> bus[MAX];
pair<int, int> student[MAX];
int n,m,ans,k,cost,st[MAX],vf[MAX],lst=1;

void backtrack(int pas){
    if(pas == k+1){
        ans = min(ans, cost*1ULL);
    }else{
        /// studentul pas alege ce autobuz vrea sa ia
        for(int i = 1; i <= n; i++){
            if(student[pas].first < bus[i].first){
                break;
            }
            if(vf[i] == 0){
                vf[i] = 1;
                st[pas] = i;
                cost += (student[pas].first-bus[i].first)*student[pas].second + bus[i].second;
                backtrack(pas+1);
                vf[i] = 0;
                cost -= (student[pas].first-bus[i].first)*student[pas].second + bus[i].second;
            }else{
                st[pas] = i;
                cost += (student[pas].first-bus[i].first)*student[pas].second;
                backtrack(pas+1);
                cost -= (student[pas].first-bus[i].first)*student[pas].second;
            }
        }
    }
}

int getpos(int x){
    /// 1 1 1 1 0 0 0 0
    ///       ^
    /// .first <= x
    int st = lst, dr = n;
    int ans = 1;
    while(st <= dr){
        int mid = (st+dr)/2;
        if(bus[mid].first <= x){
            ans = mid;
            st = mid+1;
        }else{
            dr = mid-1;
        }
    }
    return ans;
}

int solve(int pos, int v){
    int ans = 0;
    while(bus[lst].first <= pos && lst <= n){
        lst++;
    }
    lst--;
    ans = lst;
    return ans;
}

signed main()
{
    cin >> n;
    for(int i = 1; i <= n; i++){
        cin >> bus[i].first >> bus[i].second;
    }
    cin >> m;
    int sol = 0;
    for(int i = 1; i <= m; i++){
        cin >> student[i].first >> student[i].second;
        /// bag bulan tati
        sol += solve(student[i].first,student[i].second);
        cout << sol << " ";
    }
    return 0;
}
