#include <iostream>
#include <fstream>
#include <vector>
#include <queue>
//#include <mem.h>

#define DIM 2000
#define DIM2 100000

#define MOD 1000000007
#define Bpow1 200000

using namespace std;
//ifstream f("in.in");

vector <int> l[DIM+5];
pair <int,int> drumuri[DIM2+5];
short drum[DIM+5][DIM+5];
bool v[DIM+5];
int n,m,q,x,y;

long long sol[DIM*DIM+5],sumSol=0,k,b;

bool bfs(int start,int target,int blocked){
    //cout<<"@"<<start<<" "<<target<<" "<<blocked<<'\n';
    for(int i=1;i<=n;i++){
        v[i] = 0;
    }

    v[start] = 1;

    queue <int> q;
    queue <int> elim;
    q.push(start);
    while(!q.empty()){

        int nod = q.front();

        if(start == 6 && target == 4){
            //cout<<nod<<" ";
        }

        if(nod == target){
            return 1;
        }

        for(int i=0;i<l[nod].size();i++){
            int vecin = l[nod][i];
            if(v[vecin] == 0 &&
               !(drumuri[blocked].first==nod && drumuri[blocked].second==vecin &&
                drum[nod][vecin] == 1)){

                v[vecin] = 1;
                q.push(vecin);
            }
        }

        q.pop();
    }

    return 0;
}

int check(int x,int y){
    //cout<<'\n';
    if(bfs(x,y,0) == 0){
        return 0;
    }
    if(bfs(y,x,0) == 0){
        return 0;
    }

    if(n>200 || q>500){
        return m+1;
    }

    for(int i=1;i<=m;i++){
        if(bfs(x,y,i) == 0 || bfs(y,x,i) == 0){
            return i;
        }
    }

    return m+1;
}

int main()
{
    cin>>n>>m;

    drumuri[0] = {0,0};
    for(int i=1;i<=m;i++){
        cin>>x>>y;
        l[x].push_back(y);
        drumuri[i] = {x,y};
        if(drum[x][y] == 0){
            drum[x][y] = 1;
        }else{
            drum[x][y] = 2;
        }
    }

    cin>>q;
    if(q == 0){
        k=0;
        for(int i=1;i<=n;i++){
            for(int j=i;j<=n;j++){
                sol[++k] = check(i,j);
            }
        }
    }else{

        for(int i=1;i<=q;i++){
            cin>>x>>y;
            sol[++k] = check(x,y);
        }
    }

    b=1;
    for(int i=k;i>=1;i--){

        sumSol = (sumSol + (b * sol[i])%MOD)%MOD;

        b = (b*1ll*Bpow1)%MOD;
    }

    cout<<sumSol;

    return 0;
}
