#include <bits/stdc++.h>
#define all(x) (x).begin(),(x).end()
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
// #define int ll
#define sz(x) (int)(x).size()

using pii = pair<int,int>;
using tii = tuple<int,int,int>;
using tiii = tuple<int,int,int,int>;

typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> oset;

const int nmax = 2e3 + 5, mmax = 1e5 + 5;

int ans[nmax][nmax];
vector<pii> g[nmax];
int up[nmax], d[nmax];
int cringe[nmax];

int n, m;

pii edg[mmax];
int viz[nmax];

void dfs(int node) {
	if(viz[node]) return;
	viz[node] = 1;
	for(auto [a, b] : g[node]) dfs(a);
	return;
}

signed main() {
	cin.tie(0) -> sync_with_stdio(0);
	cin >> n >> m;
	for(int a, b, i = 1; i <= m; i++) {
		cin >> a >> b;
		edg[i] = pii{a, b};
	}
	for(int i = 1; i <= n; i++) {
		for(int j = 1; j <= n; j++)
			ans[i][j] = m + 1;
	}
	for(int i = m; i >= 0; i--) {
		for(int i = 1; i <= n; i++)
			g[i].clear();
		for(int j = 1; j <= m; j++) {
			if(i != j)	
				g[edg[j].first].emplace_back(edg[j].second, i);
		}
		for(int a = 1; a <= n; a++) {
			for(int b = i; b <= n; b++) {
				memset(viz, 0, sizeof(viz));
				dfs(a);
				if(viz[b] == 0)
					ans[a][b] = i;
				else {
					memset(viz, 0, sizeof(viz));
					dfs(b);
					if(viz[a] == 0)
						ans[a][b] = i;
				} 
			}
		}
	}
	
	int q;
	cin >> q;
	const ll mod = 1e9 + 7, b = 2e5;
	ll rez = 0;
	if(q == 0) {
		// cerr << '\n';
		// for(int i = 1; i <= n; i++)
			// for(int j = 1; j <= n; j++)
				// cerr << ans[i][j] << " \n"[j == n];
		for(int i = 1; i <= n; i++) {
			for(int j = i; j <= n; j++) {
				rez = ((ll)rez * b + (ll)min(ans[i][j], ans[j][i])) % mod;
				// cerr << min(ans[i][j], ans[j][i]) << ' ';
			}
		}
		cout << rez << '\n';
		return 0;
	}
	for(int i = 0, a, u; i < q; i++) {
		cin >> a >> u;
		if(a > u)
			swap(a, u);
		rez = ((ll)rez * b + (ll)ans[a][u]) % mod;
	}
	cout << rez << '\n';
	return 0;
}
