#include <vector>
#include <algorithm>
#include <iostream>
#define all(x) (x).begin(),(x).end()
#include "sorting.h"
using namespace std;

#define sz(x) (int)(x).size()

vector<int> atr;

void init(vector<int>& tosort, int val = 1) {
	int N = sz(tosort);
	if(sz(tosort) == 2) {
		atr[tosort[0]] = 1,
		atr[tosort[1]] = 0;
		if(compare(tosort[0], tosort[1]))
			atr[tosort[0]] = 0,
			atr[tosort[1]] = 1;
		return;
	}
	if(sz(tosort) == 1) {
		atr[tosort[0]] = 0;
		return;
	}
	if(N % 3 != 0) {
		vector<int> a[3];
		a[0].reserve(N / 3 + 1);
		a[1].reserve(N / 3 + 1);
		a[2].reserve(N / 3 + 1);
		vector<int> remain;
		remain.reserve(2 * N / 3 + 1);
		a[0].emplace_back(tosort[0]);
		for(int i = 1; i < sz(tosort); i++) {
			if(divisible(tosort[0], tosort[i], val * 3))
					a[0].emplace_back(tosort[i]);
			else
				remain.emplace_back(tosort[i]);
		}	
		a[1].emplace_back(remain[0]);
		for(int i = 1; i < sz(remain); i++) {
			if(divisible(remain[0], remain[i], val * 3))
				a[1].emplace_back(remain[i]);
			else
				a[2].emplace_back(remain[i]);
		}
		
		init(a[0], val * 3);
		init(a[1], val * 3);
		init(a[2], val * 3);
		
		for(auto x : tosort)
			atr[x] *= 3;
		int l = sz(tosort) / 3;
		sort(a, a + 3, [&](auto u, auto b) { return sz(u) < sz(b); });
		if(sz(a[1]) != l) {
			for(auto x : a[0])
				atr[x] += 2;
			int u = a[1][0], v = a[2][0];
			for(auto i : a[1])
				if(atr[i] < atr[u])
					u = i;
			for(auto i : a[2])
				if(atr[i] < atr[v])
					v = i;
			
			if(!compare(u, v))
				swap(a[1], a[2]);
			for(auto x : a[2])
				atr[x] += 1;
		}
		else {
			int u = a[1][0], v = a[0][0];
			for(auto i : a[1])
				if(atr[i] < atr[u])
					u = i;
			for(auto i : a[0])
				if(atr[i] < atr[v])
					v = i;
			
			if(!compare(v, u))
				swap(a[1], a[0]);
			for(auto x : a[0])
				atr[x] += 1;
			for(auto x : a[1])
				atr[x] += 2;
		}
		return;
	}
	
	vector<int> a[2];
	a[0].reserve(N / 2 + 1);
	a[1].reserve(N / 2 + 1);
	a[0].emplace_back(tosort[0]);
	for(int i = 1; i < N; i++) {
		if(divisible(tosort[0], tosort[i], val * 2))
			a[0].emplace_back(tosort[i]);
		else
			a[1].emplace_back(tosort[i]);
	}
	
	init(a[0], val * 2);
	init(a[1], val * 2);
	
	for(auto x : tosort)
		atr[x] *= 2;
	
	if(sz(a[0]) > sz(a[1]))
		swap(a[0], a[1]);
	
	if(a[0].size() != a[1].size()) {
		for(auto x : a[0])
			atr[x]++;
	}
	else {
		int u = a[1][0], v = a[0][0];
		for(auto i : a[1])
			if(atr[i] < atr[u])
				u = i;
		for(auto i : a[0])
			if(atr[i] < atr[v])
				v = i;
		
		if(!compare(v, u))
			swap(a[1], a[0]);
		for(auto x : a[1])
			atr[x] += 1;
	}
	return;
}

std::vector < int > solve(int N) {	
	vector<int> vals(N);
	atr.resize(N + 1);
	for(int i = 1; i <= N; i++)
		vals[i - 1] = i;
	init(vals);
	for(auto &x : atr)
		x++;
	vector<int> rez;
	copy(1 + all(atr), back_inserter(rez));
	return rez;
}
