#pragma GCC optimize("O3,Ofast,unroll-loops")
#pragma GCC target("popcnt,lzcnt,sse,sse2,sse3,ssse3,avx,avx2,tune=native")

#include <stdio.h>
#include <ctype.h>

#define magic_sauce inline __attribute__((always_inline))
using ll = unsigned long long;

magic_sauce ll fgetint(){
	ll n = 0;
	int ch;

	while( !isdigit( ch = fgetc( stdin ) ) );
	do
		n = n * 10 + ch - '0';
	while( isdigit( ch = fgetc( stdin ) ) );

	return n;
}

template<typename T> magic_sauce T min( T a, T b ){ return a < b ? a : b; }

// ---------------------------------------

const int MAXN = 1e5;
const int MAXM = 1e5;
const ll INF = 2e18;

ll spc[1 + MAXN];
ll spi[1 + MAXN];

struct Punct { int poz; ll cost; };

Punct dud[1 + MAXN];
Punct bus[MAXN + 1];

ll dp[1 + MAXM];

int main(){
	int n, m, i, lastb;

	n = fgetint();
	for( i = 0 ; i < n ; i++ )
		bus[i] = { fgetint(), fgetint() };
	bus[n].poz = (1 << 30) + 123;

	m = fgetint();
	spc[0] = spi[0] = 0;
	for( i = 1 ; i <= m ; i++ ){
		dud[i] = { fgetint(), fgetint() };
		spc[i] = dud[i].cost + spc[i - 1];
		spi[i] = ((__int128)dud[i].cost) * dud[i].poz + spi[i - 1];
	}
	dud[0].poz = -1;

	/*if( bus[0].poz > dud[i].poz ){
		for( i = 0 ; i < n ; i++ )
		return 0;
	}*/

	dp[0] = 0;
	lastb = 0;
	for( i = 1 ; i <= m ; i++ ){
		dp[i] = +INF;
		while( bus[lastb].poz <= dud[i].poz )
			lastb++;

		//printf( "lastb = %d | busp = %d\n", lastb, bus[lastb].poz );
		//printf( "dudpoz = %d\n", dud[i].poz );

		int j = i;
		for( int b = lastb ; b-- ; ){
			while( dud[j].poz >= bus[b].poz )
				j--;

			dp[i] = min( dp[i],
				dp[j] +
				(spi[i] - spi[j]) -
				bus[b].poz * (spc[i] - spc[j]) +
				bus[b].cost
			);

			//printf( "bus = %d | j = %d | dp = %lld\n", b, j, dp[i] );
		}

		//printf( "%lld\n", (ll)dp[i] );
		printf( "%lld ", (ll)dp[i] );
	}
	printf( "\n" );

	return 0;
}