#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
ifstream fin("input.txt");
#define cin fin
#endif

#define pb push_back

const int MOD = 1e9+7;
const int B = 2e5;

const int NMAX = 2005;
const int QMAX = 1e5+5;

int n, m, q;
vector<int> g[NMAX];
int x, y;
int qx[QMAX], qy[QMAX];
int ans;
int bb = 1;

void add_to_ans(int x) {
    ans += (1ll * x * bb) % MOD;
    bb = (1ll * B) % MOD;
}

void read() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m;
    for (int i = 1; i <= m; i++) {
        cin >> x >> y;
        g[x].pb(y);
    }
    cin >> q;
    for (int i = 1; i <= q; i++)
        cin >> qx[i] >> qy[i];
}

bool has_path[NMAX][NMAX];
bool viz[NMAX];

void dfs(int x, int root) {
    has_path[root][x] = true;
    for (auto &v : g[x]) {
        if (!viz[v]) {
            viz[v] = true;
            dfs(v, root);
        }
    }
}

void solve_0_or_m_plus_1() {
    for (int i = 1; i <= n; i++)
        dfs(i, i);
    for (int i = q; i >= 1; i--) {
        add_to_ans((has_path[qx[i]][qy[i]] & has_path[qy[i]][qx[i]]) * (m + 1));
    }
}

int main() {
    read();
    if (q <= 1e5)
        solve_0_or_m_plus_1();
    cout << ans;
    return 0;
}
