#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
ifstream fin("input.txt");
#define cin fin
#endif

const int INF = 2e9;
const int NMAX = 1e5+5;

int n, m;
int x[NMAX], y[NMAX], v[NMAX], c[NMAX];

int dist(int i, int j) {
    if (x[i] < y[j] || j > m)
        return INF;
    return (x[i] - y[j]) * v[i] + c[j];
}

void read() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> m;
    for (int i = 1; i <= m; i++)
        cin >> y[i] >> c[i];
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> x[i] >> v[i];
}

void solve1e5() {
    int ans = 0;
    for (int i = 1; i <= n; i++) {
        int j = 1;
        int d = dist(i, j);
        int mn = INF;
        while (d != INF) {
            mn = min(mn, d);
            d = dist(i, ++j);
        }
        ans += mn;
        cout << ans << '\n';
    }
}

int main() {
    read();
    if (n <= 1e5) {
        solve1e5();
    }
    return 0;
}
