#include "sorting.h"
#include <bits/stdc++.h>

using namespace std;

const int NMAX = 5e5+5;

int diff[NMAX];

int find_the_diff(int n, int x, int y) {
    int poz = -1;
    for (int i = 1; i <= n; i++) {
        if (divisible(x, y, i)) {
            poz = i;
            break;
        }
    }
    int fpoz = poz;
    for (int j = 2 * poz; j <= n; j += poz) {
        if (divisible(x, y, j))
            fpoz = j;
    }
    return fpoz;
}

vector<int> solve(int n) {
    vector<int> ans(n);
    for (int i = 1; i < n; i++) {
        diff[i] = find_the_diff(n, i, i + 1) * (compare(i, i + 1) ? 1 : -1);
    }
    ans[0] = 1;
    int mn = 1;
    for (int i = 1; i < n; i++) {
        ans[i] = diff[i] + ans[i - 1];
        mn = min(mn, ans[i]);
    }
    for (auto &it : ans) {
        it += 1 - mn;
    }

    return ans;
}
