#include <bits/stdc++.h>

using namespace std;

#define MAXN 100010
#define MOD 1000000007
#define cont 20000

long long n,m;
long long q;
vector<long long> adj[MAXN];
long long rez[MAXN];
long long dist1[MAXN];
long long dist2[MAXN];
queue<long long> bfsq1;
queue<long long> bfsq2;
long long b[MAXN];

void bfs1(long long node)
{
    for (long long i=0;i<MAXN;i++) dist1[i]=-1;
    dist1[node]=0;
    bfsq1.push(node);

    while (!bfsq1.empty())
    {
        long long nodee=bfsq1.front();
        bfsq1.pop();

        long long s=adj[nodee].size();
        for (long long i=0;i<s;i++)
        {
            long long sled=adj[node][i];
            if (dist1[sled]==-1)
            {
                dist1[sled]=dist1[nodee]+1;
                bfsq1.push(sled);
            }
        }
    }
}

void bfs2(long long node)
{
    for (long long i=0;i<MAXN;i++) dist2[i]=-1;
    dist2[node]=0;
    bfsq2.push(node);

    while (!bfsq2.empty())
    {
        long long nodee=bfsq2.front();
        bfsq2.pop();

        long long s=adj[nodee].size();
        for (long long i=0;i<s;i++)
        {
            long long sled=adj[nodee][i];

            if (dist2[sled]==-1)
            {
                dist2[sled]=dist2[nodee]+1;
                bfsq2.push(sled);
            }
        }
    }
}

int main()
{
    cin>>n>>m;

    for (long long i=1;i<=m;i++)
    {
        long long x,y;
        cin>>x>>y;

        adj[x].push_back(y);
    }

    b[0]=1;

    for (long long i=1;i<MAXN;i++)
    {
        b[i]=b[i-1]*cont;
        if (b[i]>=MOD) b[i]%=MOD;
    }

    cin>>q;

    if (q==0)
    {

    }

    else
    {
        for (long long z=0;z<q;z++)
        {
            long long a,b;
            cin>>a>>b;

            bfs1(a);
            bfs2(b);

            if (dist1[b]==-1 or dist2[a]==-1) rez[z]=rez[z-1];
            else rez[z]=rez[z-1]+b[q-z-1];
            if (rez[z]>=MOD) rez[z]%=MOD;
        }

        cout<<rez[q-1]<<endl;
    }
}
