//#include "sorting.h"
#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll MOD = 1e9 + 7;

ll binpow(ll n, ll k) {
    ll res = 1;
    while (k) {
        if (k & 1) res = (1ll * res * n) % MOD;
        n = (1ll * n * n) % MOD;
        k >>= 1;
    }
    return res;
}

//-----------------------------------------------

const ll N = 2003;

ll n, m;

vector <ll> g[N];
vector <bool> used;

vector <ll> s;

void dfs(ll v) {
    used[v] = true;
    for (auto to : g[v])
        if (!used[to])
            dfs(to);
}

void solve(ll a, ll b) {
    used.assign(n, false);
    dfs(a);
    if (!used[b]) {
        s.push_back(0);
        return;
    }
    used.assign(n, false);
    dfs(b);
    if (!used[a]) {
        s.push_back(0);
        return;
    }
    s.push_back(m + 1);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    /*#ifndef ONLINE_JUDGE
        freopen("input123.txt", "r", stdin);
        freopen("output123.txt", "w", stdout);
    #endif*/

    cin >> n >> m;
    for (ll i = 0; i < m; i ++) {
        ll u, v;
        cin >> u >> v;
        u --, v --;
        g[u].push_back(v);
    }

    ll q;
    cin >> q;
    if (q != 0) {
        while (q --) {
            ll a, b;
            cin >> a >> b;
            a --, b --;
            solve(a, b);
        }
    }
    else {
        for (ll i = 0; i < n; i ++)
            for (ll j = i; j < n; j ++)
                solve(i, j);
    }
    //--------------------------------------------
    ll K = s.size();
    ll B = 2e5;
    ll res = 0;
    for (ll i = 1; i <= K; i ++) {
        res = (res + 1ll * s[i - 1] * binpow(B, K - i) % MOD) % MOD;
    }
    cout << res << '\n';
    return 0;
}