//#include "sorting.h"
#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int MOD = 1e9 + 7;

int binpow(int n, int k) {
    int res = 1;
    while (k) {
        if (k & 1) res = (1ll * res * n) % MOD;
        n = (1ll * n * n) % MOD;
        k >>= 1;
    }
    return res;
}

//-----------------------------------------------

const int N = 2003;

int n, m;

vector <int> g[N];
bool used[N];

bool can[N][N];

vector <int> s;

void dfs(int v) {
    used[v] = true;
    for (auto to : g[v])
        if (!used[to])
            dfs(to);
}

void solve(int a, int b) {
    if (!can[a][b] || !can[b][a])
        s.push_back(0);
    else
        s.push_back(m + 1);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    /*#ifndef ONLINE_JUDGE
        freopen("input123.txt", "r", stdin);
        freopen("output123.txt", "w", stdout);
    #endif*/

    cin >> n >> m;
    for (int i = 0; i < m; i ++) {
        int u, v;
        cin >> u >> v;
        u --, v --;
        g[u].push_back(v);
    }

    for (int i = 0; i < n; i ++) {
        for (int j = 0; j < n; j ++) {
            for (int u = 0; u < n; u ++) used[u] = false;
            dfs(i);
            can[i][j] = used[j];
        }
    }

    int q;
    cin >> q;
    if (q != 0) {
        while (q --) {
            int a, b;
            cin >> a >> b;
            a --, b --;
            solve(a, b);
        }
    }
    else {
        for (int i = 0; i < n; i ++)
            for (int j = i; j < n; j ++)
                solve(i, j);
    }
    //--------------------------------------------
    int K = s.size();
    int B = 2e5;
    int res = 0;
    for (int i = 1; i <= K; i ++) {
        res = (res + 1ll * s[i - 1] * binpow(B, K - i) % MOD) % MOD;
    }
    cout << res << '\n';
    return 0;
}