//#include "sorting.h"
#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int MOD = 1e9 + 7;

int binpow(int n, int k) {
    int res = 1;
    while (k) {
        if (k & 1) res = (1ll * res * n) % MOD;
        n = (1ll * n * n) % MOD;
        k >>= 1;
    }
    return res;
}

//-----------------------------------------------

const int N = 2003, M = 2003;

pair <int, int> e[M];

int n, m;

vector <int> g[N];
vector <bool> used;

bool can[N][N];

vector <int> s;

void dfs(int v, pair <int, int> p) {
    used[v] = true;
    for (auto to : g[v])
        if (!used[to] && make_pair(v, to) != p)
            dfs(to, p);
}

bool check(int a, int b, pair <int, int> p) {
    used.assign(n, false);
    dfs(a, p);
    if (!used[b])
        return false;
    used.assign(n, false);
    dfs(b, p);
    if (!used[a])
        return false;
    return true;
}

void solve(int a, int b) {
    if (!check(a, b, {-1, -1})) {
        s.push_back(0);
        return;
    }
    for (int i = 0; i < m; i ++) {
        if (!check(a, b, e[i])) {
            s.push_back(i + 1);
            return;
        }
    }
    s.push_back(m + 1);
    return;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    /*#ifndef ONLINE_JUDGE
        freopen("input123.txt", "r", stdin);
        freopen("output123.txt", "w", stdout);
    #endif*/

    cin >> n >> m;
    for (int i = 0; i < m; i ++) {
        int u, v;
        cin >> u >> v;
        u --, v --;
        g[u].push_back(v);
        e[i] = {u, v};
    }

    int q;
    cin >> q;
    if (q != 0) {
        while (q --) {
            int a, b;
            cin >> a >> b;
            a --, b --;
            solve(a, b);
        }
    }
    else {
        for (int i = 0; i < n; i ++)
            for (int j = i; j < n; j ++)
                solve(i, j);
    }
    //--------------------------------------------
    int K = s.size();
    int B = 2e5;
    int res = 0;
    for (int i = 1; i <= K; i ++) {
        res = (res + 1ll * s[i - 1] * binpow(B, K - i) % MOD) % MOD;
    }
    cout << res << '\n';
    return 0;
}