#include <bits/stdc++.h>

#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define watch(x) cout << (#x) << " : " << x << '\n'
#define boost ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)

using namespace std;

const int N = 2e4 + 128;
const int M = 1e3 + 128;

int n, m;

int x[M], y[N], v[M];
ll c[N];

ll dp[2][N];

const ll INF = 2e18;

void solve() {
    cin >> n;

    for (int i = 1; i <= n; i++)
        cin >> y[i] >> c[i];

    cin >> m;

    for (int i = 1; i <= m; i++)
        cin >> x[i] >> v[i];

    if (all_of(v + 1, v + m + 1, [&](const int& x) -> bool {return x == v[1];})) {
        assert(false);
        return;
    }

    for (int i = 0; i < 2; i++)
        for (int j = 0; j < N; j++)
            dp[i][j] = INF;

    ll prev = 0;

    for (int i = 1; i <= m; i++) {
        for (int k = 0; k <= n; k++)
            dp[i&1][k] = INF;

        ll loc = INF;
        for (int j = 1; j <= n; j++) {
            if (y[j] > x[i])
                continue;
            dp[i&1][j] = INF;
            dp[i&1][j] = min(dp[i&1][j], (x[i]-y[j])*v[i]+c[j]+prev);
            dp[i&1][j] = min(dp[i&1][j], (x[i]-y[j])*v[i]+dp[i&1^1][j]);
            loc = min(loc, dp[i&1][j]);
        }
        cout << loc << ' ';
        prev = loc;
    }

}

main() {
    boost;
    solve();
    return 0;
}
