#include <bits/stdc++.h>

#define ll __int128
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define watch(x) cout << (#x) << " : " << print(x) << '\n'
#define boost ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)

using namespace std;

const int MAX = 1e5 + 128;
int n, m;

ll x[MAX], y[MAX], v[MAX], c[MAX];

const ll INF = 2e18;

void read(ll &x) {
    string s;
    cin >> s;
    x = 0;
    for (auto c : s) {
        c -= '0';
        x *= 10;
        x += c;
    }
}

string print(ll x) {
    if (!x) return "0";
    string res = "";
    while (x) {
        res += char(x % 10 + '0');
        x /= 10;
    }
    reverse(all(res));
    return res;
}

void solve() {
    cin >> n;

    for (int i = 1; i <= n; i++)
        read(y[i]), read(c[i]);

    cin >> m;

    for (int i = 1; i <= m; i++)
        read(x[i]), read(v[i]);

    int lst = 1;
    ll max_left = -1e24, prev = 0;

    for (int i = 1; i <= m; i++) {
        while (lst <= n && y[lst] <= x[i]) {
            max_left = max(max_left, v[1]*y[lst]-c[lst]);
            lst++;
        }
        prev += (v[1]*x[i]-max_left);
        cout << print(prev) << ' ';
    }
}

main() {
    boost;
    solve();
    return 0;
}
