#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr ll INF = 1000000000000000000LL;
constexpr ll MOD = 1000000007;

ll n, m, q, k, x, y, a, b, c;
vector<ll> G[2000];
vector<ll> Gr[2000];
bool vis[2000];
ll comp[2000];
vector<ll> ts;

void topsort(ll x) {
    vis[x] = 1;
    for (int i : G[x]) {
        if (!vis[i]) {
            topsort(i);
        }
    }
    ts.push_back(x);
}

void component(ll x, ll c) {
    // cout << x << ' ' << c << '\n';
    comp[x] = c;
    for (int j : Gr[x]) {
        if (!comp[j]) {
            component(j, c);
        }
    }
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        cin >> x >> y;
        x--;
        y--;
        G[x].push_back(y);
        Gr[y].push_back(x);
    }
    for (int i = 0; i < n; i++) {
        if (!vis[i]) {
            topsort(i);
        }
    }
    for (int i = 0; i < n; i++) {
        vis[i] = 0;
    }
    reverse(ts.begin(), ts.end());
    ll c = 0;
    for (int i = 0; i < n; i++) {
        ll x = ts[i];
        if (!comp[x]) {
            c++;
            component(x, c);
        }
    }
    cin >> q;
    vector<ll> ans;
    if (q == 0) {
        for (int i = 0; i < n; i++) {
            for (int j = i; j < n; j++) {
                if (comp[i] == comp[j]) {
                    ans.push_back(m + 1);
                }
                else {
                    ans.push_back(0);
                }
            }
        }
    }
    else {
        for (int i = 0; i < q; i++) {
            cin >> x >> y;
            x--;
            y--;
            if (comp[x] == comp[y]) {
                ans.push_back(m + 1);
            }
            else {
                ans.push_back(0);
            }
        }
    }
    ll ans1 = 0;
    for (int i : ans) {
        ans1 *= 200000;
        ans1 += i;
        ans1 %= MOD;
        // cout << i << ' ';
    }
    cout << ans1 << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie();
    solve();
}