#include <iostream>
#include <vector>
#include <string>
#include <math.h>
#include <cmath>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <deque>
#include <bitset>
#include <cstring>
#include <unordered_map>

using namespace std;
typedef long long ll;

struct one{
    ll x, type, v, rent, prev, ind;
};

bool cmp(one p1, one p2){
    if(p1.x == p2.x)
        return p1.type < p2.type; // bus - 0
    return p1.x < p2.x;
}

int main(){
    ll n;
    cin >> n;
     
    vector<one>a;
    
    for(int i = 0; i < n; i++){
        ll x, rent;
        cin >> x  >> rent;
        
        a.push_back({x, 0, -1, rent, 0, -1});
    }
    
    ll m;
    cin >> m;
    
    for(int i = 0; i < m; i++){
        ll x, v;
        cin >> x >> v;
        
        a.push_back({x, 1, v, -1, -1, i});
    }
    
    sort(a.begin(), a.end(), cmp);
    
    vector<ll>dp(m);
    
    vector<one>buses;
    
    for(auto i: a){
        if(i.type == 0){
            buses.push_back(i);
            continue;
        }
        
        dp[i.ind] = 3 * 1e18;
        
        for(auto j: buses){
            ll cnt = (i.x - j.x) * i.v + j.rent;
            
            dp[i.ind] = min(dp[i.ind], cnt);
        }
        dp[i.ind] += (i.ind == 0 ? 0 : dp[i.ind - 1]);
    }
    
    for(int i = 0; i < m; i++)
        cout << dp[i] << ' ';
    cout << endl;
    
    return 0;
}
