#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <string>
#include <math.h>
#include <cmath>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <deque>
#include <bitset>
#include <cstring>
#include <unordered_map>

using namespace std;
typedef long long ll;

#define endl '\n'

struct one{
    ll x, type, v, rent, prev, ind;
};

bool cmp(one p1, one p2){
    if(p1.x == p2.x)
        return p1.type < p2.type; // bus - 0
    return p1.x < p2.x;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    ll n;
    cin >> n;
     
    vector<one>bs, st;
    
    for(int i = 0; i < n; i++){
        ll x, rent;
        cin >> x  >> rent;
        
        bs.push_back({x, 0, (ll)-1, rent, 0, (ll)-1});
    }
    
    ll m;
    cin >> m;
    
    
    for(int i = 0; i < m; i++){
        ll x, v;
        cin >> x >> v;
                
        st.push_back({x, (ll)1, v, (ll)-1, (ll)-1, (ll)i});
    }
    
    vector<ll>ans(m, 3 * 1e18);
    
    for(int mask = 0; mask < (1 << n); mask++){
        vector<one>d;
        
        for(int j = 0; j < n; j++)
            if((mask >> j) % 2 != 0)
                d.push_back(bs[j]);
        
       
        for(auto i: st)
            d.push_back(i);
        
        sort(d.begin(), d.end(), cmp);
        
        ll dp = 0, ind = 0;
        
        vector<one>passed;
        bool ok = false;
        
        for(auto i: d){
            if(i.type == 0){
                dp += i.rent;
                passed.push_back(i);
                continue;
            }
            
            if(passed.empty()){
                ok = true;
                break;
            }
            ll cnt = 3 * 1e18;
            
            for(auto j: passed)
                cnt = min(cnt, (i.x - j.x) * i.v);
      
            
            dp += cnt;
            
            ans[ind] = min(ans[ind], dp);
            ind++;
        }
    }
    
    for(auto i: ans)
        cout << i << ' ';
    cout << endl;
    
    return 0;
}
