#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <string>
#include <math.h>
#include <cmath>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <deque>
#include <bitset>
#include <cstring>
#include <unordered_map>

using namespace std;
typedef long long ll;

#define endl '\n'

struct one{
    ll x, type, v, rent, prev, ind;
};

bool cmp(one p1, one p2){
    if(p1.x == p2.x)
        return p1.type < p2.type; // bus - 0
    return p1.x < p2.x;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    ll n;
    cin >> n;
     
    vector<one>a;
    
    for(int i = 0; i < n; i++){
        ll x, rent;
        cin >> x >> rent;
        
        a.push_back({x, 0, (ll)-1, rent, -1, (ll)-1});
    }
    
    ll m;
    cin >> m;
    
    
    for(int i = 0; i < m; i++){
        ll x, v;
        cin >> x >> v;
                
        a.push_back({x, (ll)1, v, (ll)-1, (ll)-1, (ll)i});
    }
    
    sort(a.begin(), a.end(), cmp);
    
    one last = {-1, -1, -1, -1, -1, -1};
    
    for(auto &i: a){
        if(i.type == 1){
            last = i;
            continue;
        }
        
        if(last.x != -1)
            i.prev = last.ind;
    }
    
    vector<ll>dp(m);

    ll ind = 0, st = 0;
    
    for(auto i: a){
        if(i.type == 0){
            ind++;
            continue;
        }
        
        dp[st] = 3 * 1e18;
        
        ll sum = 0, cnt = 0;
        
        for(int j = ind; j >= 0; j--){
            if(j != ind){
                cnt += abs(a[j].x - a[j + 1].x) * sum;
            }
            if(a[j].type == 0){
                ll cnt2 = cnt + a[j].rent;
                if(a[j].prev != -1)
                    cnt2 += dp[a[j].prev];
                            
                dp[st] = min(dp[st], cnt2);
            }
            else{
                sum += a[j].v;
            }
        }
        
        st++;
        ind++;
    }
    
    for(int i = 0; i < m; i++)
        cout << dp[i] << ' ';
    cout << endl;
    
    return 0;
}
