#include <iostream>
#include <cmath>
#include <ctime>
#include <vector>
#include <iomanip>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <deque>
#include <stack>
#include <algorithm>
#include <numeric>
#include <bitset>
#include <list>
#include <forward_list>
#include <tuple>
#include <string>
#include <complex>
#include <random>
#include <array>
#include <sstream>


using namespace std;
#define int long long
#define elif else if
#define endl "\n"
#define mod 1000000007
#define inf 1000'000'000'000'000'000
struct Bus {
    int y;
    int c;
};

struct People {
    int x;
    int v;
};
vector<Bus> buses;
deque<People> peoples;

void solve() {
    int ans = inf;
    for (int i = 0; i <= (1 << (buses.size() + 1)); i++) {
        vector<Bus> connectBusses;
        int x = i;
        int cost = 0;
        int id = 0;
        while (x) {
            if (x % 2 != 0) {
                cost += buses[id].c;
                connectBusses.push_back(buses[id]);
            }
            x = x >> 1;
            id++;
        }
        int p1 = 0, p2 = 0;
        while (p1 != peoples.size() and p2 != connectBusses.size()) {
            if (peoples[p1].x >= connectBusses[p2].y) {
                cost += peoples[p1].v * (peoples[p1].x - connectBusses[p2].y);
                p1++;
            } else {
                p2++;
            }
        }
        if (p1 != peoples.size()) {
            cost = inf;
        }
        ans = min(ans, cost);

    }
    cout << ans << " ";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int N;
    cin >> N;
    Bus bus{};
    for (int i = 0; i < N; ++i) {
        cin >> bus.y >> bus.c;
        buses.push_back(bus);
    }
    reverse(buses.begin(), buses.end());
    int M;
    cin >> M;
    People people{};
    for (int i = 0; i < M; ++i) {
        cin >> people.x >> people.v;
        peoples.push_front(people);
        solve();
    }


}
