#include <iostream>
#include <cmath>
#include <ctime>
#include <vector>
#include <iomanip>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <deque>
#include <stack>
#include <algorithm>
#include <numeric>
#include <bitset>
#include <list>
#include <forward_list>
#include <tuple>
#include <string>
#include <complex>
#include <random>
#include <array>
#include <sstream>


using namespace std;
#define int long long
#define elif else if
#define endl "\n"
#define mod 1000000007
#define inf 1000'000'000'000'000'000
struct Bus {
    int y;
    int c;
};

struct People {
    int x;
    int v;
};
vector<Bus> buses;
deque<People> peoples;
vector<bool> used(100, false);

int minCost = inf;

void get(int pId, int cost) {
    if (pId == peoples.size()) {
        minCost = min(cost, minCost);
        return;
    }
    int bC = cost;
    for (int i = 0; i < buses.size(); i++) {
        if (buses[i].y > peoples[pId].x)
            continue;
        bool flag = false;
        if (!used[i]) {
            flag = true;
            bC += buses[i].c;
            used[i] = true;
        }

        bC += peoples[pId].v * (peoples[pId].x - buses[i].y);
        get(pId + 1, bC);
        if (flag)
            used[i] = false;
        bC = cost;
    }

}

void solve() {
    used.clear();
    used.resize(100, false);
    minCost = inf;
    get(0, 0);
    cout << minCost << " ";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int N;
    cin >> N;
    Bus bus{};
    for (int i = 0; i < N; ++i) {
        cin >> bus.y >> bus.c;
        buses.push_back(bus);
    }
    reverse(buses.begin(), buses.end());
    int M;
    cin >> M;
    People people{};
    for (int i = 0; i < M; ++i) {
        cin >> people.x >> people.v;
        peoples.push_front(people);
        solve();
    }


}
