#include <bits/stdc++.h>
#include "sorting.h"

#define _USE_MATH_DEFINES
#define MULTITEST !true

#define speed ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define inf (1e9)
#define INF (1e18)
#define all(a) a.begin(), a.end()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pii;
typedef vector<ll> vi;
typedef vector<bool> vb;
typedef vector<pii> vp;



vector<int> solve(int N) {
    vector<int> ans(N, -1);
    bool founded = true;
    int nPos = -1, onePos = -1;
    for (int j = 1; j <= N && founded; j++) {
        for (int k = 1; k <= N && founded; k++) {
            if (j != k) {
                if (divisible(j, k, N - 1)) {
                    founded = false;
                    if (compare(j, k)) {
                        ans[j - 1] = 1;
                        ans[k - 1] = N;
                        onePos = j;
                        nPos = k;
                    } else {
                        ans[k - 1] = 1;
                        ans[j - 1] = N;
                        onePos = k;
                        nPos = j;
                    }
                }
            }
        }
    }
    for (int i = 2; i < N; i++) {
        for (int j = 1; j <= N; j++) {
            if (ans[j - 1] == -1) {
                if (divisible(onePos, j, i - 1) &&
                    divisible(nPos, j, N - i)) {
                    ans[j - 1] = i;
                    break;
                }
            }
        }
    }
    for (int i = 0; i < N; i++)
        if (ans[i] == -1)
            ans[i] = (N + 1) / 2;
    return ans;
}
